Module["asm"] =  (function(global, env, buffer) {
  'almost asm';
  
  
  var HEAP8 = new global.Int8Array(buffer);
  var HEAP16 = new global.Int16Array(buffer);
  var HEAP32 = new global.Int32Array(buffer);
  var HEAPU8 = new global.Uint8Array(buffer);
  var HEAPU16 = new global.Uint16Array(buffer);
  var HEAPU32 = new global.Uint32Array(buffer);
  var HEAPF32 = new global.Float32Array(buffer);
  var HEAPF64 = new global.Float64Array(buffer);


  var STACKTOP=env.STACKTOP|0;
  var STACK_MAX=env.STACK_MAX|0;
  var tempDoublePtr=env.tempDoublePtr|0;
  var ABORT=env.ABORT|0;
  var cttz_i8=env.cttz_i8|0;

  var __THREW__ = 0;
  var threwValue = 0;
  var setjmpId = 0;
  var undef = 0;
  var nan = global.NaN, inf = global.Infinity;
  var tempInt = 0, tempBigInt = 0, tempBigIntP = 0, tempBigIntS = 0, tempBigIntR = 0.0, tempBigIntI = 0, tempBigIntD = 0, tempValue = 0, tempDouble = 0.0;
  var tempRet0 = 0;

  var Math_floor=global.Math.floor;
  var Math_abs=global.Math.abs;
  var Math_sqrt=global.Math.sqrt;
  var Math_pow=global.Math.pow;
  var Math_cos=global.Math.cos;
  var Math_sin=global.Math.sin;
  var Math_tan=global.Math.tan;
  var Math_acos=global.Math.acos;
  var Math_asin=global.Math.asin;
  var Math_atan=global.Math.atan;
  var Math_atan2=global.Math.atan2;
  var Math_exp=global.Math.exp;
  var Math_log=global.Math.log;
  var Math_ceil=global.Math.ceil;
  var Math_imul=global.Math.imul;
  var Math_min=global.Math.min;
  var Math_clz32=global.Math.clz32;
  var abort=env.abort;
  var assert=env.assert;
  var abortStackOverflow=env.abortStackOverflow;
  var nullFunc_ii=env.nullFunc_ii;
  var nullFunc_iiii=env.nullFunc_iiii;
  var nullFunc_vi=env.nullFunc_vi;
  var invoke_ii=env.invoke_ii;
  var invoke_iiii=env.invoke_iiii;
  var invoke_vi=env.invoke_vi;
  var __spawn_thread=env.__spawn_thread;
  var _pthread_cleanup_pop=env._pthread_cleanup_pop;
  var _putenv=env._putenv;
  var _emscripten_get_now_is_monotonic=env._emscripten_get_now_is_monotonic;
  var _emscripten_is_main_runtime_thread=env._emscripten_is_main_runtime_thread;
  var _abort=env._abort;
  var ___unlock=env.___unlock;
  var _unsetenv=env._unsetenv;
  var _emscripten_syscall=env._emscripten_syscall;
  var ___assert_fail=env.___assert_fail;
  var _utimes=env._utimes;
  var ___buildEnvironment=env.___buildEnvironment;
  var _clock_gettime=env._clock_gettime;
  var _emscripten_futex_wait=env._emscripten_futex_wait;
  var _tzset=env._tzset;
  var ___setErrNo=env.___setErrNo;
  var _sbrk=env._sbrk;
  var _emscripten_set_current_thread_status_js=env._emscripten_set_current_thread_status_js;
  var _pthread_getschedparam=env._pthread_getschedparam;
  var _emscripten_get_now=env._emscripten_get_now;
  var _clearenv=env._clearenv;
  var _emscripten_asm_const_v=env._emscripten_asm_const_v;
  var _emscripten_futex_wake=env._emscripten_futex_wake;
  var __exit=env.__exit;
  var _utime=env._utime;
  var _emscripten_memcpy_big=env._emscripten_memcpy_big;
  var _exit=env._exit;
  var _confstr=env._confstr;
  var _pthread_self=env._pthread_self;
  var _pthread_join=env._pthread_join;
  var _getenv=env._getenv;
  var _pthread_exit=env._pthread_exit;
  var ___syscall54=env.___syscall54;
  var _emscripten_has_threading_support=env._emscripten_has_threading_support;
  var _pthread_create=env._pthread_create;
  var __register_pthread_ptr=env.__register_pthread_ptr;
  var _emscripten_asm_const_iii=env._emscripten_asm_const_iii;
  var _chroot=env._chroot;
  var _emscripten_asm_const_iiii=env._emscripten_asm_const_iiii;
  var __pthread_testcancel_js=env.__pthread_testcancel_js;
  var ___lock=env.___lock;
  var ___syscall6=env.___syscall6;
  var _pthread_cleanup_push=env._pthread_cleanup_push;
  var _sysconf=env._sysconf;
  var __cleanup_thread=env.__cleanup_thread;
  var _gettimeofday=env._gettimeofday;
  var _atexit=env._atexit;
  var ___syscall140=env.___syscall140;
  var _fpathconf=env._fpathconf;
  var _setenv=env._setenv;
  var ___syscall146=env.___syscall146;
  var _emscripten_conditional_set_current_thread_status_js=env._emscripten_conditional_set_current_thread_status_js;
  var Atomics_load=global.Atomics.load;
  var Atomics_store=global.Atomics.store;
  var Atomics_exchange=global.Atomics.exchange;
  var Atomics_compareExchange=global.Atomics.compareExchange;
  var Atomics_add=global.Atomics.add;
  var Atomics_sub=global.Atomics.sub;
  var Atomics_and=global.Atomics.and;
  var Atomics_or=global.Atomics.or;
  var Atomics_xor=global.Atomics.xor;
  var tempFloat = 0.0;

// EMSCRIPTEN_START_FUNCS

function stackAlloc(size) {
  size = size|0;
  var ret = 0;
  ret = STACKTOP;
  STACKTOP = (STACKTOP + size)|0;
  STACKTOP = (STACKTOP + 15)&-16;
  if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(size|0);

  return ret|0;
}
function stackSave() {
  return STACKTOP|0;
}
function stackRestore(top) {
  top = top|0;
  STACKTOP = top;
}
function establishStackSpace(stackBase, stackMax) {
  stackBase = stackBase|0;
  stackMax = stackMax|0;
  STACKTOP = stackBase;
  STACK_MAX = stackMax;
}

function setThrew(threw, value) {
  threw = threw|0;
  value = value|0;
  if ((__THREW__|0) == 0) {
    __THREW__ = threw;
    threwValue = value;
  }
}

function setTempRet0(value) {
  value = value|0;
  tempRet0 = value;
}
function getTempRet0() {
  return tempRet0|0;
}

function __Z10ThreadMainPv($arg) {
 $arg = $arg|0;
 var $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $7 = 0, $8 = 0, $9 = 0, $i = 0, $i1 = 0, $i2 = 0, $idx = 0, $j = 0, $n = 0, $numGood = 0, $param = 0, $t = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 448|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $n = sp + 24|0;
 $0 = $arg;
 $1 = $0;
 $2 = $1;
 $idx = $2;
 $3 = $idx;
 $4 = (3556 + ($3<<2)|0);
 $5 = HEAP32[$4>>2]|0;
 $param = $5;
 $6 = $idx;
 $7 = $param;
 $8 = _emscripten_asm_const_iiii(0, ($6|0), 100, ($7|0))|0;
 $i = 0;
 while(1) {
  $9 = $i;
  $10 = ($9>>>0)<(100);
  if (!($10)) {
   break;
  }
  $11 = $i;
  $12 = $param;
  $13 = (($11) + ($12))|0;
  $14 = (($13>>>0) % 100)&-1;
  $15 = $i;
  $16 = (($n) + ($15<<2)|0);
  HEAP32[$16>>2] = $14;
  $17 = $i;
  $18 = (($17) + 1)|0;
  $i = $18;
 }
 $i1 = 0;
 while(1) {
  $19 = $i1;
  $20 = ($19>>>0)<(100);
  if (!($20)) {
   break;
  }
  $21 = $i1;
  $j = $21;
  while(1) {
   $22 = $j;
   $23 = ($22>>>0)<(100);
   $24 = $i1;
   if (!($23)) {
    break;
   }
   $25 = (($n) + ($24<<2)|0);
   $26 = HEAP32[$25>>2]|0;
   $27 = $j;
   $28 = (($n) + ($27<<2)|0);
   $29 = HEAP32[$28>>2]|0;
   $30 = ($26>>>0)>($29>>>0);
   if ($30) {
    $31 = $i1;
    $32 = (($n) + ($31<<2)|0);
    $33 = HEAP32[$32>>2]|0;
    $t = $33;
    $34 = $j;
    $35 = (($n) + ($34<<2)|0);
    $36 = HEAP32[$35>>2]|0;
    $37 = $i1;
    $38 = (($n) + ($37<<2)|0);
    HEAP32[$38>>2] = $36;
    $39 = $t;
    $40 = $j;
    $41 = (($n) + ($40<<2)|0);
    HEAP32[$41>>2] = $39;
   }
   $42 = $j;
   $43 = (($42) + 1)|0;
   $j = $43;
  }
  $44 = (($24) + 1)|0;
  $i1 = $44;
 }
 $numGood = 0;
 $i2 = 0;
 while(1) {
  $45 = $i2;
  $46 = ($45>>>0)<(100);
  if (!($46)) {
   break;
  }
  $47 = $i2;
  $48 = (($n) + ($47<<2)|0);
  $49 = HEAP32[$48>>2]|0;
  $50 = $i2;
  $51 = ($49|0)==($50|0);
  if ($51) {
   $52 = $numGood;
   $53 = (($52) + 1)|0;
   $numGood = $53;
  } else {
   $54 = $i2;
   $55 = $i2;
   $56 = (($n) + ($55<<2)|0);
   $57 = HEAP32[$56>>2]|0;
   $58 = _emscripten_asm_const_iii(1, ($54|0), ($57|0))|0;
  }
  $59 = $i2;
  $60 = (($59) + 1)|0;
  $i2 = $60;
 }
 $61 = $idx;
 $62 = $param;
 $63 = $numGood;
 $64 = _emscripten_asm_const_iiii(2, ($61|0), ($62|0), ($63|0))|0;
 $65 = $numGood;
 $66 = $65;
 _pthread_exit(($66|0));
 // unreachable;
 return (0)|0;
}
function __Z12CreateThreadi($i) {
 $i = $i|0;
 var $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $attr = 0, $rc = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $attr = sp + 4|0;
 $0 = $i;
 (_pthread_attr_init($attr)|0);
 (_pthread_attr_setdetachstate($attr,0)|0);
 $1 = HEAP32[3]|0;
 $2 = (($1) + 1)|0;
 HEAP32[3] = $2;
 $3 = Math_imul($1, 12141231)|0;
 $4 = $3 & 2147483647;
 $5 = $0;
 $6 = (3556 + ($5<<2)|0);
 HEAP32[$6>>2] = $4;
 $7 = $0;
 $8 = (3588 + ($7<<2)|0);
 $9 = $0;
 $10 = $9;
 $11 = (_pthread_create(($8|0),($attr|0),(5|0),($10|0))|0);
 $rc = $11;
 $12 = $rc;
 $13 = ($12|0)==(0);
 if ($13) {
  STACKTOP = sp;return;
 } else {
  ___assert_fail((478|0),(486|0),66,(524|0));
  // unreachable;
 }
}
function _main() {
 var $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $i = 0, $i1 = 0;
 var $rc = 0, $result = 0, $status = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $vararg_buffer = sp;
 $status = sp + 8|0;
 $0 = 0;
 $result = 0;
 $1 = (_emscripten_has_threading_support()|0);
 $2 = ($1|0)!=(0);
 if (!($2)) {
  (_printf(537,$vararg_buffer)|0);
  $0 = 0;
  $37 = $0;
  STACKTOP = sp;return ($37|0);
 }
 $i = 0;
 while(1) {
  $3 = $i;
  $4 = ($3|0)<(8);
  if (!($4)) {
   break;
  }
  $5 = $i;
  __Z12CreateThreadi($5);
  $6 = $i;
  $7 = (($6) + 1)|0;
  $i = $7;
 }
 $i1 = 0;
 while(1) {
  $8 = $i1;
  $9 = ($8|0)<(8);
  if (!($9)) {
   label = 16;
   break;
  }
  $10 = $i1;
  $11 = (3588 + ($10<<2)|0);
  $12 = HEAP32[$11>>2]|0;
  $13 = ($12|0)!=(0);
  if ($13) {
   $14 = $i1;
   $15 = (3588 + ($14<<2)|0);
   $16 = HEAP32[$15>>2]|0;
   $17 = (_pthread_join(($16|0),($status|0))|0);
   $rc = $17;
   $18 = $rc;
   $19 = ($18|0)==(0);
   if (!($19)) {
    label = 10;
    break;
   }
   $20 = $i1;
   $21 = $i1;
   $22 = (3556 + ($21<<2)|0);
   $23 = HEAP32[$22>>2]|0;
   $24 = HEAP32[$status>>2]|0;
   $25 = _emscripten_asm_const_iiii(3, ($20|0), ($23|0), ($24|0))|0;
   $26 = HEAP32[$status>>2]|0;
   $27 = ($26|0)==(100);
   if (!($27)) {
    label = 12;
    break;
   }
   $28 = $i1;
   $29 = (3588 + ($28<<2)|0);
   HEAP32[$29>>2] = 0;
   $30 = HEAP32[2]|0;
   $31 = ($30|0)>(0);
   if ($31) {
    $32 = HEAP32[2]|0;
    $33 = (($32) + -1)|0;
    HEAP32[2] = $33;
    $34 = $i1;
    __Z12CreateThreadi($34);
   }
  }
  $35 = $i1;
  $36 = (($35) + 1)|0;
  $i1 = $36;
 }
 if ((label|0) == 10) {
  ___assert_fail((478|0),(486|0),94,(575|0));
  // unreachable;
 }
 else if ((label|0) == 12) {
  ___assert_fail((679|0),(486|0),96,(575|0));
  // unreachable;
 }
 else if ((label|0) == 16) {
  $37 = $0;
  STACKTOP = sp;return ($37|0);
 }
 return (0)|0;
}
function ___stdio_close($f) {
 $f = $f|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $vararg_buffer = sp;
 $0 = ((($f)) + 60|0);
 $1 = HEAP32[$0>>2]|0;
 HEAP32[$vararg_buffer>>2] = $1;
 $2 = (___syscall6(6,($vararg_buffer|0))|0);
 $3 = (___syscall_ret($2)|0);
 STACKTOP = sp;return ($3|0);
}
function ___syscall_ret($r) {
 $r = $r|0;
 var $$0 = 0, $0 = 0, $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = ($r>>>0)>(4294963200);
 if ($0) {
  $1 = (0 - ($r))|0;
  $2 = (___errno_location()|0);
  HEAP32[$2>>2] = $1;
  $$0 = -1;
 } else {
  $$0 = $r;
 }
 return ($$0|0);
}
function ___errno_location() {
 var $$0 = 0, $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[905]|0;
 $1 = ($0|0)==(0|0);
 if ($1) {
  $$0 = 3664;
 } else {
  $2 = (_pthread_self()|0);
  $3 = ((($2)) + 64|0);
  $4 = HEAP32[$3>>2]|0;
  $$0 = $4;
 }
 return ($$0|0);
}
function ___stdio_write($f,$buf,$len) {
 $f = $f|0;
 $buf = $buf|0;
 $len = $len|0;
 var $$0 = 0, $$phi$trans$insert = 0, $$pre = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0;
 var $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cnt$0 = 0, $cnt$1 = 0, $iov$0 = 0, $iov$0$lcssa11 = 0, $iov$1 = 0, $iovcnt$0 = 0, $iovcnt$0$lcssa12 = 0;
 var $iovcnt$1 = 0, $iovs = 0, $rem$0 = 0, $vararg_buffer = 0, $vararg_buffer3 = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr6 = 0, $vararg_ptr7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer = sp;
 $iovs = sp + 32|0;
 $0 = ((($f)) + 28|0);
 $1 = HEAP32[$0>>2]|0;
 HEAP32[$iovs>>2] = $1;
 $2 = ((($iovs)) + 4|0);
 $3 = ((($f)) + 20|0);
 $4 = HEAP32[$3>>2]|0;
 $5 = (($4) - ($1))|0;
 HEAP32[$2>>2] = $5;
 $6 = ((($iovs)) + 8|0);
 HEAP32[$6>>2] = $buf;
 $7 = ((($iovs)) + 12|0);
 HEAP32[$7>>2] = $len;
 $8 = (($5) + ($len))|0;
 $9 = ((($f)) + 60|0);
 $10 = ((($f)) + 44|0);
 $iov$0 = $iovs;$iovcnt$0 = 2;$rem$0 = $8;
 while(1) {
  $11 = HEAP32[905]|0;
  $12 = ($11|0)==(0|0);
  if ($12) {
   $16 = HEAP32[$9>>2]|0;
   HEAP32[$vararg_buffer3>>2] = $16;
   $vararg_ptr6 = ((($vararg_buffer3)) + 4|0);
   HEAP32[$vararg_ptr6>>2] = $iov$0;
   $vararg_ptr7 = ((($vararg_buffer3)) + 8|0);
   HEAP32[$vararg_ptr7>>2] = $iovcnt$0;
   $17 = (___syscall146(146,($vararg_buffer3|0))|0);
   $18 = (___syscall_ret($17)|0);
   $cnt$0 = $18;
  } else {
   _pthread_cleanup_push((6|0),($f|0));
   $13 = HEAP32[$9>>2]|0;
   HEAP32[$vararg_buffer>>2] = $13;
   $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
   HEAP32[$vararg_ptr1>>2] = $iov$0;
   $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
   HEAP32[$vararg_ptr2>>2] = $iovcnt$0;
   $14 = (___syscall146(146,($vararg_buffer|0))|0);
   $15 = (___syscall_ret($14)|0);
   _pthread_cleanup_pop(0);
   $cnt$0 = $15;
  }
  $19 = ($rem$0|0)==($cnt$0|0);
  if ($19) {
   label = 6;
   break;
  }
  $26 = ($cnt$0|0)<(0);
  if ($26) {
   $iov$0$lcssa11 = $iov$0;$iovcnt$0$lcssa12 = $iovcnt$0;
   label = 8;
   break;
  }
  $34 = (($rem$0) - ($cnt$0))|0;
  $35 = ((($iov$0)) + 4|0);
  $36 = HEAP32[$35>>2]|0;
  $37 = ($cnt$0>>>0)>($36>>>0);
  if ($37) {
   $38 = HEAP32[$10>>2]|0;
   HEAP32[$0>>2] = $38;
   HEAP32[$3>>2] = $38;
   $39 = (($cnt$0) - ($36))|0;
   $40 = ((($iov$0)) + 8|0);
   $41 = (($iovcnt$0) + -1)|0;
   $$phi$trans$insert = ((($iov$0)) + 12|0);
   $$pre = HEAP32[$$phi$trans$insert>>2]|0;
   $49 = $$pre;$cnt$1 = $39;$iov$1 = $40;$iovcnt$1 = $41;
  } else {
   $42 = ($iovcnt$0|0)==(2);
   if ($42) {
    $43 = HEAP32[$0>>2]|0;
    $44 = (($43) + ($cnt$0)|0);
    HEAP32[$0>>2] = $44;
    $49 = $36;$cnt$1 = $cnt$0;$iov$1 = $iov$0;$iovcnt$1 = 2;
   } else {
    $49 = $36;$cnt$1 = $cnt$0;$iov$1 = $iov$0;$iovcnt$1 = $iovcnt$0;
   }
  }
  $45 = HEAP32[$iov$1>>2]|0;
  $46 = (($45) + ($cnt$1)|0);
  HEAP32[$iov$1>>2] = $46;
  $47 = ((($iov$1)) + 4|0);
  $48 = (($49) - ($cnt$1))|0;
  HEAP32[$47>>2] = $48;
  $iov$0 = $iov$1;$iovcnt$0 = $iovcnt$1;$rem$0 = $34;
 }
 if ((label|0) == 6) {
  $20 = HEAP32[$10>>2]|0;
  $21 = ((($f)) + 48|0);
  $22 = HEAP32[$21>>2]|0;
  $23 = (($20) + ($22)|0);
  $24 = ((($f)) + 16|0);
  HEAP32[$24>>2] = $23;
  $25 = $20;
  HEAP32[$0>>2] = $25;
  HEAP32[$3>>2] = $25;
  $$0 = $len;
 }
 else if ((label|0) == 8) {
  $27 = ((($f)) + 16|0);
  HEAP32[$27>>2] = 0;
  HEAP32[$0>>2] = 0;
  HEAP32[$3>>2] = 0;
  $28 = HEAP32[$f>>2]|0;
  $29 = $28 | 32;
  HEAP32[$f>>2] = $29;
  $30 = ($iovcnt$0$lcssa12|0)==(2);
  if ($30) {
   $$0 = 0;
  } else {
   $31 = ((($iov$0$lcssa11)) + 4|0);
   $32 = HEAP32[$31>>2]|0;
   $33 = (($len) - ($32))|0;
   $$0 = $33;
  }
 }
 STACKTOP = sp;return ($$0|0);
}
function _cleanup_387($p) {
 $p = $p|0;
 var $0 = 0, $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = ((($p)) + 68|0);
 $1 = HEAP32[$0>>2]|0;
 $2 = ($1|0)==(0);
 if ($2) {
  ___unlockfile($p);
 }
 return;
}
function ___unlockfile($f) {
 $f = $f|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return;
}
function ___stdio_seek($f,$off,$whence) {
 $f = $f|0;
 $off = $off|0;
 $whence = $whence|0;
 var $$pre = 0, $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $ret = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr3 = 0, $vararg_ptr4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $vararg_buffer = sp;
 $ret = sp + 20|0;
 $0 = ((($f)) + 60|0);
 $1 = HEAP32[$0>>2]|0;
 HEAP32[$vararg_buffer>>2] = $1;
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 HEAP32[$vararg_ptr1>>2] = 0;
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
 HEAP32[$vararg_ptr2>>2] = $off;
 $vararg_ptr3 = ((($vararg_buffer)) + 12|0);
 HEAP32[$vararg_ptr3>>2] = $ret;
 $vararg_ptr4 = ((($vararg_buffer)) + 16|0);
 HEAP32[$vararg_ptr4>>2] = $whence;
 $2 = (___syscall140(140,($vararg_buffer|0))|0);
 $3 = (___syscall_ret($2)|0);
 $4 = ($3|0)<(0);
 if ($4) {
  HEAP32[$ret>>2] = -1;
  $5 = -1;
 } else {
  $$pre = HEAP32[$ret>>2]|0;
  $5 = $$pre;
 }
 STACKTOP = sp;return ($5|0);
}
function ___stdout_write($f,$buf,$len) {
 $f = $f|0;
 $buf = $buf|0;
 $len = $len|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $tio = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $vararg_buffer = sp;
 $tio = sp + 12|0;
 $0 = ((($f)) + 36|0);
 HEAP32[$0>>2] = 7;
 $1 = HEAP32[$f>>2]|0;
 $2 = $1 & 64;
 $3 = ($2|0)==(0);
 if ($3) {
  $4 = ((($f)) + 60|0);
  $5 = HEAP32[$4>>2]|0;
  HEAP32[$vararg_buffer>>2] = $5;
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
  HEAP32[$vararg_ptr1>>2] = 21505;
  $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
  HEAP32[$vararg_ptr2>>2] = $tio;
  $6 = (___syscall54(54,($vararg_buffer|0))|0);
  $7 = ($6|0)==(0);
  if (!($7)) {
   $8 = ((($f)) + 75|0);
   HEAP8[$8>>0] = -1;
  }
 }
 $9 = (___stdio_write($f,$buf,$len)|0);
 STACKTOP = sp;return ($9|0);
}
function _memchr($src,$c,$n) {
 $src = $src|0;
 $c = $c|0;
 $n = $n|0;
 var $$0$lcssa = 0, $$0$lcssa30 = 0, $$019 = 0, $$1$lcssa = 0, $$110 = 0, $$110$lcssa = 0, $$24 = 0, $$3 = 0, $$lcssa = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0;
 var $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0;
 var $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $or$cond18 = 0, $s$0$lcssa = 0, $s$0$lcssa29 = 0, $s$020 = 0, $s$15 = 0, $s$2 = 0, $w$0$lcssa = 0, $w$011 = 0, $w$011$lcssa = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = $c & 255;
 $1 = $src;
 $2 = $1 & 3;
 $3 = ($2|0)!=(0);
 $4 = ($n|0)!=(0);
 $or$cond18 = $4 & $3;
 L1: do {
  if ($or$cond18) {
   $5 = $c&255;
   $$019 = $n;$s$020 = $src;
   while(1) {
    $6 = HEAP8[$s$020>>0]|0;
    $7 = ($6<<24>>24)==($5<<24>>24);
    if ($7) {
     $$0$lcssa30 = $$019;$s$0$lcssa29 = $s$020;
     label = 6;
     break L1;
    }
    $8 = ((($s$020)) + 1|0);
    $9 = (($$019) + -1)|0;
    $10 = $8;
    $11 = $10 & 3;
    $12 = ($11|0)!=(0);
    $13 = ($9|0)!=(0);
    $or$cond = $13 & $12;
    if ($or$cond) {
     $$019 = $9;$s$020 = $8;
    } else {
     $$0$lcssa = $9;$$lcssa = $13;$s$0$lcssa = $8;
     label = 5;
     break;
    }
   }
  } else {
   $$0$lcssa = $n;$$lcssa = $4;$s$0$lcssa = $src;
   label = 5;
  }
 } while(0);
 if ((label|0) == 5) {
  if ($$lcssa) {
   $$0$lcssa30 = $$0$lcssa;$s$0$lcssa29 = $s$0$lcssa;
   label = 6;
  } else {
   $$3 = 0;$s$2 = $s$0$lcssa;
  }
 }
 L8: do {
  if ((label|0) == 6) {
   $14 = HEAP8[$s$0$lcssa29>>0]|0;
   $15 = $c&255;
   $16 = ($14<<24>>24)==($15<<24>>24);
   if ($16) {
    $$3 = $$0$lcssa30;$s$2 = $s$0$lcssa29;
   } else {
    $17 = Math_imul($0, 16843009)|0;
    $18 = ($$0$lcssa30>>>0)>(3);
    L11: do {
     if ($18) {
      $$110 = $$0$lcssa30;$w$011 = $s$0$lcssa29;
      while(1) {
       $19 = HEAP32[$w$011>>2]|0;
       $20 = $19 ^ $17;
       $21 = (($20) + -16843009)|0;
       $22 = $20 & -2139062144;
       $23 = $22 ^ -2139062144;
       $24 = $23 & $21;
       $25 = ($24|0)==(0);
       if (!($25)) {
        $$110$lcssa = $$110;$w$011$lcssa = $w$011;
        break;
       }
       $26 = ((($w$011)) + 4|0);
       $27 = (($$110) + -4)|0;
       $28 = ($27>>>0)>(3);
       if ($28) {
        $$110 = $27;$w$011 = $26;
       } else {
        $$1$lcssa = $27;$w$0$lcssa = $26;
        label = 11;
        break L11;
       }
      }
      $$24 = $$110$lcssa;$s$15 = $w$011$lcssa;
     } else {
      $$1$lcssa = $$0$lcssa30;$w$0$lcssa = $s$0$lcssa29;
      label = 11;
     }
    } while(0);
    if ((label|0) == 11) {
     $29 = ($$1$lcssa|0)==(0);
     if ($29) {
      $$3 = 0;$s$2 = $w$0$lcssa;
      break;
     } else {
      $$24 = $$1$lcssa;$s$15 = $w$0$lcssa;
     }
    }
    while(1) {
     $30 = HEAP8[$s$15>>0]|0;
     $31 = ($30<<24>>24)==($15<<24>>24);
     if ($31) {
      $$3 = $$24;$s$2 = $s$15;
      break L8;
     }
     $32 = ((($s$15)) + 1|0);
     $33 = (($$24) + -1)|0;
     $34 = ($33|0)==(0);
     if ($34) {
      $$3 = 0;$s$2 = $32;
      break;
     } else {
      $$24 = $33;$s$15 = $32;
     }
    }
   }
  }
 } while(0);
 $35 = ($$3|0)!=(0);
 $36 = $35 ? $s$2 : 0;
 return ($36|0);
}
function _vsnprintf($s,$n,$fmt,$ap) {
 $s = $s|0;
 $n = $n|0;
 $fmt = $fmt|0;
 $ap = $ap|0;
 var $$$02 = 0, $$0 = 0, $$01 = 0, $$02 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0;
 var $6 = 0, $7 = 0, $8 = 0, $9 = 0, $b = 0, $f = 0, dest = 0, label = 0, sp = 0, src = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 128|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $b = sp + 112|0;
 $f = sp;
 dest=$f; src=136; stop=dest+112|0; do { HEAP32[dest>>2]=HEAP32[src>>2]|0; dest=dest+4|0; src=src+4|0; } while ((dest|0) < (stop|0));
 $0 = (($n) + -1)|0;
 $1 = ($0>>>0)>(2147483646);
 if ($1) {
  $2 = ($n|0)==(0);
  if ($2) {
   $$01 = $b;$$02 = 1;
   label = 4;
  } else {
   $3 = (___errno_location()|0);
   HEAP32[$3>>2] = 75;
   $$0 = -1;
  }
 } else {
  $$01 = $s;$$02 = $n;
  label = 4;
 }
 if ((label|0) == 4) {
  $4 = $$01;
  $5 = (-2 - ($4))|0;
  $6 = ($$02>>>0)>($5>>>0);
  $$$02 = $6 ? $5 : $$02;
  $7 = ((($f)) + 48|0);
  HEAP32[$7>>2] = $$$02;
  $8 = ((($f)) + 20|0);
  HEAP32[$8>>2] = $$01;
  $9 = ((($f)) + 44|0);
  HEAP32[$9>>2] = $$01;
  $10 = (($$01) + ($$$02)|0);
  $11 = ((($f)) + 16|0);
  HEAP32[$11>>2] = $10;
  $12 = ((($f)) + 28|0);
  HEAP32[$12>>2] = $10;
  $13 = (_vfprintf($f,$fmt,$ap)|0);
  $14 = ($$$02|0)==(0);
  if ($14) {
   $$0 = $13;
  } else {
   $15 = HEAP32[$8>>2]|0;
   $16 = HEAP32[$11>>2]|0;
   $17 = ($15|0)==($16|0);
   $18 = $17 << 31 >> 31;
   $19 = (($15) + ($18)|0);
   HEAP8[$19>>0] = 0;
   $$0 = $13;
  }
 }
 STACKTOP = sp;return ($$0|0);
}
function _sn_write($f,$s,$l) {
 $f = $f|0;
 $s = $s|0;
 $l = $l|0;
 var $$cast = 0, $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $l$ = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = ((($f)) + 16|0);
 $1 = HEAP32[$0>>2]|0;
 $2 = ((($f)) + 20|0);
 $3 = HEAP32[$2>>2]|0;
 $4 = (($1) - ($3))|0;
 $5 = ($4>>>0)>($l>>>0);
 $l$ = $5 ? $l : $4;
 $$cast = $3;
 _memcpy(($$cast|0),($s|0),($l$|0))|0;
 $6 = HEAP32[$2>>2]|0;
 $7 = (($6) + ($l$)|0);
 HEAP32[$2>>2] = $7;
 return ($l|0);
}
function _vfprintf($f,$fmt,$ap) {
 $f = $f|0;
 $fmt = $fmt|0;
 $ap = $ap|0;
 var $$ = 0, $$0 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $ap2 = 0, $internal_buf = 0, $nl_arg = 0, $nl_type = 0;
 var $ret$1 = 0, $ret$1$ = 0, $vacopy_currentptr = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 224|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $ap2 = sp + 120|0;
 $nl_type = sp + 80|0;
 $nl_arg = sp;
 $internal_buf = sp + 136|0;
 dest=$nl_type; stop=dest+40|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0));
 $vacopy_currentptr = HEAP32[$ap>>2]|0;
 HEAP32[$ap2>>2] = $vacopy_currentptr;
 $0 = (_printf_core(0,$fmt,$ap2,$nl_arg,$nl_type)|0);
 $1 = ($0|0)<(0);
 if ($1) {
  $$0 = -1;
 } else {
  $2 = ((($f)) + 76|0);
  $3 = HEAP32[$2>>2]|0;
  $4 = ($3|0)>(-1);
  if ($4) {
   $5 = (___lockfile($f)|0);
   $33 = $5;
  } else {
   $33 = 0;
  }
  $6 = HEAP32[$f>>2]|0;
  $7 = $6 & 32;
  $8 = ((($f)) + 74|0);
  $9 = HEAP8[$8>>0]|0;
  $10 = ($9<<24>>24)<(1);
  if ($10) {
   $11 = $6 & -33;
   HEAP32[$f>>2] = $11;
  }
  $12 = ((($f)) + 48|0);
  $13 = HEAP32[$12>>2]|0;
  $14 = ($13|0)==(0);
  if ($14) {
   $16 = ((($f)) + 44|0);
   $17 = HEAP32[$16>>2]|0;
   HEAP32[$16>>2] = $internal_buf;
   $18 = ((($f)) + 28|0);
   HEAP32[$18>>2] = $internal_buf;
   $19 = ((($f)) + 20|0);
   HEAP32[$19>>2] = $internal_buf;
   HEAP32[$12>>2] = 80;
   $20 = ((($internal_buf)) + 80|0);
   $21 = ((($f)) + 16|0);
   HEAP32[$21>>2] = $20;
   $22 = (_printf_core($f,$fmt,$ap2,$nl_arg,$nl_type)|0);
   $23 = ($17|0)==(0|0);
   if ($23) {
    $ret$1 = $22;
   } else {
    $24 = ((($f)) + 36|0);
    $25 = HEAP32[$24>>2]|0;
    (FUNCTION_TABLE_iiii[$25 & 7]($f,0,0)|0);
    $26 = HEAP32[$19>>2]|0;
    $27 = ($26|0)==(0|0);
    $$ = $27 ? -1 : $22;
    HEAP32[$16>>2] = $17;
    HEAP32[$12>>2] = 0;
    HEAP32[$21>>2] = 0;
    HEAP32[$18>>2] = 0;
    HEAP32[$19>>2] = 0;
    $ret$1 = $$;
   }
  } else {
   $15 = (_printf_core($f,$fmt,$ap2,$nl_arg,$nl_type)|0);
   $ret$1 = $15;
  }
  $28 = HEAP32[$f>>2]|0;
  $29 = $28 & 32;
  $30 = ($29|0)==(0);
  $ret$1$ = $30 ? $ret$1 : -1;
  $31 = $28 | $7;
  HEAP32[$f>>2] = $31;
  $32 = ($33|0)==(0);
  if (!($32)) {
   ___unlockfile($f);
  }
  $$0 = $ret$1$;
 }
 STACKTOP = sp;return ($$0|0);
}
function _printf_core($f,$fmt,$ap,$nl_arg,$nl_type) {
 $f = $f|0;
 $fmt = $fmt|0;
 $ap = $ap|0;
 $nl_arg = $nl_arg|0;
 $nl_type = $nl_type|0;
 var $$ = 0, $$$i = 0, $$0 = 0, $$0$i = 0, $$0$lcssa$i = 0, $$012$i = 0, $$013$i = 0, $$03$i33 = 0, $$07$i = 0.0, $$1$i = 0.0, $$114$i = 0, $$2$i = 0.0, $$20$i = 0.0, $$210$$24$i = 0, $$210$$26$i = 0, $$210$i = 0, $$23$i = 0, $$25$i = 0, $$3$i = 0.0, $$311$i = 0;
 var $$33$i = 0, $$36$i = 0.0, $$4$i = 0.0, $$412$lcssa$i = 0, $$41278$i = 0, $$43 = 0, $$5$lcssa$i = 0, $$589$i = 0, $$a$3$i = 0, $$a$3191$i = 0, $$a$3192$i = 0, $$fl$4 = 0, $$l10n$0 = 0, $$lcssa = 0, $$lcssa162$i = 0, $$lcssa295 = 0, $$lcssa300 = 0, $$lcssa301 = 0, $$lcssa302 = 0, $$lcssa303 = 0;
 var $$lcssa304 = 0, $$lcssa306 = 0, $$lcssa316 = 0, $$lcssa319 = 0.0, $$lcssa321 = 0, $$neg55$i = 0, $$neg56$i = 0, $$p$$i = 0, $$p$5 = 0, $$p$i = 0, $$pn$i = 0, $$pr$i = 0, $$pr50$i = 0, $$pre = 0, $$pre$i = 0, $$pre$phi190$iZ2D = 0, $$pre170 = 0, $$pre171 = 0, $$pre185$i = 0, $$pre188$i = 0;
 var $$pre189$i = 0, $$z$3$i = 0, $$z$4$i = 0, $0 = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0;
 var $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0;
 var $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0;
 var $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0;
 var $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0;
 var $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0;
 var $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0;
 var $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0;
 var $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0;
 var $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0;
 var $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0;
 var $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0;
 var $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0;
 var $33 = 0, $330 = 0, $331 = 0, $332 = 0, $333 = 0, $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0;
 var $348 = 0, $349 = 0, $35 = 0, $350 = 0, $351 = 0, $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0.0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0.0, $363 = 0, $364 = 0, $365 = 0;
 var $366 = 0, $367 = 0, $368 = 0, $369 = 0, $37 = 0, $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0, $380 = 0, $381 = 0, $382 = 0, $383 = 0;
 var $384 = 0, $385 = 0, $386 = 0, $387 = 0, $388 = 0, $389 = 0, $39 = 0, $390 = 0.0, $391 = 0.0, $392 = 0, $393 = 0, $394 = 0, $395 = 0, $396 = 0, $397 = 0, $398 = 0, $399 = 0, $4 = 0, $40 = 0, $400 = 0;
 var $401 = 0, $402 = 0, $403 = 0, $404 = 0, $405 = 0, $406 = 0.0, $407 = 0, $408 = 0, $409 = 0, $41 = 0, $410 = 0.0, $411 = 0.0, $412 = 0.0, $413 = 0.0, $414 = 0.0, $415 = 0.0, $416 = 0, $417 = 0, $418 = 0, $419 = 0;
 var $42 = 0, $420 = 0, $421 = 0, $422 = 0, $423 = 0, $424 = 0, $425 = 0, $426 = 0, $427 = 0, $428 = 0, $429 = 0, $43 = 0, $430 = 0, $431 = 0, $432 = 0, $433 = 0, $434 = 0, $435 = 0, $436 = 0, $437 = 0;
 var $438 = 0, $439 = 0, $44 = 0, $440 = 0, $441 = 0.0, $442 = 0.0, $443 = 0.0, $444 = 0, $445 = 0, $446 = 0, $447 = 0, $448 = 0, $449 = 0, $45 = 0, $450 = 0, $451 = 0, $452 = 0, $453 = 0, $454 = 0, $455 = 0;
 var $456 = 0, $457 = 0, $458 = 0, $459 = 0, $46 = 0, $460 = 0, $461 = 0, $462 = 0, $463 = 0, $464 = 0, $465 = 0, $466 = 0, $467 = 0, $468 = 0, $469 = 0, $47 = 0, $470 = 0, $471 = 0, $472 = 0, $473 = 0;
 var $474 = 0.0, $475 = 0, $476 = 0, $477 = 0, $478 = 0, $479 = 0, $48 = 0, $480 = 0, $481 = 0, $482 = 0.0, $483 = 0.0, $484 = 0.0, $485 = 0, $486 = 0, $487 = 0, $488 = 0, $489 = 0, $49 = 0, $490 = 0, $491 = 0;
 var $492 = 0, $493 = 0, $494 = 0, $495 = 0, $496 = 0, $497 = 0, $498 = 0, $499 = 0, $5 = 0, $50 = 0, $500 = 0, $501 = 0, $502 = 0, $503 = 0, $504 = 0, $505 = 0, $506 = 0, $507 = 0, $508 = 0, $509 = 0;
 var $51 = 0, $510 = 0, $511 = 0, $512 = 0, $513 = 0, $514 = 0, $515 = 0, $516 = 0, $517 = 0, $518 = 0, $519 = 0, $52 = 0, $520 = 0, $521 = 0, $522 = 0, $523 = 0, $524 = 0, $525 = 0, $526 = 0, $527 = 0;
 var $528 = 0, $529 = 0, $53 = 0, $530 = 0, $531 = 0, $532 = 0, $533 = 0, $534 = 0, $535 = 0, $536 = 0, $537 = 0, $538 = 0, $539 = 0, $54 = 0, $540 = 0, $541 = 0, $542 = 0, $543 = 0, $544 = 0, $545 = 0;
 var $546 = 0, $547 = 0, $548 = 0, $549 = 0, $55 = 0, $550 = 0, $551 = 0, $552 = 0, $553 = 0, $554 = 0, $555 = 0, $556 = 0, $557 = 0, $558 = 0, $559 = 0, $56 = 0, $560 = 0, $561 = 0, $562 = 0, $563 = 0;
 var $564 = 0, $565 = 0, $566 = 0, $567 = 0, $568 = 0, $569 = 0, $57 = 0, $570 = 0, $571 = 0, $572 = 0, $573 = 0, $574 = 0, $575 = 0, $576 = 0, $577 = 0, $578 = 0, $579 = 0, $58 = 0, $580 = 0, $581 = 0;
 var $582 = 0, $583 = 0, $584 = 0, $585 = 0, $586 = 0, $587 = 0, $588 = 0, $589 = 0, $59 = 0, $590 = 0, $591 = 0, $592 = 0, $593 = 0.0, $594 = 0.0, $595 = 0, $596 = 0.0, $597 = 0, $598 = 0, $599 = 0, $6 = 0;
 var $60 = 0, $600 = 0, $601 = 0, $602 = 0, $603 = 0, $604 = 0, $605 = 0, $606 = 0, $607 = 0, $608 = 0, $609 = 0, $61 = 0, $610 = 0, $611 = 0, $612 = 0, $613 = 0, $614 = 0, $615 = 0, $616 = 0, $617 = 0;
 var $618 = 0, $619 = 0, $62 = 0, $620 = 0, $621 = 0, $622 = 0, $623 = 0, $624 = 0, $625 = 0, $626 = 0, $627 = 0, $628 = 0, $629 = 0, $63 = 0, $630 = 0, $631 = 0, $632 = 0, $633 = 0, $634 = 0, $635 = 0;
 var $636 = 0, $637 = 0, $638 = 0, $639 = 0, $64 = 0, $640 = 0, $641 = 0, $642 = 0, $643 = 0, $644 = 0, $645 = 0, $646 = 0, $647 = 0, $648 = 0, $649 = 0, $65 = 0, $650 = 0, $651 = 0, $652 = 0, $653 = 0;
 var $654 = 0, $655 = 0, $656 = 0, $657 = 0, $658 = 0, $659 = 0, $66 = 0, $660 = 0, $661 = 0, $662 = 0, $663 = 0, $664 = 0, $665 = 0, $666 = 0, $667 = 0, $668 = 0, $669 = 0, $67 = 0, $670 = 0, $671 = 0;
 var $672 = 0, $673 = 0, $674 = 0, $675 = 0, $676 = 0, $677 = 0, $678 = 0, $679 = 0, $68 = 0, $680 = 0, $681 = 0, $682 = 0, $683 = 0, $684 = 0, $685 = 0, $686 = 0, $687 = 0, $688 = 0, $689 = 0, $69 = 0;
 var $690 = 0, $691 = 0, $692 = 0, $693 = 0, $694 = 0, $695 = 0, $696 = 0, $697 = 0, $698 = 0, $699 = 0, $7 = 0, $70 = 0, $700 = 0, $701 = 0, $702 = 0, $703 = 0, $704 = 0, $705 = 0, $706 = 0, $707 = 0;
 var $708 = 0, $709 = 0, $71 = 0, $710 = 0, $711 = 0, $712 = 0, $713 = 0, $714 = 0, $715 = 0, $716 = 0, $717 = 0, $718 = 0, $719 = 0, $72 = 0, $720 = 0, $721 = 0, $722 = 0, $723 = 0, $724 = 0, $725 = 0;
 var $726 = 0, $727 = 0, $728 = 0, $729 = 0, $73 = 0, $730 = 0, $731 = 0, $732 = 0, $733 = 0, $734 = 0, $735 = 0, $736 = 0, $737 = 0, $738 = 0, $739 = 0, $74 = 0, $740 = 0, $741 = 0, $742 = 0, $743 = 0;
 var $744 = 0, $745 = 0, $746 = 0, $747 = 0, $748 = 0, $749 = 0, $75 = 0, $750 = 0, $751 = 0, $752 = 0, $753 = 0, $754 = 0, $755 = 0, $756 = 0, $757 = 0, $758 = 0, $759 = 0, $76 = 0, $760 = 0, $761 = 0;
 var $762 = 0, $763 = 0, $764 = 0, $765 = 0, $766 = 0, $767 = 0, $768 = 0, $769 = 0, $77 = 0, $770 = 0, $771 = 0, $772 = 0, $773 = 0, $774 = 0, $775 = 0, $776 = 0, $777 = 0, $778 = 0, $779 = 0, $78 = 0;
 var $780 = 0, $781 = 0, $782 = 0, $783 = 0, $784 = 0, $785 = 0, $786 = 0, $787 = 0, $788 = 0, $789 = 0, $79 = 0, $790 = 0, $791 = 0, $792 = 0, $793 = 0, $794 = 0, $795 = 0, $796 = 0, $797 = 0, $798 = 0;
 var $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0;
 var $98 = 0, $99 = 0, $a$0 = 0, $a$1 = 0, $a$1$lcssa$i = 0, $a$1149$i = 0, $a$2 = 0, $a$2$ph$i = 0, $a$3$lcssa$i = 0, $a$3136$i = 0, $a$5$lcssa$i = 0, $a$5111$i = 0, $a$6$i = 0, $a$8$i = 0, $a$9$ph$i = 0, $arg = 0, $arglist_current = 0, $arglist_current2 = 0, $arglist_next = 0, $arglist_next3 = 0;
 var $argpos$0 = 0, $big$i = 0, $buf = 0, $buf$i = 0, $carry$0142$i = 0, $carry3$0130$i = 0, $cnt$0 = 0, $cnt$1 = 0, $cnt$1$lcssa = 0, $d$0$i = 0, $d$0141$i = 0, $d$0143$i = 0, $d$1129$i = 0, $d$2$lcssa$i = 0, $d$2110$i = 0, $d$4$i = 0, $d$584$i = 0, $d$677$i = 0, $d$788$i = 0, $e$0125$i = 0;
 var $e$1$i = 0, $e$2106$i = 0, $e$4$i = 0, $e$5$ph$i = 0, $e2$i = 0, $ebuf0$i = 0, $estr$0$i = 0, $estr$1$lcssa$i = 0, $estr$195$i = 0, $estr$2$i = 0, $exitcond$i = 0, $expanded = 0, $expanded10 = 0, $expanded11 = 0, $expanded13 = 0, $expanded14 = 0, $expanded15 = 0, $expanded4 = 0, $expanded6 = 0, $expanded7 = 0;
 var $expanded8 = 0, $fl$0100 = 0, $fl$053 = 0, $fl$1 = 0, $fl$1$ = 0, $fl$3 = 0, $fl$4 = 0, $fl$6 = 0, $i$0$lcssa = 0, $i$0$lcssa178 = 0, $i$0105 = 0, $i$0124$i = 0, $i$03$i = 0, $i$03$i25 = 0, $i$1$lcssa$i = 0, $i$1116 = 0, $i$1118$i = 0, $i$2105$i = 0, $i$291 = 0, $i$291$lcssa = 0;
 var $i$3101$i = 0, $i$389 = 0, $isdigit = 0, $isdigit$i = 0, $isdigit$i27 = 0, $isdigit10 = 0, $isdigit12 = 0, $isdigit2$i = 0, $isdigit2$i23 = 0, $isdigittmp = 0, $isdigittmp$ = 0, $isdigittmp$i = 0, $isdigittmp$i26 = 0, $isdigittmp1$i = 0, $isdigittmp1$i22 = 0, $isdigittmp11 = 0, $isdigittmp4$i = 0, $isdigittmp4$i24 = 0, $isdigittmp9 = 0, $j$0$i = 0;
 var $j$0117$i = 0, $j$0119$i = 0, $j$1102$i = 0, $j$2$i = 0, $l$0 = 0, $l$0$i = 0, $l$1$i = 0, $l$1104 = 0, $l$2 = 0, $l10n$0 = 0, $l10n$0$lcssa = 0, $l10n$0$phi = 0, $l10n$1 = 0, $l10n$2 = 0, $l10n$3 = 0, $mb = 0, $notlhs$i = 0, $notrhs$i = 0, $or$cond = 0, $or$cond$i = 0;
 var $or$cond122 = 0, $or$cond15 = 0, $or$cond17 = 0, $or$cond18$i = 0, $or$cond20 = 0, $or$cond22$i = 0, $or$cond3$not$i = 0, $or$cond31$i = 0, $or$cond6$i = 0, $p$0 = 0, $p$0$ = 0, $p$1 = 0, $p$2 = 0, $p$2$ = 0, $p$3 = 0, $p$4176 = 0, $p$5 = 0, $pl$0 = 0, $pl$0$i = 0, $pl$1 = 0;
 var $pl$1$i = 0, $pl$2 = 0, $prefix$0 = 0, $prefix$0$$i = 0, $prefix$0$i = 0, $prefix$1 = 0, $prefix$2 = 0, $r$0$a$9$i = 0, $re$171$i = 0, $round$070$i = 0.0, $round6$1$i = 0.0, $s$0 = 0, $s$0$i = 0, $s$1 = 0, $s$1$i = 0, $s$1$i$lcssa = 0, $s$2$lcssa = 0, $s$292 = 0, $s$4 = 0, $s$6 = 0;
 var $s$7 = 0, $s$7$lcssa298 = 0, $s1$0$i = 0, $s7$081$i = 0, $s7$1$i = 0, $s8$0$lcssa$i = 0, $s8$072$i = 0, $s9$0$i = 0, $s9$185$i = 0, $s9$2$i = 0, $scevgep182$i = 0, $scevgep182183$i = 0, $small$0$i = 0.0, $small$1$i = 0.0, $st$0 = 0, $st$0$lcssa299 = 0, $storemerge = 0, $storemerge13 = 0, $storemerge851 = 0, $storemerge899 = 0;
 var $sum = 0, $t$0 = 0, $t$1 = 0, $w$$i = 0, $w$0 = 0, $w$1 = 0, $w$2 = 0, $w$32$i = 0, $wc = 0, $ws$0106 = 0, $ws$1117 = 0, $z$0$i = 0, $z$0$lcssa = 0, $z$093 = 0, $z$1 = 0, $z$1$lcssa$i = 0, $z$1148$i = 0, $z$2 = 0, $z$2$i = 0, $z$2$i$lcssa = 0;
 var $z$3$lcssa$i = 0, $z$3135$i = 0, $z$4$i = 0, $z$7$$i = 0, $z$7$i = 0, $z$7$i$lcssa = 0, $z$7$ph$i = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 624|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $big$i = sp + 24|0;
 $e2$i = sp + 16|0;
 $buf$i = sp + 588|0;
 $ebuf0$i = sp + 576|0;
 $arg = sp;
 $buf = sp + 536|0;
 $wc = sp + 8|0;
 $mb = sp + 528|0;
 $0 = ($f|0)!=(0|0);
 $1 = ((($buf)) + 40|0);
 $2 = $1;
 $3 = ((($buf)) + 39|0);
 $4 = ((($wc)) + 4|0);
 $5 = $buf$i;
 $6 = (0 - ($5))|0;
 $7 = ((($ebuf0$i)) + 12|0);
 $8 = ((($ebuf0$i)) + 11|0);
 $9 = $7;
 $10 = (($9) - ($5))|0;
 $11 = (-2 - ($5))|0;
 $12 = (($9) + 2)|0;
 $13 = ((($big$i)) + 288|0);
 $14 = ((($buf$i)) + 9|0);
 $15 = $14;
 $16 = ((($buf$i)) + 8|0);
 $cnt$0 = 0;$l$0 = 0;$l10n$0 = 0;$s$0 = $fmt;
 L1: while(1) {
  $17 = ($cnt$0|0)>(-1);
  do {
   if ($17) {
    $18 = (2147483647 - ($cnt$0))|0;
    $19 = ($l$0|0)>($18|0);
    if ($19) {
     $20 = (___errno_location()|0);
     HEAP32[$20>>2] = 75;
     $cnt$1 = -1;
     break;
    } else {
     $21 = (($l$0) + ($cnt$0))|0;
     $cnt$1 = $21;
     break;
    }
   } else {
    $cnt$1 = $cnt$0;
   }
  } while(0);
  $22 = HEAP8[$s$0>>0]|0;
  $23 = ($22<<24>>24)==(0);
  if ($23) {
   $cnt$1$lcssa = $cnt$1;$l10n$0$lcssa = $l10n$0;
   label = 244;
   break;
  } else {
   $24 = $22;$s$1 = $s$0;
  }
  L9: while(1) {
   switch ($24<<24>>24) {
   case 37:  {
    $s$292 = $s$1;$z$093 = $s$1;
    label = 9;
    break L9;
    break;
   }
   case 0:  {
    $s$2$lcssa = $s$1;$z$0$lcssa = $s$1;
    break L9;
    break;
   }
   default: {
   }
   }
   $25 = ((($s$1)) + 1|0);
   $$pre = HEAP8[$25>>0]|0;
   $24 = $$pre;$s$1 = $25;
  }
  L12: do {
   if ((label|0) == 9) {
    while(1) {
     label = 0;
     $26 = ((($s$292)) + 1|0);
     $27 = HEAP8[$26>>0]|0;
     $28 = ($27<<24>>24)==(37);
     if (!($28)) {
      $s$2$lcssa = $s$292;$z$0$lcssa = $z$093;
      break L12;
     }
     $29 = ((($z$093)) + 1|0);
     $30 = ((($s$292)) + 2|0);
     $31 = HEAP8[$30>>0]|0;
     $32 = ($31<<24>>24)==(37);
     if ($32) {
      $s$292 = $30;$z$093 = $29;
      label = 9;
     } else {
      $s$2$lcssa = $30;$z$0$lcssa = $29;
      break;
     }
    }
   }
  } while(0);
  $33 = $z$0$lcssa;
  $34 = $s$0;
  $35 = (($33) - ($34))|0;
  if ($0) {
   $36 = HEAP32[$f>>2]|0;
   $37 = $36 & 32;
   $38 = ($37|0)==(0);
   if ($38) {
    (___fwritex($s$0,$35,$f)|0);
   }
  }
  $39 = ($z$0$lcssa|0)==($s$0|0);
  if (!($39)) {
   $l10n$0$phi = $l10n$0;$cnt$0 = $cnt$1;$l$0 = $35;$s$0 = $s$2$lcssa;$l10n$0 = $l10n$0$phi;
   continue;
  }
  $40 = ((($s$2$lcssa)) + 1|0);
  $41 = HEAP8[$40>>0]|0;
  $42 = $41 << 24 >> 24;
  $isdigittmp = (($42) + -48)|0;
  $isdigit = ($isdigittmp>>>0)<(10);
  if ($isdigit) {
   $43 = ((($s$2$lcssa)) + 2|0);
   $44 = HEAP8[$43>>0]|0;
   $45 = ($44<<24>>24)==(36);
   $46 = ((($s$2$lcssa)) + 3|0);
   $$43 = $45 ? $46 : $40;
   $$l10n$0 = $45 ? 1 : $l10n$0;
   $isdigittmp$ = $45 ? $isdigittmp : -1;
   $$pre170 = HEAP8[$$43>>0]|0;
   $48 = $$pre170;$argpos$0 = $isdigittmp$;$l10n$1 = $$l10n$0;$storemerge = $$43;
  } else {
   $48 = $41;$argpos$0 = -1;$l10n$1 = $l10n$0;$storemerge = $40;
  }
  $47 = $48 << 24 >> 24;
  $49 = $47 & -32;
  $50 = ($49|0)==(32);
  L25: do {
   if ($50) {
    $52 = $47;$57 = $48;$fl$0100 = 0;$storemerge899 = $storemerge;
    while(1) {
     $51 = (($52) + -32)|0;
     $53 = 1 << $51;
     $54 = $53 & 75913;
     $55 = ($54|0)==(0);
     if ($55) {
      $67 = $57;$fl$053 = $fl$0100;$storemerge851 = $storemerge899;
      break L25;
     }
     $56 = $57 << 24 >> 24;
     $58 = (($56) + -32)|0;
     $59 = 1 << $58;
     $60 = $59 | $fl$0100;
     $61 = ((($storemerge899)) + 1|0);
     $62 = HEAP8[$61>>0]|0;
     $63 = $62 << 24 >> 24;
     $64 = $63 & -32;
     $65 = ($64|0)==(32);
     if ($65) {
      $52 = $63;$57 = $62;$fl$0100 = $60;$storemerge899 = $61;
     } else {
      $67 = $62;$fl$053 = $60;$storemerge851 = $61;
      break;
     }
    }
   } else {
    $67 = $48;$fl$053 = 0;$storemerge851 = $storemerge;
   }
  } while(0);
  $66 = ($67<<24>>24)==(42);
  do {
   if ($66) {
    $68 = ((($storemerge851)) + 1|0);
    $69 = HEAP8[$68>>0]|0;
    $70 = $69 << 24 >> 24;
    $isdigittmp11 = (($70) + -48)|0;
    $isdigit12 = ($isdigittmp11>>>0)<(10);
    if ($isdigit12) {
     $71 = ((($storemerge851)) + 2|0);
     $72 = HEAP8[$71>>0]|0;
     $73 = ($72<<24>>24)==(36);
     if ($73) {
      $74 = (($nl_type) + ($isdigittmp11<<2)|0);
      HEAP32[$74>>2] = 10;
      $75 = HEAP8[$68>>0]|0;
      $76 = $75 << 24 >> 24;
      $77 = (($76) + -48)|0;
      $78 = (($nl_arg) + ($77<<3)|0);
      $79 = $78;
      $80 = $79;
      $81 = HEAP32[$80>>2]|0;
      $82 = (($79) + 4)|0;
      $83 = $82;
      $84 = HEAP32[$83>>2]|0;
      $85 = ((($storemerge851)) + 3|0);
      $l10n$2 = 1;$storemerge13 = $85;$w$0 = $81;
     } else {
      label = 24;
     }
    } else {
     label = 24;
    }
    if ((label|0) == 24) {
     label = 0;
     $86 = ($l10n$1|0)==(0);
     if (!($86)) {
      $$0 = -1;
      break L1;
     }
     if (!($0)) {
      $fl$1 = $fl$053;$l10n$3 = 0;$s$4 = $68;$w$1 = 0;
      break;
     }
     $arglist_current = HEAP32[$ap>>2]|0;
     $87 = $arglist_current;
     $88 = ((0) + 4|0);
     $expanded4 = $88;
     $expanded = (($expanded4) - 1)|0;
     $89 = (($87) + ($expanded))|0;
     $90 = ((0) + 4|0);
     $expanded8 = $90;
     $expanded7 = (($expanded8) - 1)|0;
     $expanded6 = $expanded7 ^ -1;
     $91 = $89 & $expanded6;
     $92 = $91;
     $93 = HEAP32[$92>>2]|0;
     $arglist_next = ((($92)) + 4|0);
     HEAP32[$ap>>2] = $arglist_next;
     $l10n$2 = 0;$storemerge13 = $68;$w$0 = $93;
    }
    $94 = ($w$0|0)<(0);
    if ($94) {
     $95 = $fl$053 | 8192;
     $96 = (0 - ($w$0))|0;
     $fl$1 = $95;$l10n$3 = $l10n$2;$s$4 = $storemerge13;$w$1 = $96;
    } else {
     $fl$1 = $fl$053;$l10n$3 = $l10n$2;$s$4 = $storemerge13;$w$1 = $w$0;
    }
   } else {
    $97 = $67 << 24 >> 24;
    $isdigittmp1$i = (($97) + -48)|0;
    $isdigit2$i = ($isdigittmp1$i>>>0)<(10);
    if ($isdigit2$i) {
     $101 = $storemerge851;$i$03$i = 0;$isdigittmp4$i = $isdigittmp1$i;
     while(1) {
      $98 = ($i$03$i*10)|0;
      $99 = (($98) + ($isdigittmp4$i))|0;
      $100 = ((($101)) + 1|0);
      $102 = HEAP8[$100>>0]|0;
      $103 = $102 << 24 >> 24;
      $isdigittmp$i = (($103) + -48)|0;
      $isdigit$i = ($isdigittmp$i>>>0)<(10);
      if ($isdigit$i) {
       $101 = $100;$i$03$i = $99;$isdigittmp4$i = $isdigittmp$i;
      } else {
       $$lcssa = $99;$$lcssa295 = $100;
       break;
      }
     }
     $104 = ($$lcssa|0)<(0);
     if ($104) {
      $$0 = -1;
      break L1;
     } else {
      $fl$1 = $fl$053;$l10n$3 = $l10n$1;$s$4 = $$lcssa295;$w$1 = $$lcssa;
     }
    } else {
     $fl$1 = $fl$053;$l10n$3 = $l10n$1;$s$4 = $storemerge851;$w$1 = 0;
    }
   }
  } while(0);
  $105 = HEAP8[$s$4>>0]|0;
  $106 = ($105<<24>>24)==(46);
  L46: do {
   if ($106) {
    $107 = ((($s$4)) + 1|0);
    $108 = HEAP8[$107>>0]|0;
    $109 = ($108<<24>>24)==(42);
    if (!($109)) {
     $136 = $108 << 24 >> 24;
     $isdigittmp1$i22 = (($136) + -48)|0;
     $isdigit2$i23 = ($isdigittmp1$i22>>>0)<(10);
     if ($isdigit2$i23) {
      $140 = $107;$i$03$i25 = 0;$isdigittmp4$i24 = $isdigittmp1$i22;
     } else {
      $p$0 = 0;$s$6 = $107;
      break;
     }
     while(1) {
      $137 = ($i$03$i25*10)|0;
      $138 = (($137) + ($isdigittmp4$i24))|0;
      $139 = ((($140)) + 1|0);
      $141 = HEAP8[$139>>0]|0;
      $142 = $141 << 24 >> 24;
      $isdigittmp$i26 = (($142) + -48)|0;
      $isdigit$i27 = ($isdigittmp$i26>>>0)<(10);
      if ($isdigit$i27) {
       $140 = $139;$i$03$i25 = $138;$isdigittmp4$i24 = $isdigittmp$i26;
      } else {
       $p$0 = $138;$s$6 = $139;
       break L46;
      }
     }
    }
    $110 = ((($s$4)) + 2|0);
    $111 = HEAP8[$110>>0]|0;
    $112 = $111 << 24 >> 24;
    $isdigittmp9 = (($112) + -48)|0;
    $isdigit10 = ($isdigittmp9>>>0)<(10);
    if ($isdigit10) {
     $113 = ((($s$4)) + 3|0);
     $114 = HEAP8[$113>>0]|0;
     $115 = ($114<<24>>24)==(36);
     if ($115) {
      $116 = (($nl_type) + ($isdigittmp9<<2)|0);
      HEAP32[$116>>2] = 10;
      $117 = HEAP8[$110>>0]|0;
      $118 = $117 << 24 >> 24;
      $119 = (($118) + -48)|0;
      $120 = (($nl_arg) + ($119<<3)|0);
      $121 = $120;
      $122 = $121;
      $123 = HEAP32[$122>>2]|0;
      $124 = (($121) + 4)|0;
      $125 = $124;
      $126 = HEAP32[$125>>2]|0;
      $127 = ((($s$4)) + 4|0);
      $p$0 = $123;$s$6 = $127;
      break;
     }
    }
    $128 = ($l10n$3|0)==(0);
    if (!($128)) {
     $$0 = -1;
     break L1;
    }
    if ($0) {
     $arglist_current2 = HEAP32[$ap>>2]|0;
     $129 = $arglist_current2;
     $130 = ((0) + 4|0);
     $expanded11 = $130;
     $expanded10 = (($expanded11) - 1)|0;
     $131 = (($129) + ($expanded10))|0;
     $132 = ((0) + 4|0);
     $expanded15 = $132;
     $expanded14 = (($expanded15) - 1)|0;
     $expanded13 = $expanded14 ^ -1;
     $133 = $131 & $expanded13;
     $134 = $133;
     $135 = HEAP32[$134>>2]|0;
     $arglist_next3 = ((($134)) + 4|0);
     HEAP32[$ap>>2] = $arglist_next3;
     $p$0 = $135;$s$6 = $110;
    } else {
     $p$0 = 0;$s$6 = $110;
    }
   } else {
    $p$0 = -1;$s$6 = $s$4;
   }
  } while(0);
  $s$7 = $s$6;$st$0 = 0;
  while(1) {
   $143 = HEAP8[$s$7>>0]|0;
   $144 = $143 << 24 >> 24;
   $145 = (($144) + -65)|0;
   $146 = ($145>>>0)>(57);
   if ($146) {
    $$0 = -1;
    break L1;
   }
   $147 = ((($s$7)) + 1|0);
   $148 = ((691 + (($st$0*58)|0)|0) + ($145)|0);
   $149 = HEAP8[$148>>0]|0;
   $150 = $149&255;
   $151 = (($150) + -1)|0;
   $152 = ($151>>>0)<(8);
   if ($152) {
    $s$7 = $147;$st$0 = $150;
   } else {
    $$lcssa300 = $147;$$lcssa301 = $149;$$lcssa302 = $150;$s$7$lcssa298 = $s$7;$st$0$lcssa299 = $st$0;
    break;
   }
  }
  $153 = ($$lcssa301<<24>>24)==(0);
  if ($153) {
   $$0 = -1;
   break;
  }
  $154 = ($$lcssa301<<24>>24)==(19);
  $155 = ($argpos$0|0)>(-1);
  do {
   if ($154) {
    if ($155) {
     $$0 = -1;
     break L1;
    } else {
     label = 52;
    }
   } else {
    if ($155) {
     $156 = (($nl_type) + ($argpos$0<<2)|0);
     HEAP32[$156>>2] = $$lcssa302;
     $157 = (($nl_arg) + ($argpos$0<<3)|0);
     $158 = $157;
     $159 = $158;
     $160 = HEAP32[$159>>2]|0;
     $161 = (($158) + 4)|0;
     $162 = $161;
     $163 = HEAP32[$162>>2]|0;
     $164 = $arg;
     $165 = $164;
     HEAP32[$165>>2] = $160;
     $166 = (($164) + 4)|0;
     $167 = $166;
     HEAP32[$167>>2] = $163;
     label = 52;
     break;
    }
    if (!($0)) {
     $$0 = 0;
     break L1;
    }
    _pop_arg($arg,$$lcssa302,$ap);
   }
  } while(0);
  if ((label|0) == 52) {
   label = 0;
   if (!($0)) {
    $cnt$0 = $cnt$1;$l$0 = $35;$l10n$0 = $l10n$3;$s$0 = $$lcssa300;
    continue;
   }
  }
  $168 = HEAP8[$s$7$lcssa298>>0]|0;
  $169 = $168 << 24 >> 24;
  $170 = ($st$0$lcssa299|0)!=(0);
  $171 = $169 & 15;
  $172 = ($171|0)==(3);
  $or$cond15 = $170 & $172;
  $173 = $169 & -33;
  $t$0 = $or$cond15 ? $173 : $169;
  $174 = $fl$1 & 8192;
  $175 = ($174|0)==(0);
  $176 = $fl$1 & -65537;
  $fl$1$ = $175 ? $fl$1 : $176;
  L75: do {
   switch ($t$0|0) {
   case 110:  {
    switch ($st$0$lcssa299|0) {
    case 0:  {
     $183 = HEAP32[$arg>>2]|0;
     HEAP32[$183>>2] = $cnt$1;
     $cnt$0 = $cnt$1;$l$0 = $35;$l10n$0 = $l10n$3;$s$0 = $$lcssa300;
     continue L1;
     break;
    }
    case 1:  {
     $184 = HEAP32[$arg>>2]|0;
     HEAP32[$184>>2] = $cnt$1;
     $cnt$0 = $cnt$1;$l$0 = $35;$l10n$0 = $l10n$3;$s$0 = $$lcssa300;
     continue L1;
     break;
    }
    case 2:  {
     $185 = ($cnt$1|0)<(0);
     $186 = $185 << 31 >> 31;
     $187 = HEAP32[$arg>>2]|0;
     $188 = $187;
     $189 = $188;
     HEAP32[$189>>2] = $cnt$1;
     $190 = (($188) + 4)|0;
     $191 = $190;
     HEAP32[$191>>2] = $186;
     $cnt$0 = $cnt$1;$l$0 = $35;$l10n$0 = $l10n$3;$s$0 = $$lcssa300;
     continue L1;
     break;
    }
    case 3:  {
     $192 = $cnt$1&65535;
     $193 = HEAP32[$arg>>2]|0;
     HEAP16[$193>>1] = $192;
     $cnt$0 = $cnt$1;$l$0 = $35;$l10n$0 = $l10n$3;$s$0 = $$lcssa300;
     continue L1;
     break;
    }
    case 4:  {
     $194 = $cnt$1&255;
     $195 = HEAP32[$arg>>2]|0;
     HEAP8[$195>>0] = $194;
     $cnt$0 = $cnt$1;$l$0 = $35;$l10n$0 = $l10n$3;$s$0 = $$lcssa300;
     continue L1;
     break;
    }
    case 6:  {
     $196 = HEAP32[$arg>>2]|0;
     HEAP32[$196>>2] = $cnt$1;
     $cnt$0 = $cnt$1;$l$0 = $35;$l10n$0 = $l10n$3;$s$0 = $$lcssa300;
     continue L1;
     break;
    }
    case 7:  {
     $197 = ($cnt$1|0)<(0);
     $198 = $197 << 31 >> 31;
     $199 = HEAP32[$arg>>2]|0;
     $200 = $199;
     $201 = $200;
     HEAP32[$201>>2] = $cnt$1;
     $202 = (($200) + 4)|0;
     $203 = $202;
     HEAP32[$203>>2] = $198;
     $cnt$0 = $cnt$1;$l$0 = $35;$l10n$0 = $l10n$3;$s$0 = $$lcssa300;
     continue L1;
     break;
    }
    default: {
     $cnt$0 = $cnt$1;$l$0 = $35;$l10n$0 = $l10n$3;$s$0 = $$lcssa300;
     continue L1;
    }
    }
    break;
   }
   case 112:  {
    $204 = ($p$0>>>0)>(8);
    $205 = $204 ? $p$0 : 8;
    $206 = $fl$1$ | 8;
    $fl$3 = $206;$p$1 = $205;$t$1 = 120;
    label = 64;
    break;
   }
   case 88: case 120:  {
    $fl$3 = $fl$1$;$p$1 = $p$0;$t$1 = $t$0;
    label = 64;
    break;
   }
   case 111:  {
    $244 = $arg;
    $245 = $244;
    $246 = HEAP32[$245>>2]|0;
    $247 = (($244) + 4)|0;
    $248 = $247;
    $249 = HEAP32[$248>>2]|0;
    $250 = ($246|0)==(0);
    $251 = ($249|0)==(0);
    $252 = $250 & $251;
    if ($252) {
     $$0$lcssa$i = $1;
    } else {
     $$03$i33 = $1;$254 = $246;$258 = $249;
     while(1) {
      $253 = $254 & 7;
      $255 = $253 | 48;
      $256 = $255&255;
      $257 = ((($$03$i33)) + -1|0);
      HEAP8[$257>>0] = $256;
      $259 = (_bitshift64Lshr(($254|0),($258|0),3)|0);
      $260 = tempRet0;
      $261 = ($259|0)==(0);
      $262 = ($260|0)==(0);
      $263 = $261 & $262;
      if ($263) {
       $$0$lcssa$i = $257;
       break;
      } else {
       $$03$i33 = $257;$254 = $259;$258 = $260;
      }
     }
    }
    $264 = $fl$1$ & 8;
    $265 = ($264|0)==(0);
    if ($265) {
     $a$0 = $$0$lcssa$i;$fl$4 = $fl$1$;$p$2 = $p$0;$pl$1 = 0;$prefix$1 = 1171;
     label = 77;
    } else {
     $266 = $$0$lcssa$i;
     $267 = (($2) - ($266))|0;
     $268 = ($p$0|0)>($267|0);
     $269 = (($267) + 1)|0;
     $p$0$ = $268 ? $p$0 : $269;
     $a$0 = $$0$lcssa$i;$fl$4 = $fl$1$;$p$2 = $p$0$;$pl$1 = 0;$prefix$1 = 1171;
     label = 77;
    }
    break;
   }
   case 105: case 100:  {
    $270 = $arg;
    $271 = $270;
    $272 = HEAP32[$271>>2]|0;
    $273 = (($270) + 4)|0;
    $274 = $273;
    $275 = HEAP32[$274>>2]|0;
    $276 = ($275|0)<(0);
    if ($276) {
     $277 = (_i64Subtract(0,0,($272|0),($275|0))|0);
     $278 = tempRet0;
     $279 = $arg;
     $280 = $279;
     HEAP32[$280>>2] = $277;
     $281 = (($279) + 4)|0;
     $282 = $281;
     HEAP32[$282>>2] = $278;
     $287 = $277;$288 = $278;$pl$0 = 1;$prefix$0 = 1171;
     label = 76;
     break L75;
    }
    $283 = $fl$1$ & 2048;
    $284 = ($283|0)==(0);
    if ($284) {
     $285 = $fl$1$ & 1;
     $286 = ($285|0)==(0);
     $$ = $286 ? 1171 : (1173);
     $287 = $272;$288 = $275;$pl$0 = $285;$prefix$0 = $$;
     label = 76;
    } else {
     $287 = $272;$288 = $275;$pl$0 = 1;$prefix$0 = (1172);
     label = 76;
    }
    break;
   }
   case 117:  {
    $177 = $arg;
    $178 = $177;
    $179 = HEAP32[$178>>2]|0;
    $180 = (($177) + 4)|0;
    $181 = $180;
    $182 = HEAP32[$181>>2]|0;
    $287 = $179;$288 = $182;$pl$0 = 0;$prefix$0 = 1171;
    label = 76;
    break;
   }
   case 99:  {
    $308 = $arg;
    $309 = $308;
    $310 = HEAP32[$309>>2]|0;
    $311 = (($308) + 4)|0;
    $312 = $311;
    $313 = HEAP32[$312>>2]|0;
    $314 = $310&255;
    HEAP8[$3>>0] = $314;
    $a$2 = $3;$fl$6 = $176;$p$5 = 1;$pl$2 = 0;$prefix$2 = 1171;$z$2 = $1;
    break;
   }
   case 109:  {
    $315 = (___errno_location()|0);
    $316 = HEAP32[$315>>2]|0;
    $317 = (_strerror($316)|0);
    $a$1 = $317;
    label = 82;
    break;
   }
   case 115:  {
    $318 = HEAP32[$arg>>2]|0;
    $319 = ($318|0)!=(0|0);
    $320 = $319 ? $318 : 3073;
    $a$1 = $320;
    label = 82;
    break;
   }
   case 67:  {
    $327 = $arg;
    $328 = $327;
    $329 = HEAP32[$328>>2]|0;
    $330 = (($327) + 4)|0;
    $331 = $330;
    $332 = HEAP32[$331>>2]|0;
    HEAP32[$wc>>2] = $329;
    HEAP32[$4>>2] = 0;
    HEAP32[$arg>>2] = $wc;
    $798 = $wc;$p$4176 = -1;
    label = 86;
    break;
   }
   case 83:  {
    $$pre171 = HEAP32[$arg>>2]|0;
    $333 = ($p$0|0)==(0);
    if ($333) {
     _pad($f,32,$w$1,0,$fl$1$);
     $i$0$lcssa178 = 0;
     label = 97;
    } else {
     $798 = $$pre171;$p$4176 = $p$0;
     label = 86;
    }
    break;
   }
   case 65: case 71: case 70: case 69: case 97: case 103: case 102: case 101:  {
    $358 = +HEAPF64[$arg>>3];
    HEAP32[$e2$i>>2] = 0;
    HEAPF64[tempDoublePtr>>3] = $358;$359 = HEAP32[tempDoublePtr>>2]|0;
    $360 = HEAP32[tempDoublePtr+4>>2]|0;
    $361 = ($360|0)<(0);
    if ($361) {
     $362 = -$358;
     $$07$i = $362;$pl$0$i = 1;$prefix$0$i = 3080;
    } else {
     $363 = $fl$1$ & 2048;
     $364 = ($363|0)==(0);
     if ($364) {
      $365 = $fl$1$ & 1;
      $366 = ($365|0)==(0);
      $$$i = $366 ? (3081) : (3086);
      $$07$i = $358;$pl$0$i = $365;$prefix$0$i = $$$i;
     } else {
      $$07$i = $358;$pl$0$i = 1;$prefix$0$i = (3083);
     }
    }
    HEAPF64[tempDoublePtr>>3] = $$07$i;$367 = HEAP32[tempDoublePtr>>2]|0;
    $368 = HEAP32[tempDoublePtr+4>>2]|0;
    $369 = $368 & 2146435072;
    $370 = ($369>>>0)<(2146435072);
    $371 = (0)<(0);
    $372 = ($369|0)==(2146435072);
    $373 = $372 & $371;
    $374 = $370 | $373;
    do {
     if ($374) {
      $390 = (+_frexpl($$07$i,$e2$i));
      $391 = $390 * 2.0;
      $392 = $391 != 0.0;
      if ($392) {
       $393 = HEAP32[$e2$i>>2]|0;
       $394 = (($393) + -1)|0;
       HEAP32[$e2$i>>2] = $394;
      }
      $395 = $t$0 | 32;
      $396 = ($395|0)==(97);
      if ($396) {
       $397 = $t$0 & 32;
       $398 = ($397|0)==(0);
       $399 = ((($prefix$0$i)) + 9|0);
       $prefix$0$$i = $398 ? $prefix$0$i : $399;
       $400 = $pl$0$i | 2;
       $401 = ($p$0>>>0)>(11);
       $402 = (12 - ($p$0))|0;
       $403 = ($402|0)==(0);
       $404 = $401 | $403;
       do {
        if ($404) {
         $$1$i = $391;
        } else {
         $re$171$i = $402;$round$070$i = 8.0;
         while(1) {
          $405 = (($re$171$i) + -1)|0;
          $406 = $round$070$i * 16.0;
          $407 = ($405|0)==(0);
          if ($407) {
           $$lcssa319 = $406;
           break;
          } else {
           $re$171$i = $405;$round$070$i = $406;
          }
         }
         $408 = HEAP8[$prefix$0$$i>>0]|0;
         $409 = ($408<<24>>24)==(45);
         if ($409) {
          $410 = -$391;
          $411 = $410 - $$lcssa319;
          $412 = $$lcssa319 + $411;
          $413 = -$412;
          $$1$i = $413;
          break;
         } else {
          $414 = $391 + $$lcssa319;
          $415 = $414 - $$lcssa319;
          $$1$i = $415;
          break;
         }
        }
       } while(0);
       $416 = HEAP32[$e2$i>>2]|0;
       $417 = ($416|0)<(0);
       $418 = (0 - ($416))|0;
       $419 = $417 ? $418 : $416;
       $420 = ($419|0)<(0);
       $421 = $420 << 31 >> 31;
       $422 = (_fmt_u($419,$421,$7)|0);
       $423 = ($422|0)==($7|0);
       if ($423) {
        HEAP8[$8>>0] = 48;
        $estr$0$i = $8;
       } else {
        $estr$0$i = $422;
       }
       $424 = $416 >> 31;
       $425 = $424 & 2;
       $426 = (($425) + 43)|0;
       $427 = $426&255;
       $428 = ((($estr$0$i)) + -1|0);
       HEAP8[$428>>0] = $427;
       $429 = (($t$0) + 15)|0;
       $430 = $429&255;
       $431 = ((($estr$0$i)) + -2|0);
       HEAP8[$431>>0] = $430;
       $notrhs$i = ($p$0|0)<(1);
       $432 = $fl$1$ & 8;
       $433 = ($432|0)==(0);
       $$2$i = $$1$i;$s$0$i = $buf$i;
       while(1) {
        $434 = (~~(($$2$i)));
        $435 = (1155 + ($434)|0);
        $436 = HEAP8[$435>>0]|0;
        $437 = $436&255;
        $438 = $437 | $397;
        $439 = $438&255;
        $440 = ((($s$0$i)) + 1|0);
        HEAP8[$s$0$i>>0] = $439;
        $441 = (+($434|0));
        $442 = $$2$i - $441;
        $443 = $442 * 16.0;
        $444 = $440;
        $445 = (($444) - ($5))|0;
        $446 = ($445|0)==(1);
        do {
         if ($446) {
          $notlhs$i = $443 == 0.0;
          $or$cond3$not$i = $notrhs$i & $notlhs$i;
          $or$cond$i = $433 & $or$cond3$not$i;
          if ($or$cond$i) {
           $s$1$i = $440;
           break;
          }
          $447 = ((($s$0$i)) + 2|0);
          HEAP8[$440>>0] = 46;
          $s$1$i = $447;
         } else {
          $s$1$i = $440;
         }
        } while(0);
        $448 = $443 != 0.0;
        if ($448) {
         $$2$i = $443;$s$0$i = $s$1$i;
        } else {
         $s$1$i$lcssa = $s$1$i;
         break;
        }
       }
       $449 = ($p$0|0)!=(0);
       $$pre188$i = $s$1$i$lcssa;
       $450 = (($11) + ($$pre188$i))|0;
       $451 = ($450|0)<($p$0|0);
       $or$cond122 = $449 & $451;
       $452 = $431;
       $453 = (($12) + ($p$0))|0;
       $454 = (($453) - ($452))|0;
       $455 = (($10) - ($452))|0;
       $456 = (($455) + ($$pre188$i))|0;
       $l$0$i = $or$cond122 ? $454 : $456;
       $457 = (($l$0$i) + ($400))|0;
       _pad($f,32,$w$1,$457,$fl$1$);
       $458 = HEAP32[$f>>2]|0;
       $459 = $458 & 32;
       $460 = ($459|0)==(0);
       if ($460) {
        (___fwritex($prefix$0$$i,$400,$f)|0);
       }
       $461 = $fl$1$ ^ 65536;
       _pad($f,48,$w$1,$457,$461);
       $462 = (($$pre188$i) - ($5))|0;
       $463 = HEAP32[$f>>2]|0;
       $464 = $463 & 32;
       $465 = ($464|0)==(0);
       if ($465) {
        (___fwritex($buf$i,$462,$f)|0);
       }
       $466 = (($9) - ($452))|0;
       $sum = (($462) + ($466))|0;
       $467 = (($l$0$i) - ($sum))|0;
       _pad($f,48,$467,0,0);
       $468 = HEAP32[$f>>2]|0;
       $469 = $468 & 32;
       $470 = ($469|0)==(0);
       if ($470) {
        (___fwritex($431,$466,$f)|0);
       }
       $471 = $fl$1$ ^ 8192;
       _pad($f,32,$w$1,$457,$471);
       $472 = ($457|0)<($w$1|0);
       $w$$i = $472 ? $w$1 : $457;
       $$0$i = $w$$i;
       break;
      }
      $473 = ($p$0|0)<(0);
      $$p$i = $473 ? 6 : $p$0;
      if ($392) {
       $474 = $391 * 268435456.0;
       $475 = HEAP32[$e2$i>>2]|0;
       $476 = (($475) + -28)|0;
       HEAP32[$e2$i>>2] = $476;
       $$3$i = $474;$478 = $476;
      } else {
       $$pre185$i = HEAP32[$e2$i>>2]|0;
       $$3$i = $391;$478 = $$pre185$i;
      }
      $477 = ($478|0)<(0);
      $$33$i = $477 ? $big$i : $13;
      $479 = $$33$i;
      $$4$i = $$3$i;$z$0$i = $$33$i;
      while(1) {
       $480 = (~~(($$4$i))>>>0);
       HEAP32[$z$0$i>>2] = $480;
       $481 = ((($z$0$i)) + 4|0);
       $482 = (+($480>>>0));
       $483 = $$4$i - $482;
       $484 = $483 * 1.0E+9;
       $485 = $484 != 0.0;
       if ($485) {
        $$4$i = $484;$z$0$i = $481;
       } else {
        $$lcssa303 = $481;
        break;
       }
      }
      $$pr$i = HEAP32[$e2$i>>2]|0;
      $486 = ($$pr$i|0)>(0);
      if ($486) {
       $488 = $$pr$i;$a$1149$i = $$33$i;$z$1148$i = $$lcssa303;
       while(1) {
        $487 = ($488|0)>(29);
        $489 = $487 ? 29 : $488;
        $d$0141$i = ((($z$1148$i)) + -4|0);
        $490 = ($d$0141$i>>>0)<($a$1149$i>>>0);
        do {
         if ($490) {
          $a$2$ph$i = $a$1149$i;
         } else {
          $carry$0142$i = 0;$d$0143$i = $d$0141$i;
          while(1) {
           $491 = HEAP32[$d$0143$i>>2]|0;
           $492 = (_bitshift64Shl(($491|0),0,($489|0))|0);
           $493 = tempRet0;
           $494 = (_i64Add(($492|0),($493|0),($carry$0142$i|0),0)|0);
           $495 = tempRet0;
           $496 = (___uremdi3(($494|0),($495|0),1000000000,0)|0);
           $497 = tempRet0;
           HEAP32[$d$0143$i>>2] = $496;
           $498 = (___udivdi3(($494|0),($495|0),1000000000,0)|0);
           $499 = tempRet0;
           $d$0$i = ((($d$0143$i)) + -4|0);
           $500 = ($d$0$i>>>0)<($a$1149$i>>>0);
           if ($500) {
            $$lcssa304 = $498;
            break;
           } else {
            $carry$0142$i = $498;$d$0143$i = $d$0$i;
           }
          }
          $501 = ($$lcssa304|0)==(0);
          if ($501) {
           $a$2$ph$i = $a$1149$i;
           break;
          }
          $502 = ((($a$1149$i)) + -4|0);
          HEAP32[$502>>2] = $$lcssa304;
          $a$2$ph$i = $502;
         }
        } while(0);
        $z$2$i = $z$1148$i;
        while(1) {
         $503 = ($z$2$i>>>0)>($a$2$ph$i>>>0);
         if (!($503)) {
          $z$2$i$lcssa = $z$2$i;
          break;
         }
         $504 = ((($z$2$i)) + -4|0);
         $505 = HEAP32[$504>>2]|0;
         $506 = ($505|0)==(0);
         if ($506) {
          $z$2$i = $504;
         } else {
          $z$2$i$lcssa = $z$2$i;
          break;
         }
        }
        $507 = HEAP32[$e2$i>>2]|0;
        $508 = (($507) - ($489))|0;
        HEAP32[$e2$i>>2] = $508;
        $509 = ($508|0)>(0);
        if ($509) {
         $488 = $508;$a$1149$i = $a$2$ph$i;$z$1148$i = $z$2$i$lcssa;
        } else {
         $$pr50$i = $508;$a$1$lcssa$i = $a$2$ph$i;$z$1$lcssa$i = $z$2$i$lcssa;
         break;
        }
       }
      } else {
       $$pr50$i = $$pr$i;$a$1$lcssa$i = $$33$i;$z$1$lcssa$i = $$lcssa303;
      }
      $510 = ($$pr50$i|0)<(0);
      if ($510) {
       $511 = (($$p$i) + 25)|0;
       $512 = (($511|0) / 9)&-1;
       $513 = (($512) + 1)|0;
       $514 = ($395|0)==(102);
       $516 = $$pr50$i;$a$3136$i = $a$1$lcssa$i;$z$3135$i = $z$1$lcssa$i;
       while(1) {
        $515 = (0 - ($516))|0;
        $517 = ($515|0)>(9);
        $518 = $517 ? 9 : $515;
        $519 = ($a$3136$i>>>0)<($z$3135$i>>>0);
        do {
         if ($519) {
          $523 = 1 << $518;
          $524 = (($523) + -1)|0;
          $525 = 1000000000 >>> $518;
          $carry3$0130$i = 0;$d$1129$i = $a$3136$i;
          while(1) {
           $526 = HEAP32[$d$1129$i>>2]|0;
           $527 = $526 & $524;
           $528 = $526 >>> $518;
           $529 = (($528) + ($carry3$0130$i))|0;
           HEAP32[$d$1129$i>>2] = $529;
           $530 = Math_imul($527, $525)|0;
           $531 = ((($d$1129$i)) + 4|0);
           $532 = ($531>>>0)<($z$3135$i>>>0);
           if ($532) {
            $carry3$0130$i = $530;$d$1129$i = $531;
           } else {
            $$lcssa306 = $530;
            break;
           }
          }
          $533 = HEAP32[$a$3136$i>>2]|0;
          $534 = ($533|0)==(0);
          $535 = ((($a$3136$i)) + 4|0);
          $$a$3$i = $534 ? $535 : $a$3136$i;
          $536 = ($$lcssa306|0)==(0);
          if ($536) {
           $$a$3192$i = $$a$3$i;$z$4$i = $z$3135$i;
           break;
          }
          $537 = ((($z$3135$i)) + 4|0);
          HEAP32[$z$3135$i>>2] = $$lcssa306;
          $$a$3192$i = $$a$3$i;$z$4$i = $537;
         } else {
          $520 = HEAP32[$a$3136$i>>2]|0;
          $521 = ($520|0)==(0);
          $522 = ((($a$3136$i)) + 4|0);
          $$a$3191$i = $521 ? $522 : $a$3136$i;
          $$a$3192$i = $$a$3191$i;$z$4$i = $z$3135$i;
         }
        } while(0);
        $538 = $514 ? $$33$i : $$a$3192$i;
        $539 = $z$4$i;
        $540 = $538;
        $541 = (($539) - ($540))|0;
        $542 = $541 >> 2;
        $543 = ($542|0)>($513|0);
        $544 = (($538) + ($513<<2)|0);
        $$z$4$i = $543 ? $544 : $z$4$i;
        $545 = HEAP32[$e2$i>>2]|0;
        $546 = (($545) + ($518))|0;
        HEAP32[$e2$i>>2] = $546;
        $547 = ($546|0)<(0);
        if ($547) {
         $516 = $546;$a$3136$i = $$a$3192$i;$z$3135$i = $$z$4$i;
        } else {
         $a$3$lcssa$i = $$a$3192$i;$z$3$lcssa$i = $$z$4$i;
         break;
        }
       }
      } else {
       $a$3$lcssa$i = $a$1$lcssa$i;$z$3$lcssa$i = $z$1$lcssa$i;
      }
      $548 = ($a$3$lcssa$i>>>0)<($z$3$lcssa$i>>>0);
      do {
       if ($548) {
        $549 = $a$3$lcssa$i;
        $550 = (($479) - ($549))|0;
        $551 = $550 >> 2;
        $552 = ($551*9)|0;
        $553 = HEAP32[$a$3$lcssa$i>>2]|0;
        $554 = ($553>>>0)<(10);
        if ($554) {
         $e$1$i = $552;
         break;
        } else {
         $e$0125$i = $552;$i$0124$i = 10;
        }
        while(1) {
         $555 = ($i$0124$i*10)|0;
         $556 = (($e$0125$i) + 1)|0;
         $557 = ($553>>>0)<($555>>>0);
         if ($557) {
          $e$1$i = $556;
          break;
         } else {
          $e$0125$i = $556;$i$0124$i = $555;
         }
        }
       } else {
        $e$1$i = 0;
       }
      } while(0);
      $558 = ($395|0)!=(102);
      $559 = $558 ? $e$1$i : 0;
      $560 = (($$p$i) - ($559))|0;
      $561 = ($395|0)==(103);
      $562 = ($$p$i|0)!=(0);
      $563 = $562 & $561;
      $$neg55$i = $563 << 31 >> 31;
      $564 = (($560) + ($$neg55$i))|0;
      $565 = $z$3$lcssa$i;
      $566 = (($565) - ($479))|0;
      $567 = $566 >> 2;
      $568 = ($567*9)|0;
      $569 = (($568) + -9)|0;
      $570 = ($564|0)<($569|0);
      if ($570) {
       $571 = ((($$33$i)) + 4|0);
       $572 = (($564) + 9216)|0;
       $573 = (($572|0) / 9)&-1;
       $574 = (($573) + -1024)|0;
       $575 = (($571) + ($574<<2)|0);
       $576 = (($572|0) % 9)&-1;
       $j$0117$i = (($576) + 1)|0;
       $577 = ($j$0117$i|0)<(9);
       if ($577) {
        $i$1118$i = 10;$j$0119$i = $j$0117$i;
        while(1) {
         $578 = ($i$1118$i*10)|0;
         $j$0$i = (($j$0119$i) + 1)|0;
         $exitcond$i = ($j$0$i|0)==(9);
         if ($exitcond$i) {
          $i$1$lcssa$i = $578;
          break;
         } else {
          $i$1118$i = $578;$j$0119$i = $j$0$i;
         }
        }
       } else {
        $i$1$lcssa$i = 10;
       }
       $579 = HEAP32[$575>>2]|0;
       $580 = (($579>>>0) % ($i$1$lcssa$i>>>0))&-1;
       $581 = ($580|0)==(0);
       $582 = ((($575)) + 4|0);
       $583 = ($582|0)==($z$3$lcssa$i|0);
       $or$cond18$i = $583 & $581;
       do {
        if ($or$cond18$i) {
         $a$8$i = $a$3$lcssa$i;$d$4$i = $575;$e$4$i = $e$1$i;
        } else {
         $584 = (($579>>>0) / ($i$1$lcssa$i>>>0))&-1;
         $585 = $584 & 1;
         $586 = ($585|0)==(0);
         $$20$i = $586 ? 9007199254740992.0 : 9007199254740994.0;
         $587 = (($i$1$lcssa$i|0) / 2)&-1;
         $588 = ($580>>>0)<($587>>>0);
         if ($588) {
          $small$0$i = 0.5;
         } else {
          $589 = ($580|0)==($587|0);
          $or$cond22$i = $583 & $589;
          $$36$i = $or$cond22$i ? 1.0 : 1.5;
          $small$0$i = $$36$i;
         }
         $590 = ($pl$0$i|0)==(0);
         do {
          if ($590) {
           $round6$1$i = $$20$i;$small$1$i = $small$0$i;
          } else {
           $591 = HEAP8[$prefix$0$i>>0]|0;
           $592 = ($591<<24>>24)==(45);
           if (!($592)) {
            $round6$1$i = $$20$i;$small$1$i = $small$0$i;
            break;
           }
           $593 = -$$20$i;
           $594 = -$small$0$i;
           $round6$1$i = $593;$small$1$i = $594;
          }
         } while(0);
         $595 = (($579) - ($580))|0;
         HEAP32[$575>>2] = $595;
         $596 = $round6$1$i + $small$1$i;
         $597 = $596 != $round6$1$i;
         if (!($597)) {
          $a$8$i = $a$3$lcssa$i;$d$4$i = $575;$e$4$i = $e$1$i;
          break;
         }
         $598 = (($595) + ($i$1$lcssa$i))|0;
         HEAP32[$575>>2] = $598;
         $599 = ($598>>>0)>(999999999);
         if ($599) {
          $a$5111$i = $a$3$lcssa$i;$d$2110$i = $575;
          while(1) {
           $600 = ((($d$2110$i)) + -4|0);
           HEAP32[$d$2110$i>>2] = 0;
           $601 = ($600>>>0)<($a$5111$i>>>0);
           if ($601) {
            $602 = ((($a$5111$i)) + -4|0);
            HEAP32[$602>>2] = 0;
            $a$6$i = $602;
           } else {
            $a$6$i = $a$5111$i;
           }
           $603 = HEAP32[$600>>2]|0;
           $604 = (($603) + 1)|0;
           HEAP32[$600>>2] = $604;
           $605 = ($604>>>0)>(999999999);
           if ($605) {
            $a$5111$i = $a$6$i;$d$2110$i = $600;
           } else {
            $a$5$lcssa$i = $a$6$i;$d$2$lcssa$i = $600;
            break;
           }
          }
         } else {
          $a$5$lcssa$i = $a$3$lcssa$i;$d$2$lcssa$i = $575;
         }
         $606 = $a$5$lcssa$i;
         $607 = (($479) - ($606))|0;
         $608 = $607 >> 2;
         $609 = ($608*9)|0;
         $610 = HEAP32[$a$5$lcssa$i>>2]|0;
         $611 = ($610>>>0)<(10);
         if ($611) {
          $a$8$i = $a$5$lcssa$i;$d$4$i = $d$2$lcssa$i;$e$4$i = $609;
          break;
         } else {
          $e$2106$i = $609;$i$2105$i = 10;
         }
         while(1) {
          $612 = ($i$2105$i*10)|0;
          $613 = (($e$2106$i) + 1)|0;
          $614 = ($610>>>0)<($612>>>0);
          if ($614) {
           $a$8$i = $a$5$lcssa$i;$d$4$i = $d$2$lcssa$i;$e$4$i = $613;
           break;
          } else {
           $e$2106$i = $613;$i$2105$i = $612;
          }
         }
        }
       } while(0);
       $615 = ((($d$4$i)) + 4|0);
       $616 = ($z$3$lcssa$i>>>0)>($615>>>0);
       $$z$3$i = $616 ? $615 : $z$3$lcssa$i;
       $a$9$ph$i = $a$8$i;$e$5$ph$i = $e$4$i;$z$7$ph$i = $$z$3$i;
      } else {
       $a$9$ph$i = $a$3$lcssa$i;$e$5$ph$i = $e$1$i;$z$7$ph$i = $z$3$lcssa$i;
      }
      $617 = (0 - ($e$5$ph$i))|0;
      $z$7$i = $z$7$ph$i;
      while(1) {
       $618 = ($z$7$i>>>0)>($a$9$ph$i>>>0);
       if (!($618)) {
        $$lcssa162$i = 0;$z$7$i$lcssa = $z$7$i;
        break;
       }
       $619 = ((($z$7$i)) + -4|0);
       $620 = HEAP32[$619>>2]|0;
       $621 = ($620|0)==(0);
       if ($621) {
        $z$7$i = $619;
       } else {
        $$lcssa162$i = 1;$z$7$i$lcssa = $z$7$i;
        break;
       }
      }
      do {
       if ($561) {
        $622 = $562&1;
        $623 = $622 ^ 1;
        $$p$$i = (($623) + ($$p$i))|0;
        $624 = ($$p$$i|0)>($e$5$ph$i|0);
        $625 = ($e$5$ph$i|0)>(-5);
        $or$cond6$i = $624 & $625;
        if ($or$cond6$i) {
         $626 = (($t$0) + -1)|0;
         $$neg56$i = (($$p$$i) + -1)|0;
         $627 = (($$neg56$i) - ($e$5$ph$i))|0;
         $$013$i = $626;$$210$i = $627;
        } else {
         $628 = (($t$0) + -2)|0;
         $629 = (($$p$$i) + -1)|0;
         $$013$i = $628;$$210$i = $629;
        }
        $630 = $fl$1$ & 8;
        $631 = ($630|0)==(0);
        if (!($631)) {
         $$114$i = $$013$i;$$311$i = $$210$i;$$pre$phi190$iZ2D = $630;
         break;
        }
        do {
         if ($$lcssa162$i) {
          $632 = ((($z$7$i$lcssa)) + -4|0);
          $633 = HEAP32[$632>>2]|0;
          $634 = ($633|0)==(0);
          if ($634) {
           $j$2$i = 9;
           break;
          }
          $635 = (($633>>>0) % 10)&-1;
          $636 = ($635|0)==(0);
          if ($636) {
           $i$3101$i = 10;$j$1102$i = 0;
          } else {
           $j$2$i = 0;
           break;
          }
          while(1) {
           $637 = ($i$3101$i*10)|0;
           $638 = (($j$1102$i) + 1)|0;
           $639 = (($633>>>0) % ($637>>>0))&-1;
           $640 = ($639|0)==(0);
           if ($640) {
            $i$3101$i = $637;$j$1102$i = $638;
           } else {
            $j$2$i = $638;
            break;
           }
          }
         } else {
          $j$2$i = 9;
         }
        } while(0);
        $641 = $$013$i | 32;
        $642 = ($641|0)==(102);
        $643 = $z$7$i$lcssa;
        $644 = (($643) - ($479))|0;
        $645 = $644 >> 2;
        $646 = ($645*9)|0;
        $647 = (($646) + -9)|0;
        if ($642) {
         $648 = (($647) - ($j$2$i))|0;
         $649 = ($648|0)<(0);
         $$23$i = $649 ? 0 : $648;
         $650 = ($$210$i|0)<($$23$i|0);
         $$210$$24$i = $650 ? $$210$i : $$23$i;
         $$114$i = $$013$i;$$311$i = $$210$$24$i;$$pre$phi190$iZ2D = 0;
         break;
        } else {
         $651 = (($647) + ($e$5$ph$i))|0;
         $652 = (($651) - ($j$2$i))|0;
         $653 = ($652|0)<(0);
         $$25$i = $653 ? 0 : $652;
         $654 = ($$210$i|0)<($$25$i|0);
         $$210$$26$i = $654 ? $$210$i : $$25$i;
         $$114$i = $$013$i;$$311$i = $$210$$26$i;$$pre$phi190$iZ2D = 0;
         break;
        }
       } else {
        $$pre189$i = $fl$1$ & 8;
        $$114$i = $t$0;$$311$i = $$p$i;$$pre$phi190$iZ2D = $$pre189$i;
       }
      } while(0);
      $655 = $$311$i | $$pre$phi190$iZ2D;
      $656 = ($655|0)!=(0);
      $657 = $656&1;
      $658 = $$114$i | 32;
      $659 = ($658|0)==(102);
      if ($659) {
       $660 = ($e$5$ph$i|0)>(0);
       $661 = $660 ? $e$5$ph$i : 0;
       $$pn$i = $661;$estr$2$i = 0;
      } else {
       $662 = ($e$5$ph$i|0)<(0);
       $663 = $662 ? $617 : $e$5$ph$i;
       $664 = ($663|0)<(0);
       $665 = $664 << 31 >> 31;
       $666 = (_fmt_u($663,$665,$7)|0);
       $667 = $666;
       $668 = (($9) - ($667))|0;
       $669 = ($668|0)<(2);
       if ($669) {
        $estr$195$i = $666;
        while(1) {
         $670 = ((($estr$195$i)) + -1|0);
         HEAP8[$670>>0] = 48;
         $671 = $670;
         $672 = (($9) - ($671))|0;
         $673 = ($672|0)<(2);
         if ($673) {
          $estr$195$i = $670;
         } else {
          $estr$1$lcssa$i = $670;
          break;
         }
        }
       } else {
        $estr$1$lcssa$i = $666;
       }
       $674 = $e$5$ph$i >> 31;
       $675 = $674 & 2;
       $676 = (($675) + 43)|0;
       $677 = $676&255;
       $678 = ((($estr$1$lcssa$i)) + -1|0);
       HEAP8[$678>>0] = $677;
       $679 = $$114$i&255;
       $680 = ((($estr$1$lcssa$i)) + -2|0);
       HEAP8[$680>>0] = $679;
       $681 = $680;
       $682 = (($9) - ($681))|0;
       $$pn$i = $682;$estr$2$i = $680;
      }
      $683 = (($pl$0$i) + 1)|0;
      $684 = (($683) + ($$311$i))|0;
      $l$1$i = (($684) + ($657))|0;
      $685 = (($l$1$i) + ($$pn$i))|0;
      _pad($f,32,$w$1,$685,$fl$1$);
      $686 = HEAP32[$f>>2]|0;
      $687 = $686 & 32;
      $688 = ($687|0)==(0);
      if ($688) {
       (___fwritex($prefix$0$i,$pl$0$i,$f)|0);
      }
      $689 = $fl$1$ ^ 65536;
      _pad($f,48,$w$1,$685,$689);
      do {
       if ($659) {
        $690 = ($a$9$ph$i>>>0)>($$33$i>>>0);
        $r$0$a$9$i = $690 ? $$33$i : $a$9$ph$i;
        $d$584$i = $r$0$a$9$i;
        while(1) {
         $691 = HEAP32[$d$584$i>>2]|0;
         $692 = (_fmt_u($691,0,$14)|0);
         $693 = ($d$584$i|0)==($r$0$a$9$i|0);
         do {
          if ($693) {
           $699 = ($692|0)==($14|0);
           if (!($699)) {
            $s7$1$i = $692;
            break;
           }
           HEAP8[$16>>0] = 48;
           $s7$1$i = $16;
          } else {
           $694 = ($692>>>0)>($buf$i>>>0);
           if (!($694)) {
            $s7$1$i = $692;
            break;
           }
           $695 = $692;
           $696 = (($695) - ($5))|0;
           _memset(($buf$i|0),48,($696|0))|0;
           $s7$081$i = $692;
           while(1) {
            $697 = ((($s7$081$i)) + -1|0);
            $698 = ($697>>>0)>($buf$i>>>0);
            if ($698) {
             $s7$081$i = $697;
            } else {
             $s7$1$i = $697;
             break;
            }
           }
          }
         } while(0);
         $700 = HEAP32[$f>>2]|0;
         $701 = $700 & 32;
         $702 = ($701|0)==(0);
         if ($702) {
          $703 = $s7$1$i;
          $704 = (($15) - ($703))|0;
          (___fwritex($s7$1$i,$704,$f)|0);
         }
         $705 = ((($d$584$i)) + 4|0);
         $706 = ($705>>>0)>($$33$i>>>0);
         if ($706) {
          $$lcssa316 = $705;
          break;
         } else {
          $d$584$i = $705;
         }
        }
        $707 = ($655|0)==(0);
        do {
         if (!($707)) {
          $708 = HEAP32[$f>>2]|0;
          $709 = $708 & 32;
          $710 = ($709|0)==(0);
          if (!($710)) {
           break;
          }
          (___fwritex(3115,1,$f)|0);
         }
        } while(0);
        $711 = ($$lcssa316>>>0)<($z$7$i$lcssa>>>0);
        $712 = ($$311$i|0)>(0);
        $713 = $712 & $711;
        if ($713) {
         $$41278$i = $$311$i;$d$677$i = $$lcssa316;
         while(1) {
          $714 = HEAP32[$d$677$i>>2]|0;
          $715 = (_fmt_u($714,0,$14)|0);
          $716 = ($715>>>0)>($buf$i>>>0);
          if ($716) {
           $717 = $715;
           $718 = (($717) - ($5))|0;
           _memset(($buf$i|0),48,($718|0))|0;
           $s8$072$i = $715;
           while(1) {
            $719 = ((($s8$072$i)) + -1|0);
            $720 = ($719>>>0)>($buf$i>>>0);
            if ($720) {
             $s8$072$i = $719;
            } else {
             $s8$0$lcssa$i = $719;
             break;
            }
           }
          } else {
           $s8$0$lcssa$i = $715;
          }
          $721 = HEAP32[$f>>2]|0;
          $722 = $721 & 32;
          $723 = ($722|0)==(0);
          if ($723) {
           $724 = ($$41278$i|0)>(9);
           $725 = $724 ? 9 : $$41278$i;
           (___fwritex($s8$0$lcssa$i,$725,$f)|0);
          }
          $726 = ((($d$677$i)) + 4|0);
          $727 = (($$41278$i) + -9)|0;
          $728 = ($726>>>0)<($z$7$i$lcssa>>>0);
          $729 = ($$41278$i|0)>(9);
          $730 = $729 & $728;
          if ($730) {
           $$41278$i = $727;$d$677$i = $726;
          } else {
           $$412$lcssa$i = $727;
           break;
          }
         }
        } else {
         $$412$lcssa$i = $$311$i;
        }
        $731 = (($$412$lcssa$i) + 9)|0;
        _pad($f,48,$731,9,0);
       } else {
        $732 = ((($a$9$ph$i)) + 4|0);
        $z$7$$i = $$lcssa162$i ? $z$7$i$lcssa : $732;
        $733 = ($$311$i|0)>(-1);
        if ($733) {
         $734 = ($$pre$phi190$iZ2D|0)==(0);
         $$589$i = $$311$i;$d$788$i = $a$9$ph$i;
         while(1) {
          $735 = HEAP32[$d$788$i>>2]|0;
          $736 = (_fmt_u($735,0,$14)|0);
          $737 = ($736|0)==($14|0);
          if ($737) {
           HEAP8[$16>>0] = 48;
           $s9$0$i = $16;
          } else {
           $s9$0$i = $736;
          }
          $738 = ($d$788$i|0)==($a$9$ph$i|0);
          do {
           if ($738) {
            $742 = ((($s9$0$i)) + 1|0);
            $743 = HEAP32[$f>>2]|0;
            $744 = $743 & 32;
            $745 = ($744|0)==(0);
            if ($745) {
             (___fwritex($s9$0$i,1,$f)|0);
            }
            $746 = ($$589$i|0)<(1);
            $or$cond31$i = $734 & $746;
            if ($or$cond31$i) {
             $s9$2$i = $742;
             break;
            }
            $747 = HEAP32[$f>>2]|0;
            $748 = $747 & 32;
            $749 = ($748|0)==(0);
            if (!($749)) {
             $s9$2$i = $742;
             break;
            }
            (___fwritex(3115,1,$f)|0);
            $s9$2$i = $742;
           } else {
            $739 = ($s9$0$i>>>0)>($buf$i>>>0);
            if (!($739)) {
             $s9$2$i = $s9$0$i;
             break;
            }
            $scevgep182$i = (($s9$0$i) + ($6)|0);
            $scevgep182183$i = $scevgep182$i;
            _memset(($buf$i|0),48,($scevgep182183$i|0))|0;
            $s9$185$i = $s9$0$i;
            while(1) {
             $740 = ((($s9$185$i)) + -1|0);
             $741 = ($740>>>0)>($buf$i>>>0);
             if ($741) {
              $s9$185$i = $740;
             } else {
              $s9$2$i = $740;
              break;
             }
            }
           }
          } while(0);
          $750 = $s9$2$i;
          $751 = (($15) - ($750))|0;
          $752 = HEAP32[$f>>2]|0;
          $753 = $752 & 32;
          $754 = ($753|0)==(0);
          if ($754) {
           $755 = ($$589$i|0)>($751|0);
           $756 = $755 ? $751 : $$589$i;
           (___fwritex($s9$2$i,$756,$f)|0);
          }
          $757 = (($$589$i) - ($751))|0;
          $758 = ((($d$788$i)) + 4|0);
          $759 = ($758>>>0)<($z$7$$i>>>0);
          $760 = ($757|0)>(-1);
          $761 = $759 & $760;
          if ($761) {
           $$589$i = $757;$d$788$i = $758;
          } else {
           $$5$lcssa$i = $757;
           break;
          }
         }
        } else {
         $$5$lcssa$i = $$311$i;
        }
        $762 = (($$5$lcssa$i) + 18)|0;
        _pad($f,48,$762,18,0);
        $763 = HEAP32[$f>>2]|0;
        $764 = $763 & 32;
        $765 = ($764|0)==(0);
        if (!($765)) {
         break;
        }
        $766 = $estr$2$i;
        $767 = (($9) - ($766))|0;
        (___fwritex($estr$2$i,$767,$f)|0);
       }
      } while(0);
      $768 = $fl$1$ ^ 8192;
      _pad($f,32,$w$1,$685,$768);
      $769 = ($685|0)<($w$1|0);
      $w$32$i = $769 ? $w$1 : $685;
      $$0$i = $w$32$i;
     } else {
      $375 = $t$0 & 32;
      $376 = ($375|0)!=(0);
      $377 = $376 ? 3099 : 3103;
      $378 = ($$07$i != $$07$i) | (0.0 != 0.0);
      $379 = $376 ? 3107 : 3111;
      $pl$1$i = $378 ? 0 : $pl$0$i;
      $s1$0$i = $378 ? $379 : $377;
      $380 = (($pl$1$i) + 3)|0;
      _pad($f,32,$w$1,$380,$176);
      $381 = HEAP32[$f>>2]|0;
      $382 = $381 & 32;
      $383 = ($382|0)==(0);
      if ($383) {
       (___fwritex($prefix$0$i,$pl$1$i,$f)|0);
       $$pre$i = HEAP32[$f>>2]|0;
       $385 = $$pre$i;
      } else {
       $385 = $381;
      }
      $384 = $385 & 32;
      $386 = ($384|0)==(0);
      if ($386) {
       (___fwritex($s1$0$i,3,$f)|0);
      }
      $387 = $fl$1$ ^ 8192;
      _pad($f,32,$w$1,$380,$387);
      $388 = ($380|0)<($w$1|0);
      $389 = $388 ? $w$1 : $380;
      $$0$i = $389;
     }
    } while(0);
    $cnt$0 = $cnt$1;$l$0 = $$0$i;$l10n$0 = $l10n$3;$s$0 = $$lcssa300;
    continue L1;
    break;
   }
   default: {
    $a$2 = $s$0;$fl$6 = $fl$1$;$p$5 = $p$0;$pl$2 = 0;$prefix$2 = 1171;$z$2 = $1;
   }
   }
  } while(0);
  L311: do {
   if ((label|0) == 64) {
    label = 0;
    $207 = $arg;
    $208 = $207;
    $209 = HEAP32[$208>>2]|0;
    $210 = (($207) + 4)|0;
    $211 = $210;
    $212 = HEAP32[$211>>2]|0;
    $213 = $t$1 & 32;
    $214 = ($209|0)==(0);
    $215 = ($212|0)==(0);
    $216 = $214 & $215;
    if ($216) {
     $a$0 = $1;$fl$4 = $fl$3;$p$2 = $p$1;$pl$1 = 0;$prefix$1 = 1171;
     label = 77;
    } else {
     $$012$i = $1;$218 = $209;$225 = $212;
     while(1) {
      $217 = $218 & 15;
      $219 = (1155 + ($217)|0);
      $220 = HEAP8[$219>>0]|0;
      $221 = $220&255;
      $222 = $221 | $213;
      $223 = $222&255;
      $224 = ((($$012$i)) + -1|0);
      HEAP8[$224>>0] = $223;
      $226 = (_bitshift64Lshr(($218|0),($225|0),4)|0);
      $227 = tempRet0;
      $228 = ($226|0)==(0);
      $229 = ($227|0)==(0);
      $230 = $228 & $229;
      if ($230) {
       $$lcssa321 = $224;
       break;
      } else {
       $$012$i = $224;$218 = $226;$225 = $227;
      }
     }
     $231 = $arg;
     $232 = $231;
     $233 = HEAP32[$232>>2]|0;
     $234 = (($231) + 4)|0;
     $235 = $234;
     $236 = HEAP32[$235>>2]|0;
     $237 = ($233|0)==(0);
     $238 = ($236|0)==(0);
     $239 = $237 & $238;
     $240 = $fl$3 & 8;
     $241 = ($240|0)==(0);
     $or$cond17 = $241 | $239;
     if ($or$cond17) {
      $a$0 = $$lcssa321;$fl$4 = $fl$3;$p$2 = $p$1;$pl$1 = 0;$prefix$1 = 1171;
      label = 77;
     } else {
      $242 = $t$1 >> 4;
      $243 = (1171 + ($242)|0);
      $a$0 = $$lcssa321;$fl$4 = $fl$3;$p$2 = $p$1;$pl$1 = 2;$prefix$1 = $243;
      label = 77;
     }
    }
   }
   else if ((label|0) == 76) {
    label = 0;
    $289 = (_fmt_u($287,$288,$1)|0);
    $a$0 = $289;$fl$4 = $fl$1$;$p$2 = $p$0;$pl$1 = $pl$0;$prefix$1 = $prefix$0;
    label = 77;
   }
   else if ((label|0) == 82) {
    label = 0;
    $321 = (_memchr($a$1,0,$p$0)|0);
    $322 = ($321|0)==(0|0);
    $323 = $321;
    $324 = $a$1;
    $325 = (($323) - ($324))|0;
    $326 = (($a$1) + ($p$0)|0);
    $z$1 = $322 ? $326 : $321;
    $p$3 = $322 ? $p$0 : $325;
    $a$2 = $a$1;$fl$6 = $176;$p$5 = $p$3;$pl$2 = 0;$prefix$2 = 1171;$z$2 = $z$1;
   }
   else if ((label|0) == 86) {
    label = 0;
    $i$0105 = 0;$l$1104 = 0;$ws$0106 = $798;
    while(1) {
     $334 = HEAP32[$ws$0106>>2]|0;
     $335 = ($334|0)==(0);
     if ($335) {
      $i$0$lcssa = $i$0105;$l$2 = $l$1104;
      break;
     }
     $336 = (_wctomb($mb,$334)|0);
     $337 = ($336|0)<(0);
     $338 = (($p$4176) - ($i$0105))|0;
     $339 = ($336>>>0)>($338>>>0);
     $or$cond20 = $337 | $339;
     if ($or$cond20) {
      $i$0$lcssa = $i$0105;$l$2 = $336;
      break;
     }
     $340 = ((($ws$0106)) + 4|0);
     $341 = (($336) + ($i$0105))|0;
     $342 = ($p$4176>>>0)>($341>>>0);
     if ($342) {
      $i$0105 = $341;$l$1104 = $336;$ws$0106 = $340;
     } else {
      $i$0$lcssa = $341;$l$2 = $336;
      break;
     }
    }
    $343 = ($l$2|0)<(0);
    if ($343) {
     $$0 = -1;
     break L1;
    }
    _pad($f,32,$w$1,$i$0$lcssa,$fl$1$);
    $344 = ($i$0$lcssa|0)==(0);
    if ($344) {
     $i$0$lcssa178 = 0;
     label = 97;
    } else {
     $i$1116 = 0;$ws$1117 = $798;
     while(1) {
      $345 = HEAP32[$ws$1117>>2]|0;
      $346 = ($345|0)==(0);
      if ($346) {
       $i$0$lcssa178 = $i$0$lcssa;
       label = 97;
       break L311;
      }
      $347 = ((($ws$1117)) + 4|0);
      $348 = (_wctomb($mb,$345)|0);
      $349 = (($348) + ($i$1116))|0;
      $350 = ($349|0)>($i$0$lcssa|0);
      if ($350) {
       $i$0$lcssa178 = $i$0$lcssa;
       label = 97;
       break L311;
      }
      $351 = HEAP32[$f>>2]|0;
      $352 = $351 & 32;
      $353 = ($352|0)==(0);
      if ($353) {
       (___fwritex($mb,$348,$f)|0);
      }
      $354 = ($349>>>0)<($i$0$lcssa>>>0);
      if ($354) {
       $i$1116 = $349;$ws$1117 = $347;
      } else {
       $i$0$lcssa178 = $i$0$lcssa;
       label = 97;
       break;
      }
     }
    }
   }
  } while(0);
  if ((label|0) == 97) {
   label = 0;
   $355 = $fl$1$ ^ 8192;
   _pad($f,32,$w$1,$i$0$lcssa178,$355);
   $356 = ($w$1|0)>($i$0$lcssa178|0);
   $357 = $356 ? $w$1 : $i$0$lcssa178;
   $cnt$0 = $cnt$1;$l$0 = $357;$l10n$0 = $l10n$3;$s$0 = $$lcssa300;
   continue;
  }
  if ((label|0) == 77) {
   label = 0;
   $290 = ($p$2|0)>(-1);
   $291 = $fl$4 & -65537;
   $$fl$4 = $290 ? $291 : $fl$4;
   $292 = $arg;
   $293 = $292;
   $294 = HEAP32[$293>>2]|0;
   $295 = (($292) + 4)|0;
   $296 = $295;
   $297 = HEAP32[$296>>2]|0;
   $298 = ($294|0)!=(0);
   $299 = ($297|0)!=(0);
   $300 = $298 | $299;
   $301 = ($p$2|0)!=(0);
   $or$cond = $301 | $300;
   if ($or$cond) {
    $302 = $a$0;
    $303 = (($2) - ($302))|0;
    $304 = $300&1;
    $305 = $304 ^ 1;
    $306 = (($305) + ($303))|0;
    $307 = ($p$2|0)>($306|0);
    $p$2$ = $307 ? $p$2 : $306;
    $a$2 = $a$0;$fl$6 = $$fl$4;$p$5 = $p$2$;$pl$2 = $pl$1;$prefix$2 = $prefix$1;$z$2 = $1;
   } else {
    $a$2 = $1;$fl$6 = $$fl$4;$p$5 = 0;$pl$2 = $pl$1;$prefix$2 = $prefix$1;$z$2 = $1;
   }
  }
  $770 = $z$2;
  $771 = $a$2;
  $772 = (($770) - ($771))|0;
  $773 = ($p$5|0)<($772|0);
  $$p$5 = $773 ? $772 : $p$5;
  $774 = (($pl$2) + ($$p$5))|0;
  $775 = ($w$1|0)<($774|0);
  $w$2 = $775 ? $774 : $w$1;
  _pad($f,32,$w$2,$774,$fl$6);
  $776 = HEAP32[$f>>2]|0;
  $777 = $776 & 32;
  $778 = ($777|0)==(0);
  if ($778) {
   (___fwritex($prefix$2,$pl$2,$f)|0);
  }
  $779 = $fl$6 ^ 65536;
  _pad($f,48,$w$2,$774,$779);
  _pad($f,48,$$p$5,$772,0);
  $780 = HEAP32[$f>>2]|0;
  $781 = $780 & 32;
  $782 = ($781|0)==(0);
  if ($782) {
   (___fwritex($a$2,$772,$f)|0);
  }
  $783 = $fl$6 ^ 8192;
  _pad($f,32,$w$2,$774,$783);
  $cnt$0 = $cnt$1;$l$0 = $w$2;$l10n$0 = $l10n$3;$s$0 = $$lcssa300;
 }
 L345: do {
  if ((label|0) == 244) {
   $784 = ($f|0)==(0|0);
   if ($784) {
    $785 = ($l10n$0$lcssa|0)==(0);
    if ($785) {
     $$0 = 0;
    } else {
     $i$291 = 1;
     while(1) {
      $786 = (($nl_type) + ($i$291<<2)|0);
      $787 = HEAP32[$786>>2]|0;
      $788 = ($787|0)==(0);
      if ($788) {
       $i$291$lcssa = $i$291;
       break;
      }
      $790 = (($nl_arg) + ($i$291<<3)|0);
      _pop_arg($790,$787,$ap);
      $791 = (($i$291) + 1)|0;
      $792 = ($791|0)<(10);
      if ($792) {
       $i$291 = $791;
      } else {
       $$0 = 1;
       break L345;
      }
     }
     $789 = ($i$291$lcssa|0)<(10);
     if ($789) {
      $i$389 = $i$291$lcssa;
      while(1) {
       $795 = (($nl_type) + ($i$389<<2)|0);
       $796 = HEAP32[$795>>2]|0;
       $797 = ($796|0)==(0);
       $794 = (($i$389) + 1)|0;
       if (!($797)) {
        $$0 = -1;
        break L345;
       }
       $793 = ($794|0)<(10);
       if ($793) {
        $i$389 = $794;
       } else {
        $$0 = 1;
        break;
       }
      }
     } else {
      $$0 = 1;
     }
    }
   } else {
    $$0 = $cnt$1$lcssa;
   }
  }
 } while(0);
 STACKTOP = sp;return ($$0|0);
}
function ___fwritex($s,$l,$f) {
 $s = $s|0;
 $l = $l|0;
 $f = $f|0;
 var $$0 = 0, $$01 = 0, $$02 = 0, $$pre = 0, $$pre6 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0;
 var $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $i$0 = 0, $i$0$lcssa12 = 0;
 var $i$1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = ((($f)) + 16|0);
 $1 = HEAP32[$0>>2]|0;
 $2 = ($1|0)==(0|0);
 if ($2) {
  $4 = (___towrite($f)|0);
  $5 = ($4|0)==(0);
  if ($5) {
   $$pre = HEAP32[$0>>2]|0;
   $9 = $$pre;
   label = 5;
  } else {
   $$0 = 0;
  }
 } else {
  $3 = $1;
  $9 = $3;
  label = 5;
 }
 L5: do {
  if ((label|0) == 5) {
   $6 = ((($f)) + 20|0);
   $7 = HEAP32[$6>>2]|0;
   $8 = (($9) - ($7))|0;
   $10 = ($8>>>0)<($l>>>0);
   $11 = $7;
   if ($10) {
    $12 = ((($f)) + 36|0);
    $13 = HEAP32[$12>>2]|0;
    $14 = (FUNCTION_TABLE_iiii[$13 & 7]($f,$s,$l)|0);
    $$0 = $14;
    break;
   }
   $15 = ((($f)) + 75|0);
   $16 = HEAP8[$15>>0]|0;
   $17 = ($16<<24>>24)>(-1);
   L10: do {
    if ($17) {
     $i$0 = $l;
     while(1) {
      $18 = ($i$0|0)==(0);
      if ($18) {
       $$01 = $l;$$02 = $s;$29 = $11;$i$1 = 0;
       break L10;
      }
      $19 = (($i$0) + -1)|0;
      $20 = (($s) + ($19)|0);
      $21 = HEAP8[$20>>0]|0;
      $22 = ($21<<24>>24)==(10);
      if ($22) {
       $i$0$lcssa12 = $i$0;
       break;
      } else {
       $i$0 = $19;
      }
     }
     $23 = ((($f)) + 36|0);
     $24 = HEAP32[$23>>2]|0;
     $25 = (FUNCTION_TABLE_iiii[$24 & 7]($f,$s,$i$0$lcssa12)|0);
     $26 = ($25>>>0)<($i$0$lcssa12>>>0);
     if ($26) {
      $$0 = $i$0$lcssa12;
      break L5;
     }
     $27 = (($s) + ($i$0$lcssa12)|0);
     $28 = (($l) - ($i$0$lcssa12))|0;
     $$pre6 = HEAP32[$6>>2]|0;
     $$01 = $28;$$02 = $27;$29 = $$pre6;$i$1 = $i$0$lcssa12;
    } else {
     $$01 = $l;$$02 = $s;$29 = $11;$i$1 = 0;
    }
   } while(0);
   _memcpy(($29|0),($$02|0),($$01|0))|0;
   $30 = HEAP32[$6>>2]|0;
   $31 = (($30) + ($$01)|0);
   HEAP32[$6>>2] = $31;
   $32 = (($i$1) + ($$01))|0;
   $$0 = $32;
  }
 } while(0);
 return ($$0|0);
}
function ___towrite($f) {
 $f = $f|0;
 var $$0 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = ((($f)) + 74|0);
 $1 = HEAP8[$0>>0]|0;
 $2 = $1 << 24 >> 24;
 $3 = (($2) + 255)|0;
 $4 = $3 | $2;
 $5 = $4&255;
 HEAP8[$0>>0] = $5;
 $6 = HEAP32[$f>>2]|0;
 $7 = $6 & 8;
 $8 = ($7|0)==(0);
 if ($8) {
  $10 = ((($f)) + 8|0);
  HEAP32[$10>>2] = 0;
  $11 = ((($f)) + 4|0);
  HEAP32[$11>>2] = 0;
  $12 = ((($f)) + 44|0);
  $13 = HEAP32[$12>>2]|0;
  $14 = ((($f)) + 28|0);
  HEAP32[$14>>2] = $13;
  $15 = ((($f)) + 20|0);
  HEAP32[$15>>2] = $13;
  $16 = $13;
  $17 = ((($f)) + 48|0);
  $18 = HEAP32[$17>>2]|0;
  $19 = (($16) + ($18)|0);
  $20 = ((($f)) + 16|0);
  HEAP32[$20>>2] = $19;
  $$0 = 0;
 } else {
  $9 = $6 | 32;
  HEAP32[$f>>2] = $9;
  $$0 = -1;
 }
 return ($$0|0);
}
function _pop_arg($arg,$type,$ap) {
 $arg = $arg|0;
 $type = $type|0;
 $ap = $ap|0;
 var $$mask = 0, $$mask1 = 0, $0 = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0.0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0.0;
 var $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0;
 var $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $arglist_current = 0, $arglist_current11 = 0, $arglist_current14 = 0, $arglist_current17 = 0;
 var $arglist_current2 = 0, $arglist_current20 = 0, $arglist_current23 = 0, $arglist_current26 = 0, $arglist_current5 = 0, $arglist_current8 = 0, $arglist_next = 0, $arglist_next12 = 0, $arglist_next15 = 0, $arglist_next18 = 0, $arglist_next21 = 0, $arglist_next24 = 0, $arglist_next27 = 0, $arglist_next3 = 0, $arglist_next6 = 0, $arglist_next9 = 0, $expanded = 0, $expanded28 = 0, $expanded30 = 0, $expanded31 = 0;
 var $expanded32 = 0, $expanded34 = 0, $expanded35 = 0, $expanded37 = 0, $expanded38 = 0, $expanded39 = 0, $expanded41 = 0, $expanded42 = 0, $expanded44 = 0, $expanded45 = 0, $expanded46 = 0, $expanded48 = 0, $expanded49 = 0, $expanded51 = 0, $expanded52 = 0, $expanded53 = 0, $expanded55 = 0, $expanded56 = 0, $expanded58 = 0, $expanded59 = 0;
 var $expanded60 = 0, $expanded62 = 0, $expanded63 = 0, $expanded65 = 0, $expanded66 = 0, $expanded67 = 0, $expanded69 = 0, $expanded70 = 0, $expanded72 = 0, $expanded73 = 0, $expanded74 = 0, $expanded76 = 0, $expanded77 = 0, $expanded79 = 0, $expanded80 = 0, $expanded81 = 0, $expanded83 = 0, $expanded84 = 0, $expanded86 = 0, $expanded87 = 0;
 var $expanded88 = 0, $expanded90 = 0, $expanded91 = 0, $expanded93 = 0, $expanded94 = 0, $expanded95 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = ($type>>>0)>(20);
 L1: do {
  if (!($0)) {
   do {
    switch ($type|0) {
    case 9:  {
     $arglist_current = HEAP32[$ap>>2]|0;
     $1 = $arglist_current;
     $2 = ((0) + 4|0);
     $expanded28 = $2;
     $expanded = (($expanded28) - 1)|0;
     $3 = (($1) + ($expanded))|0;
     $4 = ((0) + 4|0);
     $expanded32 = $4;
     $expanded31 = (($expanded32) - 1)|0;
     $expanded30 = $expanded31 ^ -1;
     $5 = $3 & $expanded30;
     $6 = $5;
     $7 = HEAP32[$6>>2]|0;
     $arglist_next = ((($6)) + 4|0);
     HEAP32[$ap>>2] = $arglist_next;
     HEAP32[$arg>>2] = $7;
     break L1;
     break;
    }
    case 10:  {
     $arglist_current2 = HEAP32[$ap>>2]|0;
     $8 = $arglist_current2;
     $9 = ((0) + 4|0);
     $expanded35 = $9;
     $expanded34 = (($expanded35) - 1)|0;
     $10 = (($8) + ($expanded34))|0;
     $11 = ((0) + 4|0);
     $expanded39 = $11;
     $expanded38 = (($expanded39) - 1)|0;
     $expanded37 = $expanded38 ^ -1;
     $12 = $10 & $expanded37;
     $13 = $12;
     $14 = HEAP32[$13>>2]|0;
     $arglist_next3 = ((($13)) + 4|0);
     HEAP32[$ap>>2] = $arglist_next3;
     $15 = ($14|0)<(0);
     $16 = $15 << 31 >> 31;
     $17 = $arg;
     $18 = $17;
     HEAP32[$18>>2] = $14;
     $19 = (($17) + 4)|0;
     $20 = $19;
     HEAP32[$20>>2] = $16;
     break L1;
     break;
    }
    case 11:  {
     $arglist_current5 = HEAP32[$ap>>2]|0;
     $21 = $arglist_current5;
     $22 = ((0) + 4|0);
     $expanded42 = $22;
     $expanded41 = (($expanded42) - 1)|0;
     $23 = (($21) + ($expanded41))|0;
     $24 = ((0) + 4|0);
     $expanded46 = $24;
     $expanded45 = (($expanded46) - 1)|0;
     $expanded44 = $expanded45 ^ -1;
     $25 = $23 & $expanded44;
     $26 = $25;
     $27 = HEAP32[$26>>2]|0;
     $arglist_next6 = ((($26)) + 4|0);
     HEAP32[$ap>>2] = $arglist_next6;
     $28 = $arg;
     $29 = $28;
     HEAP32[$29>>2] = $27;
     $30 = (($28) + 4)|0;
     $31 = $30;
     HEAP32[$31>>2] = 0;
     break L1;
     break;
    }
    case 12:  {
     $arglist_current8 = HEAP32[$ap>>2]|0;
     $32 = $arglist_current8;
     $33 = ((0) + 8|0);
     $expanded49 = $33;
     $expanded48 = (($expanded49) - 1)|0;
     $34 = (($32) + ($expanded48))|0;
     $35 = ((0) + 8|0);
     $expanded53 = $35;
     $expanded52 = (($expanded53) - 1)|0;
     $expanded51 = $expanded52 ^ -1;
     $36 = $34 & $expanded51;
     $37 = $36;
     $38 = $37;
     $39 = $38;
     $40 = HEAP32[$39>>2]|0;
     $41 = (($38) + 4)|0;
     $42 = $41;
     $43 = HEAP32[$42>>2]|0;
     $arglist_next9 = ((($37)) + 8|0);
     HEAP32[$ap>>2] = $arglist_next9;
     $44 = $arg;
     $45 = $44;
     HEAP32[$45>>2] = $40;
     $46 = (($44) + 4)|0;
     $47 = $46;
     HEAP32[$47>>2] = $43;
     break L1;
     break;
    }
    case 13:  {
     $arglist_current11 = HEAP32[$ap>>2]|0;
     $48 = $arglist_current11;
     $49 = ((0) + 4|0);
     $expanded56 = $49;
     $expanded55 = (($expanded56) - 1)|0;
     $50 = (($48) + ($expanded55))|0;
     $51 = ((0) + 4|0);
     $expanded60 = $51;
     $expanded59 = (($expanded60) - 1)|0;
     $expanded58 = $expanded59 ^ -1;
     $52 = $50 & $expanded58;
     $53 = $52;
     $54 = HEAP32[$53>>2]|0;
     $arglist_next12 = ((($53)) + 4|0);
     HEAP32[$ap>>2] = $arglist_next12;
     $55 = $54&65535;
     $56 = $55 << 16 >> 16;
     $57 = ($56|0)<(0);
     $58 = $57 << 31 >> 31;
     $59 = $arg;
     $60 = $59;
     HEAP32[$60>>2] = $56;
     $61 = (($59) + 4)|0;
     $62 = $61;
     HEAP32[$62>>2] = $58;
     break L1;
     break;
    }
    case 14:  {
     $arglist_current14 = HEAP32[$ap>>2]|0;
     $63 = $arglist_current14;
     $64 = ((0) + 4|0);
     $expanded63 = $64;
     $expanded62 = (($expanded63) - 1)|0;
     $65 = (($63) + ($expanded62))|0;
     $66 = ((0) + 4|0);
     $expanded67 = $66;
     $expanded66 = (($expanded67) - 1)|0;
     $expanded65 = $expanded66 ^ -1;
     $67 = $65 & $expanded65;
     $68 = $67;
     $69 = HEAP32[$68>>2]|0;
     $arglist_next15 = ((($68)) + 4|0);
     HEAP32[$ap>>2] = $arglist_next15;
     $$mask1 = $69 & 65535;
     $70 = $arg;
     $71 = $70;
     HEAP32[$71>>2] = $$mask1;
     $72 = (($70) + 4)|0;
     $73 = $72;
     HEAP32[$73>>2] = 0;
     break L1;
     break;
    }
    case 15:  {
     $arglist_current17 = HEAP32[$ap>>2]|0;
     $74 = $arglist_current17;
     $75 = ((0) + 4|0);
     $expanded70 = $75;
     $expanded69 = (($expanded70) - 1)|0;
     $76 = (($74) + ($expanded69))|0;
     $77 = ((0) + 4|0);
     $expanded74 = $77;
     $expanded73 = (($expanded74) - 1)|0;
     $expanded72 = $expanded73 ^ -1;
     $78 = $76 & $expanded72;
     $79 = $78;
     $80 = HEAP32[$79>>2]|0;
     $arglist_next18 = ((($79)) + 4|0);
     HEAP32[$ap>>2] = $arglist_next18;
     $81 = $80&255;
     $82 = $81 << 24 >> 24;
     $83 = ($82|0)<(0);
     $84 = $83 << 31 >> 31;
     $85 = $arg;
     $86 = $85;
     HEAP32[$86>>2] = $82;
     $87 = (($85) + 4)|0;
     $88 = $87;
     HEAP32[$88>>2] = $84;
     break L1;
     break;
    }
    case 16:  {
     $arglist_current20 = HEAP32[$ap>>2]|0;
     $89 = $arglist_current20;
     $90 = ((0) + 4|0);
     $expanded77 = $90;
     $expanded76 = (($expanded77) - 1)|0;
     $91 = (($89) + ($expanded76))|0;
     $92 = ((0) + 4|0);
     $expanded81 = $92;
     $expanded80 = (($expanded81) - 1)|0;
     $expanded79 = $expanded80 ^ -1;
     $93 = $91 & $expanded79;
     $94 = $93;
     $95 = HEAP32[$94>>2]|0;
     $arglist_next21 = ((($94)) + 4|0);
     HEAP32[$ap>>2] = $arglist_next21;
     $$mask = $95 & 255;
     $96 = $arg;
     $97 = $96;
     HEAP32[$97>>2] = $$mask;
     $98 = (($96) + 4)|0;
     $99 = $98;
     HEAP32[$99>>2] = 0;
     break L1;
     break;
    }
    case 17:  {
     $arglist_current23 = HEAP32[$ap>>2]|0;
     $100 = $arglist_current23;
     $101 = ((0) + 8|0);
     $expanded84 = $101;
     $expanded83 = (($expanded84) - 1)|0;
     $102 = (($100) + ($expanded83))|0;
     $103 = ((0) + 8|0);
     $expanded88 = $103;
     $expanded87 = (($expanded88) - 1)|0;
     $expanded86 = $expanded87 ^ -1;
     $104 = $102 & $expanded86;
     $105 = $104;
     $106 = +HEAPF64[$105>>3];
     $arglist_next24 = ((($105)) + 8|0);
     HEAP32[$ap>>2] = $arglist_next24;
     HEAPF64[$arg>>3] = $106;
     break L1;
     break;
    }
    case 18:  {
     $arglist_current26 = HEAP32[$ap>>2]|0;
     $107 = $arglist_current26;
     $108 = ((0) + 8|0);
     $expanded91 = $108;
     $expanded90 = (($expanded91) - 1)|0;
     $109 = (($107) + ($expanded90))|0;
     $110 = ((0) + 8|0);
     $expanded95 = $110;
     $expanded94 = (($expanded95) - 1)|0;
     $expanded93 = $expanded94 ^ -1;
     $111 = $109 & $expanded93;
     $112 = $111;
     $113 = +HEAPF64[$112>>3];
     $arglist_next27 = ((($112)) + 8|0);
     HEAP32[$ap>>2] = $arglist_next27;
     HEAPF64[$arg>>3] = $113;
     break L1;
     break;
    }
    default: {
     break L1;
    }
    }
   } while(0);
  }
 } while(0);
 return;
}
function _fmt_u($0,$1,$s) {
 $0 = $0|0;
 $1 = $1|0;
 $s = $s|0;
 var $$0$lcssa = 0, $$01$lcssa$off0 = 0, $$05 = 0, $$1$lcssa = 0, $$12 = 0, $$lcssa19 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $y$03 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = ($1>>>0)>(0);
 $3 = ($0>>>0)>(4294967295);
 $4 = ($1|0)==(0);
 $5 = $4 & $3;
 $6 = $2 | $5;
 if ($6) {
  $$05 = $s;$7 = $0;$8 = $1;
  while(1) {
   $9 = (___uremdi3(($7|0),($8|0),10,0)|0);
   $10 = tempRet0;
   $11 = $9 | 48;
   $12 = $11&255;
   $13 = ((($$05)) + -1|0);
   HEAP8[$13>>0] = $12;
   $14 = (___udivdi3(($7|0),($8|0),10,0)|0);
   $15 = tempRet0;
   $16 = ($8>>>0)>(9);
   $17 = ($7>>>0)>(4294967295);
   $18 = ($8|0)==(9);
   $19 = $18 & $17;
   $20 = $16 | $19;
   if ($20) {
    $$05 = $13;$7 = $14;$8 = $15;
   } else {
    $$lcssa19 = $13;$28 = $14;$29 = $15;
    break;
   }
  }
  $$0$lcssa = $$lcssa19;$$01$lcssa$off0 = $28;
 } else {
  $$0$lcssa = $s;$$01$lcssa$off0 = $0;
 }
 $21 = ($$01$lcssa$off0|0)==(0);
 if ($21) {
  $$1$lcssa = $$0$lcssa;
 } else {
  $$12 = $$0$lcssa;$y$03 = $$01$lcssa$off0;
  while(1) {
   $22 = (($y$03>>>0) % 10)&-1;
   $23 = $22 | 48;
   $24 = $23&255;
   $25 = ((($$12)) + -1|0);
   HEAP8[$25>>0] = $24;
   $26 = (($y$03>>>0) / 10)&-1;
   $27 = ($y$03>>>0)<(10);
   if ($27) {
    $$1$lcssa = $25;
    break;
   } else {
    $$12 = $25;$y$03 = $26;
   }
  }
 }
 return ($$1$lcssa|0);
}
function _strerror($e) {
 $e = $e|0;
 var $$lcssa = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $i$03 = 0, $i$03$lcssa = 0, $i$12 = 0, $s$0$lcssa = 0, $s$01 = 0, $s$1 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $i$03 = 0;
 while(1) {
  $1 = (1181 + ($i$03)|0);
  $2 = HEAP8[$1>>0]|0;
  $3 = $2&255;
  $4 = ($3|0)==($e|0);
  if ($4) {
   $i$03$lcssa = $i$03;
   label = 2;
   break;
  }
  $5 = (($i$03) + 1)|0;
  $6 = ($5|0)==(87);
  if ($6) {
   $i$12 = 87;$s$01 = 1269;
   label = 5;
   break;
  } else {
   $i$03 = $5;
  }
 }
 if ((label|0) == 2) {
  $0 = ($i$03$lcssa|0)==(0);
  if ($0) {
   $s$0$lcssa = 1269;
  } else {
   $i$12 = $i$03$lcssa;$s$01 = 1269;
   label = 5;
  }
 }
 if ((label|0) == 5) {
  while(1) {
   label = 0;
   $s$1 = $s$01;
   while(1) {
    $7 = HEAP8[$s$1>>0]|0;
    $8 = ($7<<24>>24)==(0);
    $9 = ((($s$1)) + 1|0);
    if ($8) {
     $$lcssa = $9;
     break;
    } else {
     $s$1 = $9;
    }
   }
   $10 = (($i$12) + -1)|0;
   $11 = ($10|0)==(0);
   if ($11) {
    $s$0$lcssa = $$lcssa;
    break;
   } else {
    $i$12 = $10;$s$01 = $$lcssa;
    label = 5;
   }
  }
 }
 return ($s$0$lcssa|0);
}
function _pad($f,$c,$w,$l,$fl) {
 $f = $f|0;
 $c = $c|0;
 $w = $w|0;
 $l = $l|0;
 $fl = $fl|0;
 var $$0$lcssa6 = 0, $$02 = 0, $$pre = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $or$cond = 0, $pad = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 256|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $pad = sp;
 $0 = $fl & 73728;
 $1 = ($0|0)==(0);
 $2 = ($w|0)>($l|0);
 $or$cond = $2 & $1;
 do {
  if ($or$cond) {
   $3 = (($w) - ($l))|0;
   $4 = ($3>>>0)>(256);
   $5 = $4 ? 256 : $3;
   _memset(($pad|0),($c|0),($5|0))|0;
   $6 = ($3>>>0)>(255);
   $7 = HEAP32[$f>>2]|0;
   $8 = $7 & 32;
   $9 = ($8|0)==(0);
   if ($6) {
    $10 = (($w) - ($l))|0;
    $$02 = $3;$17 = $7;$18 = $9;
    while(1) {
     if ($18) {
      (___fwritex($pad,256,$f)|0);
      $$pre = HEAP32[$f>>2]|0;
      $14 = $$pre;
     } else {
      $14 = $17;
     }
     $11 = (($$02) + -256)|0;
     $12 = ($11>>>0)>(255);
     $13 = $14 & 32;
     $15 = ($13|0)==(0);
     if ($12) {
      $$02 = $11;$17 = $14;$18 = $15;
     } else {
      break;
     }
    }
    $16 = $10 & 255;
    if ($15) {
     $$0$lcssa6 = $16;
    } else {
     break;
    }
   } else {
    if ($9) {
     $$0$lcssa6 = $3;
    } else {
     break;
    }
   }
   (___fwritex($pad,$$0$lcssa6,$f)|0);
  }
 } while(0);
 STACKTOP = sp;return;
}
function _wctomb($s,$wc) {
 $s = $s|0;
 $wc = $wc|0;
 var $$0 = 0, $0 = 0, $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = ($s|0)==(0|0);
 if ($0) {
  $$0 = 0;
 } else {
  $1 = (_wcrtomb($s,$wc,0)|0);
  $$0 = $1;
 }
 return ($$0|0);
}
function _wcrtomb($s,$wc,$st) {
 $s = $s|0;
 $wc = $wc|0;
 $st = $st|0;
 var $$0 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0;
 var $44 = 0, $45 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = ($s|0)==(0|0);
 do {
  if ($0) {
   $$0 = 1;
  } else {
   $1 = ($wc>>>0)<(128);
   if ($1) {
    $2 = $wc&255;
    HEAP8[$s>>0] = $2;
    $$0 = 1;
    break;
   }
   $3 = ($wc>>>0)<(2048);
   if ($3) {
    $4 = $wc >>> 6;
    $5 = $4 | 192;
    $6 = $5&255;
    $7 = ((($s)) + 1|0);
    HEAP8[$s>>0] = $6;
    $8 = $wc & 63;
    $9 = $8 | 128;
    $10 = $9&255;
    HEAP8[$7>>0] = $10;
    $$0 = 2;
    break;
   }
   $11 = ($wc>>>0)<(55296);
   $12 = $wc & -8192;
   $13 = ($12|0)==(57344);
   $or$cond = $11 | $13;
   if ($or$cond) {
    $14 = $wc >>> 12;
    $15 = $14 | 224;
    $16 = $15&255;
    $17 = ((($s)) + 1|0);
    HEAP8[$s>>0] = $16;
    $18 = $wc >>> 6;
    $19 = $18 & 63;
    $20 = $19 | 128;
    $21 = $20&255;
    $22 = ((($s)) + 2|0);
    HEAP8[$17>>0] = $21;
    $23 = $wc & 63;
    $24 = $23 | 128;
    $25 = $24&255;
    HEAP8[$22>>0] = $25;
    $$0 = 3;
    break;
   }
   $26 = (($wc) + -65536)|0;
   $27 = ($26>>>0)<(1048576);
   if ($27) {
    $28 = $wc >>> 18;
    $29 = $28 | 240;
    $30 = $29&255;
    $31 = ((($s)) + 1|0);
    HEAP8[$s>>0] = $30;
    $32 = $wc >>> 12;
    $33 = $32 & 63;
    $34 = $33 | 128;
    $35 = $34&255;
    $36 = ((($s)) + 2|0);
    HEAP8[$31>>0] = $35;
    $37 = $wc >>> 6;
    $38 = $37 & 63;
    $39 = $38 | 128;
    $40 = $39&255;
    $41 = ((($s)) + 3|0);
    HEAP8[$36>>0] = $40;
    $42 = $wc & 63;
    $43 = $42 | 128;
    $44 = $43&255;
    HEAP8[$41>>0] = $44;
    $$0 = 4;
    break;
   } else {
    $45 = (___errno_location()|0);
    HEAP32[$45>>2] = 84;
    $$0 = -1;
    break;
   }
  }
 } while(0);
 return ($$0|0);
}
function _frexpl($x,$e) {
 $x = +$x;
 $e = $e|0;
 var $0 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = (+_frexp($x,$e));
 return (+$0);
}
function _frexp($x,$e) {
 $x = +$x;
 $e = $e|0;
 var $$0 = 0.0, $$01 = 0.0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0.0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0.0, $7 = 0.0, $8 = 0, $9 = 0, $storemerge = 0, label = 0, sp = 0;
 sp = STACKTOP;
 HEAPF64[tempDoublePtr>>3] = $x;$0 = HEAP32[tempDoublePtr>>2]|0;
 $1 = HEAP32[tempDoublePtr+4>>2]|0;
 $2 = (_bitshift64Lshr(($0|0),($1|0),52)|0);
 $3 = tempRet0;
 $4 = $2 & 2047;
 switch ($4|0) {
 case 0:  {
  $5 = $x != 0.0;
  if ($5) {
   $6 = $x * 1.8446744073709552E+19;
   $7 = (+_frexp($6,$e));
   $8 = HEAP32[$e>>2]|0;
   $9 = (($8) + -64)|0;
   $$01 = $7;$storemerge = $9;
  } else {
   $$01 = $x;$storemerge = 0;
  }
  HEAP32[$e>>2] = $storemerge;
  $$0 = $$01;
  break;
 }
 case 2047:  {
  $$0 = $x;
  break;
 }
 default: {
  $10 = (($4) + -1022)|0;
  HEAP32[$e>>2] = $10;
  $11 = $1 & -2146435073;
  $12 = $11 | 1071644672;
  HEAP32[tempDoublePtr>>2] = $0;HEAP32[tempDoublePtr+4>>2] = $12;$13 = +HEAPF64[tempDoublePtr>>3];
  $$0 = $13;
 }
 }
 return (+$$0);
}
function ___lockfile($f) {
 $f = $f|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0;
}
function _fflush($f) {
 $f = $f|0;
 var $$0 = 0, $$01 = 0, $$012 = 0, $$014 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $phitmp = 0, $r$0$lcssa = 0, $r$03 = 0, $r$1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = ($f|0)==(0|0);
 do {
  if ($0) {
   $7 = (Atomics_load(HEAP32,33)|0);
   $8 = ($7|0)==(0|0);
   if ($8) {
    $27 = 0;
   } else {
    $9 = (Atomics_load(HEAP32,33)|0);
    $10 = (_fflush($9)|0);
    $27 = $10;
   }
   ___lock(((3648)|0));
   $$012 = HEAP32[(3644)>>2]|0;
   $11 = ($$012|0)==(0|0);
   if ($11) {
    $r$0$lcssa = $27;
   } else {
    $$014 = $$012;$r$03 = $27;
    while(1) {
     $12 = ((($$014)) + 76|0);
     $13 = HEAP32[$12>>2]|0;
     $14 = ($13|0)>(-1);
     if ($14) {
      $15 = (___lockfile($$014)|0);
      $24 = $15;
     } else {
      $24 = 0;
     }
     $16 = ((($$014)) + 20|0);
     $17 = HEAP32[$16>>2]|0;
     $18 = ((($$014)) + 28|0);
     $19 = HEAP32[$18>>2]|0;
     $20 = ($17>>>0)>($19>>>0);
     if ($20) {
      $21 = (___fflush_unlocked($$014)|0);
      $22 = $21 | $r$03;
      $r$1 = $22;
     } else {
      $r$1 = $r$03;
     }
     $23 = ($24|0)==(0);
     if (!($23)) {
      ___unlockfile($$014);
     }
     $25 = ((($$014)) + 56|0);
     $$01 = HEAP32[$25>>2]|0;
     $26 = ($$01|0)==(0|0);
     if ($26) {
      $r$0$lcssa = $r$1;
      break;
     } else {
      $$014 = $$01;$r$03 = $r$1;
     }
    }
   }
   ___unlock(((3648)|0));
   $$0 = $r$0$lcssa;
  } else {
   $1 = ((($f)) + 76|0);
   $2 = HEAP32[$1>>2]|0;
   $3 = ($2|0)>(-1);
   if (!($3)) {
    $4 = (___fflush_unlocked($f)|0);
    $$0 = $4;
    break;
   }
   $5 = (___lockfile($f)|0);
   $phitmp = ($5|0)==(0);
   $6 = (___fflush_unlocked($f)|0);
   if ($phitmp) {
    $$0 = $6;
   } else {
    ___unlockfile($f);
    $$0 = $6;
   }
  }
 } while(0);
 return ($$0|0);
}
function ___fflush_unlocked($f) {
 $f = $f|0;
 var $$0 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = ((($f)) + 20|0);
 $1 = HEAP32[$0>>2]|0;
 $2 = ((($f)) + 28|0);
 $3 = HEAP32[$2>>2]|0;
 $4 = ($1>>>0)>($3>>>0);
 if ($4) {
  $5 = ((($f)) + 36|0);
  $6 = HEAP32[$5>>2]|0;
  (FUNCTION_TABLE_iiii[$6 & 7]($f,0,0)|0);
  $7 = HEAP32[$0>>2]|0;
  $8 = ($7|0)==(0|0);
  if ($8) {
   $$0 = -1;
  } else {
   label = 3;
  }
 } else {
  label = 3;
 }
 if ((label|0) == 3) {
  $9 = ((($f)) + 4|0);
  $10 = HEAP32[$9>>2]|0;
  $11 = ((($f)) + 8|0);
  $12 = HEAP32[$11>>2]|0;
  $13 = ($10>>>0)<($12>>>0);
  if ($13) {
   $14 = ((($f)) + 40|0);
   $15 = HEAP32[$14>>2]|0;
   $16 = $10;
   $17 = $12;
   $18 = (($16) - ($17))|0;
   (FUNCTION_TABLE_iiii[$15 & 7]($f,$18,1)|0);
  }
  $19 = ((($f)) + 16|0);
  HEAP32[$19>>2] = 0;
  HEAP32[$2>>2] = 0;
  HEAP32[$0>>2] = 0;
  HEAP32[$11>>2] = 0;
  HEAP32[$9>>2] = 0;
  $$0 = 0;
 }
 return ($$0|0);
}
function _printf($fmt,$varargs) {
 $fmt = $fmt|0;
 $varargs = $varargs|0;
 var $0 = 0, $1 = 0, $ap = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $ap = sp;
 HEAP32[$ap>>2] = $varargs;
 $0 = HEAP32[4]|0;
 $1 = (_vfprintf($0,$fmt,$ap)|0);
 STACKTOP = sp;return ($1|0);
}
function __emscripten_atomic_fetch_and_add_u64($addr,$0,$1) {
 $addr = $addr|0;
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $addr;
 $3 = $2 >>> 3;
 $4 = $3 & 255;
 $5 = (3668 + ($4<<2)|0);
 while(1) {
  $6 = (Atomics_load(HEAP32, $5>>2)|0);
  $7 = (Atomics_compareExchange(HEAP32, $5>>2, $6, 1)|0);
  $8 = ($6|0)==($7|0);
  $9 = ($6|0)==(0);
  $or$cond = $8 & $9;
  if ($or$cond) {
   break;
  }
 }
 $10 = $addr;
 $11 = $10;
 $12 = HEAP32[$11>>2]|0;
 $13 = (($10) + 4)|0;
 $14 = $13;
 $15 = HEAP32[$14>>2]|0;
 $16 = (_i64Add(($12|0),($15|0),($0|0),($1|0))|0);
 $17 = tempRet0;
 $18 = $addr;
 $19 = $18;
 HEAP32[$19>>2] = $16;
 $20 = (($18) + 4)|0;
 $21 = $20;
 HEAP32[$21>>2] = $17;
 $22 = (Atomics_store(HEAP32, $5>>2, 0)|0);
 tempRet0 = ($15);
 return ($12|0);
}
function __emscripten_atomic_fetch_and_and_u64($addr,$0,$1) {
 $addr = $addr|0;
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $addr;
 $3 = $2 >>> 3;
 $4 = $3 & 255;
 $5 = (3668 + ($4<<2)|0);
 while(1) {
  $6 = (Atomics_load(HEAP32, $5>>2)|0);
  $7 = (Atomics_compareExchange(HEAP32, $5>>2, $6, 1)|0);
  $8 = ($6|0)==($7|0);
  $9 = ($6|0)==(0);
  $or$cond = $8 & $9;
  if ($or$cond) {
   break;
  }
 }
 $10 = $addr;
 $11 = $10;
 $12 = HEAP32[$11>>2]|0;
 $13 = (($10) + 4)|0;
 $14 = $13;
 $15 = HEAP32[$14>>2]|0;
 $16 = $12 & $0;
 $17 = $15 & $1;
 $18 = $addr;
 $19 = $18;
 HEAP32[$19>>2] = $16;
 $20 = (($18) + 4)|0;
 $21 = $20;
 HEAP32[$21>>2] = $17;
 $22 = (Atomics_store(HEAP32, $5>>2, 0)|0);
 tempRet0 = ($15);
 return ($12|0);
}
function __emscripten_atomic_fetch_and_or_u64($addr,$0,$1) {
 $addr = $addr|0;
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $addr;
 $3 = $2 >>> 3;
 $4 = $3 & 255;
 $5 = (3668 + ($4<<2)|0);
 while(1) {
  $6 = (Atomics_load(HEAP32, $5>>2)|0);
  $7 = (Atomics_compareExchange(HEAP32, $5>>2, $6, 1)|0);
  $8 = ($6|0)==($7|0);
  $9 = ($6|0)==(0);
  $or$cond = $8 & $9;
  if ($or$cond) {
   break;
  }
 }
 $10 = $addr;
 $11 = $10;
 $12 = HEAP32[$11>>2]|0;
 $13 = (($10) + 4)|0;
 $14 = $13;
 $15 = HEAP32[$14>>2]|0;
 $16 = $12 | $0;
 $17 = $15 | $1;
 $18 = $addr;
 $19 = $18;
 HEAP32[$19>>2] = $16;
 $20 = (($18) + 4)|0;
 $21 = $20;
 HEAP32[$21>>2] = $17;
 $22 = (Atomics_store(HEAP32, $5>>2, 0)|0);
 tempRet0 = ($15);
 return ($12|0);
}
function __emscripten_atomic_fetch_and_sub_u64($addr,$0,$1) {
 $addr = $addr|0;
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $addr;
 $3 = $2 >>> 3;
 $4 = $3 & 255;
 $5 = (3668 + ($4<<2)|0);
 while(1) {
  $6 = (Atomics_load(HEAP32, $5>>2)|0);
  $7 = (Atomics_compareExchange(HEAP32, $5>>2, $6, 1)|0);
  $8 = ($6|0)==($7|0);
  $9 = ($6|0)==(0);
  $or$cond = $8 & $9;
  if ($or$cond) {
   break;
  }
 }
 $10 = $addr;
 $11 = $10;
 $12 = HEAP32[$11>>2]|0;
 $13 = (($10) + 4)|0;
 $14 = $13;
 $15 = HEAP32[$14>>2]|0;
 $16 = (_i64Subtract(($12|0),($15|0),($0|0),($1|0))|0);
 $17 = tempRet0;
 $18 = $addr;
 $19 = $18;
 HEAP32[$19>>2] = $16;
 $20 = (($18) + 4)|0;
 $21 = $20;
 HEAP32[$21>>2] = $17;
 $22 = (Atomics_store(HEAP32, $5>>2, 0)|0);
 tempRet0 = ($15);
 return ($12|0);
}
function __emscripten_atomic_fetch_and_xor_u64($addr,$0,$1) {
 $addr = $addr|0;
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $addr;
 $3 = $2 >>> 3;
 $4 = $3 & 255;
 $5 = (3668 + ($4<<2)|0);
 while(1) {
  $6 = (Atomics_load(HEAP32, $5>>2)|0);
  $7 = (Atomics_compareExchange(HEAP32, $5>>2, $6, 1)|0);
  $8 = ($6|0)==($7|0);
  $9 = ($6|0)==(0);
  $or$cond = $8 & $9;
  if ($or$cond) {
   break;
  }
 }
 $10 = $addr;
 $11 = $10;
 $12 = HEAP32[$11>>2]|0;
 $13 = (($10) + 4)|0;
 $14 = $13;
 $15 = HEAP32[$14>>2]|0;
 $16 = $12 ^ $0;
 $17 = $15 ^ $1;
 $18 = $addr;
 $19 = $18;
 HEAP32[$19>>2] = $16;
 $20 = (($18) + 4)|0;
 $21 = $20;
 HEAP32[$21>>2] = $17;
 $22 = (Atomics_store(HEAP32, $5>>2, 0)|0);
 tempRet0 = ($15);
 return ($12|0);
}
function _emscripten_atomic_add_u64($addr,$0,$1) {
 $addr = $addr|0;
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $addr;
 $3 = $2 >>> 3;
 $4 = $3 & 255;
 $5 = (3668 + ($4<<2)|0);
 while(1) {
  $6 = (Atomics_load(HEAP32, $5>>2)|0);
  $7 = (Atomics_compareExchange(HEAP32, $5>>2, $6, 1)|0);
  $8 = ($6|0)==($7|0);
  $9 = ($6|0)==(0);
  $or$cond = $8 & $9;
  if ($or$cond) {
   break;
  }
 }
 $10 = $addr;
 $11 = $10;
 $12 = HEAP32[$11>>2]|0;
 $13 = (($10) + 4)|0;
 $14 = $13;
 $15 = HEAP32[$14>>2]|0;
 $16 = (_i64Add(($12|0),($15|0),($0|0),($1|0))|0);
 $17 = tempRet0;
 $18 = $addr;
 $19 = $18;
 HEAP32[$19>>2] = $16;
 $20 = (($18) + 4)|0;
 $21 = $20;
 HEAP32[$21>>2] = $17;
 $22 = (Atomics_store(HEAP32, $5>>2, 0)|0);
 tempRet0 = ($17);
 return ($16|0);
}
function _emscripten_atomic_and_u64($addr,$0,$1) {
 $addr = $addr|0;
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $addr;
 $3 = $2 >>> 3;
 $4 = $3 & 255;
 $5 = (3668 + ($4<<2)|0);
 while(1) {
  $6 = (Atomics_load(HEAP32, $5>>2)|0);
  $7 = (Atomics_compareExchange(HEAP32, $5>>2, $6, 1)|0);
  $8 = ($6|0)==($7|0);
  $9 = ($6|0)==(0);
  $or$cond = $8 & $9;
  if ($or$cond) {
   break;
  }
 }
 $10 = $addr;
 $11 = $10;
 $12 = HEAP32[$11>>2]|0;
 $13 = (($10) + 4)|0;
 $14 = $13;
 $15 = HEAP32[$14>>2]|0;
 $16 = $12 & $0;
 $17 = $15 & $1;
 $18 = $addr;
 $19 = $18;
 HEAP32[$19>>2] = $16;
 $20 = (($18) + 4)|0;
 $21 = $20;
 HEAP32[$21>>2] = $17;
 $22 = (Atomics_store(HEAP32, $5>>2, 0)|0);
 tempRet0 = ($17);
 return ($16|0);
}
function _emscripten_atomic_cas_u64($addr,$0,$1,$2,$3) {
 $addr = $addr|0;
 $0 = $0|0;
 $1 = $1|0;
 $2 = $2|0;
 $3 = $3|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $4 = $addr;
 $5 = $4 >>> 3;
 $6 = $5 & 255;
 $7 = (3668 + ($6<<2)|0);
 while(1) {
  $8 = (Atomics_load(HEAP32, $7>>2)|0);
  $9 = (Atomics_compareExchange(HEAP32, $7>>2, $8, 1)|0);
  $10 = ($8|0)==($9|0);
  $11 = ($8|0)==(0);
  $or$cond = $10 & $11;
  if ($or$cond) {
   break;
  }
 }
 $12 = $addr;
 $13 = $12;
 $14 = HEAP32[$13>>2]|0;
 $15 = (($12) + 4)|0;
 $16 = $15;
 $17 = HEAP32[$16>>2]|0;
 $18 = ($14|0)==($0|0);
 $19 = ($17|0)==($1|0);
 $20 = $18 & $19;
 if (!($20)) {
  $25 = (Atomics_store(HEAP32, $7>>2, 0)|0);
  tempRet0 = ($17);
  return ($14|0);
 }
 $21 = $addr;
 $22 = $21;
 HEAP32[$22>>2] = $2;
 $23 = (($21) + 4)|0;
 $24 = $23;
 HEAP32[$24>>2] = $3;
 $25 = (Atomics_store(HEAP32, $7>>2, 0)|0);
 tempRet0 = ($17);
 return ($14|0);
}
function _emscripten_atomic_exchange_u32($addr,$newVal) {
 $addr = $addr|0;
 $newVal = $newVal|0;
 var $$lcssa = 0, $0 = 0, $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 while(1) {
  $0 = (Atomics_load(HEAP32, $addr>>2)|0);
  $1 = (Atomics_compareExchange(HEAP32, $addr>>2, $0, $newVal)|0);
  $2 = ($0|0)==($1|0);
  if ($2) {
   $$lcssa = $0;
   break;
  }
 }
 return ($$lcssa|0);
}
function _emscripten_atomic_exchange_u64($addr,$0,$1) {
 $addr = $addr|0;
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $addr;
 $3 = $2 >>> 3;
 $4 = $3 & 255;
 $5 = (3668 + ($4<<2)|0);
 while(1) {
  $6 = (Atomics_load(HEAP32, $5>>2)|0);
  $7 = (Atomics_compareExchange(HEAP32, $5>>2, $6, 1)|0);
  $8 = ($6|0)==($7|0);
  $9 = ($6|0)==(0);
  $or$cond = $8 & $9;
  if ($or$cond) {
   break;
  }
 }
 $10 = $addr;
 $11 = $10;
 $12 = HEAP32[$11>>2]|0;
 $13 = (($10) + 4)|0;
 $14 = $13;
 $15 = HEAP32[$14>>2]|0;
 $16 = $addr;
 $17 = $16;
 HEAP32[$17>>2] = $0;
 $18 = (($16) + 4)|0;
 $19 = $18;
 HEAP32[$19>>2] = $1;
 $20 = (Atomics_store(HEAP32, $5>>2, 0)|0);
 tempRet0 = ($15);
 return ($12|0);
}
function _emscripten_atomic_load_f32($addr) {
 $addr = $addr|0;
 var $0 = 0, $1 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = (Atomics_load(HEAP32, $addr>>2)|0);
 $1 = (HEAP32[tempDoublePtr>>2]=$0,+HEAPF32[tempDoublePtr>>2]);
 return (+$1);
}
function _emscripten_atomic_load_f64($addr) {
 $addr = $addr|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0.0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = $addr;
 $1 = $0 >>> 3;
 $2 = $1 & 255;
 $3 = (3668 + ($2<<2)|0);
 while(1) {
  $4 = (Atomics_load(HEAP32, $3>>2)|0);
  $5 = (Atomics_compareExchange(HEAP32, $3>>2, $4, 1)|0);
  $6 = ($4|0)==($5|0);
  $7 = ($4|0)==(0);
  $or$cond = $6 & $7;
  if ($or$cond) {
   break;
  }
 }
 $8 = +HEAPF64[$addr>>3];
 $9 = (Atomics_store(HEAP32, $3>>2, 0)|0);
 return (+$8);
}
function _emscripten_atomic_load_u64($addr) {
 $addr = $addr|0;
 var $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = $addr;
 $1 = $0 >>> 3;
 $2 = $1 & 255;
 $3 = (3668 + ($2<<2)|0);
 while(1) {
  $4 = (Atomics_load(HEAP32, $3>>2)|0);
  $5 = (Atomics_compareExchange(HEAP32, $3>>2, $4, 1)|0);
  $6 = ($4|0)==($5|0);
  $7 = ($4|0)==(0);
  $or$cond = $6 & $7;
  if ($or$cond) {
   break;
  }
 }
 $8 = $addr;
 $9 = $8;
 $10 = HEAP32[$9>>2]|0;
 $11 = (($8) + 4)|0;
 $12 = $11;
 $13 = HEAP32[$12>>2]|0;
 $14 = (Atomics_store(HEAP32, $3>>2, 0)|0);
 tempRet0 = ($13);
 return ($10|0);
}
function _emscripten_atomic_or_u64($addr,$0,$1) {
 $addr = $addr|0;
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $addr;
 $3 = $2 >>> 3;
 $4 = $3 & 255;
 $5 = (3668 + ($4<<2)|0);
 while(1) {
  $6 = (Atomics_load(HEAP32, $5>>2)|0);
  $7 = (Atomics_compareExchange(HEAP32, $5>>2, $6, 1)|0);
  $8 = ($6|0)==($7|0);
  $9 = ($6|0)==(0);
  $or$cond = $8 & $9;
  if ($or$cond) {
   break;
  }
 }
 $10 = $addr;
 $11 = $10;
 $12 = HEAP32[$11>>2]|0;
 $13 = (($10) + 4)|0;
 $14 = $13;
 $15 = HEAP32[$14>>2]|0;
 $16 = $12 | $0;
 $17 = $15 | $1;
 $18 = $addr;
 $19 = $18;
 HEAP32[$19>>2] = $16;
 $20 = (($18) + 4)|0;
 $21 = $20;
 HEAP32[$21>>2] = $17;
 $22 = (Atomics_store(HEAP32, $5>>2, 0)|0);
 tempRet0 = ($17);
 return ($16|0);
}
function _emscripten_atomic_store_f32($addr,$val) {
 $addr = $addr|0;
 $val = +$val;
 var $0 = 0, $1 = 0, $2 = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = (HEAPF32[tempDoublePtr>>2]=$val,HEAP32[tempDoublePtr>>2]|0);
 $1 = (Atomics_store(HEAP32, $addr>>2, $0)|0);
 $2 = (+($1>>>0));
 return (+$2);
}
function _emscripten_atomic_store_f64($addr,$val) {
 $addr = $addr|0;
 $val = +$val;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = $addr;
 $1 = $0 >>> 3;
 $2 = $1 & 255;
 $3 = (3668 + ($2<<2)|0);
 while(1) {
  $4 = (Atomics_load(HEAP32, $3>>2)|0);
  $5 = (Atomics_compareExchange(HEAP32, $3>>2, $4, 1)|0);
  $6 = ($4|0)==($5|0);
  $7 = ($4|0)==(0);
  $or$cond = $6 & $7;
  if ($or$cond) {
   break;
  }
 }
 HEAPF64[$addr>>3] = $val;
 $8 = (Atomics_store(HEAP32, $3>>2, 0)|0);
 return (+$val);
}
function _emscripten_atomic_store_u64($addr,$0,$1) {
 $addr = $addr|0;
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $addr;
 $3 = $2 >>> 3;
 $4 = $3 & 255;
 $5 = (3668 + ($4<<2)|0);
 while(1) {
  $6 = (Atomics_load(HEAP32, $5>>2)|0);
  $7 = (Atomics_compareExchange(HEAP32, $5>>2, $6, 1)|0);
  $8 = ($6|0)==($7|0);
  $9 = ($6|0)==(0);
  $or$cond = $8 & $9;
  if ($or$cond) {
   break;
  }
 }
 $10 = $addr;
 $11 = $10;
 HEAP32[$11>>2] = $0;
 $12 = (($10) + 4)|0;
 $13 = $12;
 HEAP32[$13>>2] = $1;
 $14 = (Atomics_store(HEAP32, $5>>2, 0)|0);
 tempRet0 = ($1);
 return ($0|0);
}
function _emscripten_atomic_sub_u64($addr,$0,$1) {
 $addr = $addr|0;
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $addr;
 $3 = $2 >>> 3;
 $4 = $3 & 255;
 $5 = (3668 + ($4<<2)|0);
 while(1) {
  $6 = (Atomics_load(HEAP32, $5>>2)|0);
  $7 = (Atomics_compareExchange(HEAP32, $5>>2, $6, 1)|0);
  $8 = ($6|0)==($7|0);
  $9 = ($6|0)==(0);
  $or$cond = $8 & $9;
  if ($or$cond) {
   break;
  }
 }
 $10 = $addr;
 $11 = $10;
 $12 = HEAP32[$11>>2]|0;
 $13 = (($10) + 4)|0;
 $14 = $13;
 $15 = HEAP32[$14>>2]|0;
 $16 = (_i64Subtract(($12|0),($15|0),($0|0),($1|0))|0);
 $17 = tempRet0;
 $18 = $addr;
 $19 = $18;
 HEAP32[$19>>2] = $16;
 $20 = (($18) + 4)|0;
 $21 = $20;
 HEAP32[$21>>2] = $17;
 $22 = (Atomics_store(HEAP32, $5>>2, 0)|0);
 tempRet0 = ($17);
 return ($16|0);
}
function _emscripten_atomic_xor_u64($addr,$0,$1) {
 $addr = $addr|0;
 $0 = $0|0;
 $1 = $1|0;
 var $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $2 = $addr;
 $3 = $2 >>> 3;
 $4 = $3 & 255;
 $5 = (3668 + ($4<<2)|0);
 while(1) {
  $6 = (Atomics_load(HEAP32, $5>>2)|0);
  $7 = (Atomics_compareExchange(HEAP32, $5>>2, $6, 1)|0);
  $8 = ($6|0)==($7|0);
  $9 = ($6|0)==(0);
  $or$cond = $8 & $9;
  if ($or$cond) {
   break;
  }
 }
 $10 = $addr;
 $11 = $10;
 $12 = HEAP32[$11>>2]|0;
 $13 = (($10) + 4)|0;
 $14 = $13;
 $15 = HEAP32[$14>>2]|0;
 $16 = $12 ^ $0;
 $17 = $15 ^ $1;
 $18 = $addr;
 $19 = $18;
 HEAP32[$19>>2] = $16;
 $20 = (($18) + 4)|0;
 $21 = $20;
 HEAP32[$21>>2] = $17;
 $22 = (Atomics_store(HEAP32, $5>>2, 0)|0);
 tempRet0 = ($17);
 return ($16|0);
}
function _emscripten_main_thread_process_queued_calls() {
 var $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $i$02 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = (_emscripten_is_main_runtime_thread()|0);
 $1 = ($0|0)==(0);
 if ($1) {
  ___assert_fail((3117|0),(3239|0),436,(3322|0));
  // unreachable;
 }
 $2 = (_emscripten_is_main_runtime_thread()|0);
 $3 = ($2|0)==(0);
 $4 = HEAP32[1173]|0;
 $5 = ($4|0)!=(0);
 $or$cond = $3 | $5;
 if ($or$cond) {
  return;
 }
 HEAP32[1173] = 1;
 (_pthread_mutex_lock(4696)|0);
 $6 = HEAP32[1181]|0;
 $7 = ($6|0)>(0);
 if ($7) {
  $i$02 = 0;
  while(1) {
   $8 = (4736 + ($i$02<<2)|0);
   $9 = HEAP32[$8>>2]|0;
   __do_call($9);
   $10 = (($i$02) + 1)|0;
   $11 = HEAP32[1181]|0;
   $12 = ($10|0)<($11|0);
   if ($12) {
    $i$02 = $10;
   } else {
    break;
   }
  }
 }
 HEAP32[1181] = 0;
 HEAP32[1173] = 0;
 (_pthread_mutex_unlock(4696)|0);
 return;
}
function _pthread_mutex_lock($m) {
 $m = $m|0;
 var $$0 = 0, $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[$m>>2]|0;
 $1 = ($0|0)==(0);
 if ($1) {
  $2 = ((($m)) + 4|0);
  $3 = (Atomics_compareExchange(HEAP32, $2>>2, 0, 16)|0);
  $4 = ($3|0)==(0);
  if ($4) {
   $$0 = 0;
   return ($$0|0);
  }
 }
 $5 = (_pthread_mutex_timedlock($m,0)|0);
 $$0 = $5;
 return ($$0|0);
}
function _pthread_mutex_timedlock($m,$at) {
 $m = $m|0;
 $at = $at|0;
 var $$0 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[$m>>2]|0;
 $1 = ($0|0)==(0);
 if ($1) {
  $2 = ((($m)) + 4|0);
  $3 = (Atomics_compareExchange(HEAP32, $2>>2, 0, 16)|0);
  $4 = ($3|0)==(0);
  if ($4) {
   $$0 = 0;
   return ($$0|0);
  }
 }
 $5 = (_pthread_mutex_trylock($m)|0);
 $6 = ($5|0)==(16);
 if (!($6)) {
  $$0 = $5;
  return ($$0|0);
 }
 $7 = ((($m)) + 4|0);
 $8 = ((($m)) + 8|0);
 L8: while(1) {
  $9 = HEAP32[$7>>2]|0;
  $10 = ($9|0)!=(0);
  $11 = $9 & 1073741824;
  $12 = ($11|0)==(0);
  $or$cond3 = $10 & $12;
  if ($or$cond3) {
   $15 = HEAP32[$m>>2]|0;
   $16 = $15 & 3;
   $17 = ($16|0)==(2);
   if ($17) {
    $18 = $9 & 536870911;
    $19 = (_pthread_self()|0);
    $20 = ((($19)) + 48|0);
    $21 = HEAP32[$20>>2]|0;
    $22 = ($18|0)==($21|0);
    if ($22) {
     $$0 = 35;
     label = 10;
     break;
    }
   }
   $23 = (Atomics_add(HEAP32, $8>>2, 1)|0);
   $24 = $9 | -2147483648;
   $25 = (Atomics_compareExchange(HEAP32, $7>>2, $9, $24)|0);
   $26 = (___timedwait($7,$24,0,$at,0,0,0)|0);
   $27 = (Atomics_sub(HEAP32, $8>>2, 1)|0);
   switch ($26|0) {
   case 0: case 4:  {
    break;
   }
   default: {
    $$0 = $26;
    label = 10;
    break L8;
   }
   }
  }
  $13 = (_pthread_mutex_trylock($m)|0);
  $14 = ($13|0)==(16);
  if (!($14)) {
   $$0 = $13;
   label = 10;
   break;
  }
 }
 if ((label|0) == 10) {
  return ($$0|0);
 }
 return (0)|0;
}
function _pthread_mutex_trylock($m) {
 $m = $m|0;
 var $$0 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0;
 var $9 = 0, $or$cond = 0, $or$cond3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[$m>>2]|0;
 $1 = ($0|0)==(0);
 if ($1) {
  $2 = ((($m)) + 4|0);
  $3 = (Atomics_compareExchange(HEAP32, $2>>2, 0, 16)|0);
  $4 = $3 & 16;
  $$0 = $4;
  return ($$0|0);
 }
 $5 = (_pthread_self()|0);
 $6 = ((($5)) + 48|0);
 $7 = HEAP32[$6>>2]|0;
 $8 = ($0|0)>(3);
 if ($8) {
  $9 = ((($m)) + 16|0);
  $10 = ((($5)) + 164|0);
  HEAP32[$10>>2] = -12;
  $11 = ((($5)) + 168|0);
  HEAP32[$11>>2] = $9;
 }
 $12 = ((($m)) + 4|0);
 $13 = HEAP32[$12>>2]|0;
 $14 = $13 & 2147483647;
 $15 = ($14|0)==($7|0);
 $16 = $0 & 3;
 $17 = ($16|0)==(1);
 $or$cond3 = $15 & $17;
 if ($or$cond3) {
  $18 = ((($m)) + 20|0);
  $19 = HEAP32[$18>>2]|0;
  $20 = ($19>>>0)>(2147483646);
  if ($20) {
   $$0 = 11;
   return ($$0|0);
  }
  $21 = (($19) + 1)|0;
  HEAP32[$18>>2] = $21;
  $$0 = 0;
  return ($$0|0);
 }
 $22 = ($14|0)!=(0);
 $23 = $13 & 1073741824;
 $24 = ($23|0)==(0);
 $or$cond = $22 & $24;
 if ($or$cond) {
  $$0 = 16;
  return ($$0|0);
 }
 $25 = (Atomics_compareExchange(HEAP32, $12>>2, $13, $7)|0);
 $26 = ($25|0)==($13|0);
 if (!($26)) {
  $$0 = 16;
  return ($$0|0);
 }
 $27 = HEAP32[$m>>2]|0;
 $28 = ($27|0)<(4);
 if ($28) {
  $$0 = 0;
  return ($$0|0);
 }
 $29 = ($27|0)>(7);
 if ($29) {
  HEAP32[$12>>2] = 0;
  $$0 = 131;
  return ($$0|0);
 }
 $30 = ((($5)) + 160|0);
 $31 = HEAP32[$30>>2]|0;
 $32 = ((($m)) + 16|0);
 HEAP32[$32>>2] = $31;
 $33 = ((($m)) + 12|0);
 HEAP32[$33>>2] = $30;
 $34 = HEAP32[$30>>2]|0;
 $35 = ($34|0)==(0|0);
 if (!($35)) {
  $36 = ((($34)) + -4|0);
  HEAP32[$36>>2] = $32;
 }
 HEAP32[$30>>2] = $32;
 $37 = ((($5)) + 168|0);
 HEAP32[$37>>2] = 0;
 if (!($22)) {
  $$0 = 0;
  return ($$0|0);
 }
 $38 = ((($m)) + 20|0);
 HEAP32[$38>>2] = 0;
 $39 = (($27) + 8)|0;
 HEAP32[$m>>2] = $39;
 $$0 = 130;
 return ($$0|0);
}
function ___timedwait($addr,$val,$clk,$at,$cleanup,$arg,$priv) {
 $addr = $addr|0;
 $val = $val|0;
 $clk = $clk|0;
 $at = $at|0;
 $cleanup = $cleanup|0;
 $arg = $arg|0;
 $priv = $priv|0;
 var $$1$i = 0, $$waitMsecs$0$us$us$i = 0.0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0.0;
 var $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0.0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0;
 var $43 = 0, $44 = 0, $45 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $cs = 0, $to$i = 0, $waitMsecs$0$us$us$i = 0.0, $waitMsecs$0$us7$i = 0.0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $to$i = sp + 8|0;
 $cs = sp;
 $0 = ($cleanup|0)!=(0|0);
 if (!($0)) {
  (_pthread_setcancelstate(1,$cs)|0);
 }
 _pthread_cleanup_push(($cleanup|0),($arg|0));
 _emscripten_conditional_set_current_thread_status(1,4);
 $1 = ($at|0)!=(0|0);
 if ($1) {
  $2 = ((($at)) + 4|0);
  $3 = HEAP32[$2>>2]|0;
  $4 = ($3>>>0)>(999999999);
  if ($4) {
   $$1$i = 22;
  } else {
   $5 = (_clock_gettime(($clk|0),($to$i|0))|0);
   $6 = ($5|0)==(0);
   if ($6) {
    $7 = HEAP32[$at>>2]|0;
    $8 = HEAP32[$to$i>>2]|0;
    $9 = (($7) - ($8))|0;
    HEAP32[$to$i>>2] = $9;
    $10 = HEAP32[$2>>2]|0;
    $11 = ((($to$i)) + 4|0);
    $12 = HEAP32[$11>>2]|0;
    $13 = (($10) - ($12))|0;
    HEAP32[$11>>2] = $13;
    $14 = ($13|0)<(0);
    if ($14) {
     $15 = (($9) + -1)|0;
     HEAP32[$to$i>>2] = $15;
     $16 = (($13) + 1000000000)|0;
     HEAP32[$11>>2] = $16;
     $18 = $15;
    } else {
     $18 = $9;
    }
    $17 = ($18|0)<(0);
    if ($17) {
     $$1$i = 110;
    } else {
     label = 9;
    }
   } else {
    $$1$i = 22;
   }
  }
 } else {
  label = 9;
 }
 L11: do {
  if ((label|0) == 9) {
   $19 = (_emscripten_is_main_runtime_thread()|0);
   $20 = (_pthread_self()|0);
   $21 = ($19|0)==(0);
   if ($21) {
    if (!($1)) {
     L16: while(1) {
      $41 = (__pthread_isduecanceled($20)|0);
      $42 = ($41|0)==(0);
      if (!($42)) {
       $$1$i = 125;
       break L11;
      }
      $43 = (_emscripten_futex_wait(($addr|0),($val|0),100.0)|0);
      $44 = (0 - ($43))|0;
      switch ($44|0) {
      case 22: case 4:  {
       $$1$i = $44;
       break L11;
       break;
      }
      case 110:  {
       break;
      }
      default: {
       break L16;
      }
      }
     }
     $$1$i = 0;
     break;
    }
    L20: while(1) {
     $34 = (__pthread_isduecanceled($20)|0);
     $35 = ($34|0)==(0);
     if (!($35)) {
      $$1$i = 125;
      break L11;
     }
     $36 = (+__pthread_msecs_until($at));
     $37 = !($36 <= 0.0);
     if (!($37)) {
      $$1$i = 110;
      break L11;
     }
     $38 = $36 > 100.0;
     $waitMsecs$0$us7$i = $38 ? 100.0 : $36;
     $39 = (_emscripten_futex_wait(($addr|0),($val|0),(+$waitMsecs$0$us7$i))|0);
     $40 = (0 - ($39))|0;
     switch ($40|0) {
     case 22: case 4:  {
      $$1$i = $40;
      break L11;
      break;
     }
     case 110:  {
      break;
     }
     default: {
      break L20;
     }
     }
    }
    $$1$i = 0;
    break;
   } else {
    if (!($1)) {
     L27: while(1) {
      $30 = (__pthread_isduecanceled($20)|0);
      $31 = ($30|0)==(0);
      if (!($31)) {
       $$1$i = 125;
       break L11;
      }
      _emscripten_main_thread_process_queued_calls();
      $32 = (_emscripten_futex_wait(($addr|0),($val|0),1.0)|0);
      $33 = (0 - ($32))|0;
      switch ($33|0) {
      case 22: case 4:  {
       $$1$i = $33;
       break L11;
       break;
      }
      case 110:  {
       break;
      }
      default: {
       break L27;
      }
      }
     }
     $$1$i = 0;
     break;
    }
    L31: while(1) {
     $22 = (__pthread_isduecanceled($20)|0);
     $23 = ($22|0)==(0);
     if (!($23)) {
      $$1$i = 125;
      break L11;
     }
     _emscripten_main_thread_process_queued_calls();
     $24 = (+__pthread_msecs_until($at));
     $25 = !($24 <= 0.0);
     if (!($25)) {
      $$1$i = 110;
      break L11;
     }
     $26 = $24 > 100.0;
     $waitMsecs$0$us$us$i = $26 ? 100.0 : $24;
     $27 = $waitMsecs$0$us$us$i > 1.0;
     $$waitMsecs$0$us$us$i = $27 ? 1.0 : $waitMsecs$0$us$us$i;
     $28 = (_emscripten_futex_wait(($addr|0),($val|0),(+$$waitMsecs$0$us$us$i))|0);
     $29 = (0 - ($28))|0;
     switch ($29|0) {
     case 22: case 4:  {
      $$1$i = $29;
      break L11;
      break;
     }
     case 110:  {
      break;
     }
     default: {
      break L31;
     }
     }
    }
    $$1$i = 0;
    break;
   }
  }
 } while(0);
 _emscripten_conditional_set_current_thread_status(4,1);
 _pthread_cleanup_pop(0);
 if ($0) {
  STACKTOP = sp;return ($$1$i|0);
 }
 $45 = HEAP32[$cs>>2]|0;
 (_pthread_setcancelstate($45,0)|0);
 STACKTOP = sp;return ($$1$i|0);
}
function _pthread_setcancelstate($new,$old) {
 $new = $new|0;
 $old = $old|0;
 var $$0 = 0, $$pre = 0, $0 = 0, $1 = 0, $2 = 0, $3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = ($new>>>0)>(1);
 if ($0) {
  $$0 = 22;
  return ($$0|0);
 }
 $1 = (_pthread_self()|0);
 $2 = ($old|0)==(0|0);
 $$pre = ((($1)) + 72|0);
 if (!($2)) {
  $3 = (Atomics_load(HEAP32,$$pre>>2)|0);
  HEAP32[$old>>2] = $3;
 }
 Atomics_store(HEAP32,$$pre>>2,$new)|0;
 $$0 = 0;
 return ($$0|0);
}
function __pthread_isduecanceled($pthread_ptr) {
 $pthread_ptr = $pthread_ptr|0;
 var $0 = 0, $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[$pthread_ptr>>2]|0;
 $1 = ($0|0)==(2);
 $2 = $1&1;
 return ($2|0);
}
function __pthread_msecs_until($at) {
 $at = $at|0;
 var $0 = 0, $1 = 0.0, $10 = 0.0, $11 = 0, $12 = 0, $13 = 0.0, $14 = 0.0, $15 = 0.0, $16 = 0.0, $2 = 0.0, $3 = 0, $4 = 0, $5 = 0.0, $6 = 0.0, $7 = 0.0, $8 = 0, $9 = 0.0, $t = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $t = sp;
 (_gettimeofday(($t|0),(0|0))|0);
 $0 = HEAP32[$t>>2]|0;
 $1 = (+($0|0));
 $2 = $1 * 1000.0;
 $3 = ((($t)) + 4|0);
 $4 = HEAP32[$3>>2]|0;
 $5 = (+($4|0));
 $6 = $5 * 0.001;
 $7 = $2 + $6;
 $8 = HEAP32[$at>>2]|0;
 $9 = (+($8|0));
 $10 = $9 * 1000.0;
 $11 = ((($at)) + 4|0);
 $12 = HEAP32[$11>>2]|0;
 $13 = (+($12|0));
 $14 = $13 * 9.9999999999999995E-7;
 $15 = $10 + $14;
 $16 = $15 - $7;
 STACKTOP = sp;return (+$16);
}
function _pthread_mutex_unlock($m) {
 $m = $m|0;
 var $$0 = 0, $$lcssa = 0, $$pre = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $or$cond = 0, $robust$0 = 0, $self$0 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $0 = ((($m)) + 8|0);
 $1 = HEAP32[$0>>2]|0;
 $2 = HEAP32[$m>>2]|0;
 $3 = ($2|0)==(0);
 $$pre = ((($m)) + 4|0);
 if ($3) {
  $robust$0 = 0;$self$0 = 0;
 } else {
  $4 = HEAP32[$$pre>>2]|0;
  $5 = ($4|0)==(0);
  if ($5) {
   $$0 = 1;
   return ($$0|0);
  }
  $6 = (_pthread_self()|0);
  $7 = $4 & 536870911;
  $8 = ((($6)) + 48|0);
  $9 = HEAP32[$8>>2]|0;
  $10 = ($7|0)==($9|0);
  if (!($10)) {
   $$0 = 1;
   return ($$0|0);
  }
  $11 = $2 & 3;
  $12 = ($11|0)==(1);
  if ($12) {
   $13 = ((($m)) + 20|0);
   $14 = HEAP32[$13>>2]|0;
   $15 = ($14|0)==(0);
   if (!($15)) {
    $16 = (($14) + -1)|0;
    HEAP32[$13>>2] = $16;
    $$0 = 0;
    return ($$0|0);
   }
  }
  $17 = ($2|0)>(3);
  if ($17) {
   $18 = ((($m)) + 16|0);
   $19 = ((($6)) + 168|0);
   HEAP32[$19>>2] = $18;
   $20 = HEAP32[$18>>2]|0;
   $21 = ((($m)) + 12|0);
   $22 = HEAP32[$21>>2]|0;
   HEAP32[$22>>2] = $20;
   $23 = HEAP32[$18>>2]|0;
   $24 = ($23|0)==(0|0);
   if (!($24)) {
    $25 = HEAP32[$21>>2]|0;
    $26 = ((($23)) + -4|0);
    HEAP32[$26>>2] = $25;
   }
   ___vm_lock_22(1);
   $robust$0 = 1;$self$0 = $6;
  } else {
   $robust$0 = 0;$self$0 = $6;
  }
 }
 while(1) {
  $27 = (Atomics_load(HEAP32, $$pre>>2)|0);
  $28 = (Atomics_compareExchange(HEAP32, $$pre>>2, $27, 0)|0);
  $29 = ($28|0)==($27|0);
  if ($29) {
   $$lcssa = $27;
   break;
  }
 }
 if ($robust$0) {
  $30 = ((($self$0)) + 168|0);
  HEAP32[$30>>2] = 0;
  ___vm_unlock_25();
 }
 $31 = ($1|0)!=(0);
 $32 = ($$lcssa|0)<(0);
 $or$cond = $31 | $32;
 if (!($or$cond)) {
  $$0 = 0;
  return ($$0|0);
 }
 (_emscripten_futex_wake(($$pre|0),1)|0);
 $$0 = 0;
 return ($$0|0);
}
function ___vm_lock_22($inc) {
 $inc = $inc|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 while(1) {
  $0 = HEAP32[1182]|0;
  $1 = Math_imul($0, $inc)|0;
  $2 = ($1|0)<(0);
  if ($2) {
   ___wait(4728,(4732),$0,1);
   continue;
  } else {
   $3 = (($0) + ($inc))|0;
   $4 = (Atomics_compareExchange(HEAP32, 1182, $0, $3)|0);
   $5 = ($4|0)==($0|0);
   if ($5) {
    break;
   } else {
    continue;
   }
  }
 }
 return;
}
function ___wait($addr,$waiters,$val,$priv) {
 $addr = $addr|0;
 $waiters = $waiters|0;
 $val = $val|0;
 $priv = $priv|0;
 var $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0.0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $spins$0 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $spins$0 = 10000;
 while(1) {
  $0 = ($spins$0|0)==(0);
  if ($0) {
   break;
  }
  $1 = (($spins$0) + -1)|0;
  $2 = (Atomics_load(HEAP32,$addr>>2)|0);
  $3 = ($2|0)==($val|0);
  if ($3) {
   $spins$0 = $1;
  } else {
   label = 22;
   break;
  }
 }
 if ((label|0) == 22) {
  return;
 }
 $4 = ($waiters|0)!=(0|0);
 if ($4) {
  $5 = (Atomics_add(HEAP32, $waiters>>2, 1)|0);
 }
 $6 = (_emscripten_is_main_runtime_thread()|0);
 $7 = (Atomics_load(HEAP32,$addr>>2)|0);
 $8 = ($7|0)==($val|0);
 L10: do {
  if ($8) {
   $9 = (_pthread_self()|0);
   $10 = ((($9)) + 76|0);
   $11 = ($6|0)!=(0);
   $12 = $11 ? 1.0 : 100.0;
   L12: do {
    if ($11) {
     while(1) {
      $13 = (Atomics_load(HEAP32,$10>>2)|0);
      $14 = ($13|0)==(1);
      if ($14) {
       while(1) {
        $17 = (__pthread_isduecanceled($9)|0);
        $18 = ($17|0)==(0);
        if (!($18)) {
         break L12;
        }
        _emscripten_main_thread_process_queued_calls();
        $19 = (_emscripten_futex_wait(($addr|0),($val|0),(+$12))|0);
        $20 = ($19|0)==(-110);
        if (!($20)) {
         break;
        }
       }
      } else {
       (_emscripten_futex_wait(($addr|0),($val|0),inf)|0);
      }
      $15 = (Atomics_load(HEAP32,$addr>>2)|0);
      $16 = ($15|0)==($val|0);
      if (!($16)) {
       break L10;
      }
     }
    } else {
     while(1) {
      $21 = (Atomics_load(HEAP32,$10>>2)|0);
      $22 = ($21|0)==(1);
      if ($22) {
       while(1) {
        $23 = (__pthread_isduecanceled($9)|0);
        $24 = ($23|0)==(0);
        if (!($24)) {
         break L12;
        }
        $26 = (_emscripten_futex_wait(($addr|0),($val|0),(+$12))|0);
        $27 = ($26|0)==(-110);
        if (!($27)) {
         break;
        }
       }
      } else {
       (_emscripten_futex_wait(($addr|0),($val|0),inf)|0);
      }
      $28 = (Atomics_load(HEAP32,$addr>>2)|0);
      $29 = ($28|0)==($val|0);
      if (!($29)) {
       break L10;
      }
     }
    }
   } while(0);
   if (!($4)) {
    return;
   }
   $25 = (Atomics_sub(HEAP32, $waiters>>2, 1)|0);
   return;
  }
 } while(0);
 if (!($4)) {
  return;
 }
 $30 = (Atomics_sub(HEAP32, $waiters>>2, 1)|0);
 return;
}
function ___vm_unlock_25() {
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $or$cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[1182]|0;
 $1 = ($0|0)>(0);
 $2 = $1 ? -1 : 1;
 $3 = (Atomics_add(HEAP32, 1182, $2)|0);
 $4 = (0 - ($2))|0;
 $5 = ($3|0)==($4|0);
 $6 = HEAP32[(4732)>>2]|0;
 $7 = ($6|0)!=(0);
 $or$cond = $5 & $7;
 if (!($or$cond)) {
  return;
 }
 (_emscripten_futex_wake((4728|0),2147483647)|0);
 return;
}
function __do_call($q) {
 $q = $q|0;
 var $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0;
 var $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0;
 var $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0;
 var $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0;
 var $81 = 0, $9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = HEAP32[$q>>2]|0;
 do {
  switch ($0|0) {
  case 12:  {
   $1 = ((($q)) + 8|0);
   $2 = HEAP32[$1>>2]|0;
   $3 = ((($q)) + 16|0);
   $4 = HEAP32[$3>>2]|0;
   $5 = (_utime(($2|0),($4|0))|0);
   $6 = ((($q)) + 72|0);
   HEAP32[$6>>2] = $5;
   break;
  }
  case 13:  {
   $7 = ((($q)) + 8|0);
   $8 = HEAP32[$7>>2]|0;
   $9 = ((($q)) + 16|0);
   $10 = HEAP32[$9>>2]|0;
   $11 = (_utimes(($8|0),($10|0))|0);
   $12 = ((($q)) + 72|0);
   HEAP32[$12>>2] = $11;
   break;
  }
  case 37:  {
   $13 = ((($q)) + 8|0);
   $14 = HEAP32[$13>>2]|0;
   $15 = (_chroot(($14|0))|0);
   $16 = ((($q)) + 72|0);
   HEAP32[$16>>2] = $15;
   break;
  }
  case 46:  {
   $17 = ((($q)) + 8|0);
   $18 = HEAP32[$17>>2]|0;
   $19 = ((($q)) + 16|0);
   $20 = HEAP32[$19>>2]|0;
   $21 = (_fpathconf(($18|0),($20|0))|0);
   $22 = ((($q)) + 72|0);
   HEAP32[$22>>2] = $21;
   break;
  }
  case 68:  {
   $23 = ((($q)) + 8|0);
   $24 = HEAP32[$23>>2]|0;
   $25 = ((($q)) + 16|0);
   $26 = HEAP32[$25>>2]|0;
   $27 = ((($q)) + 24|0);
   $28 = HEAP32[$27>>2]|0;
   $29 = (_confstr(($24|0),($26|0),($28|0))|0);
   $30 = ((($q)) + 72|0);
   HEAP32[$30>>2] = $29;
   break;
  }
  case 72:  {
   $31 = ((($q)) + 8|0);
   $32 = HEAP32[$31>>2]|0;
   $33 = (_sysconf(($32|0))|0);
   $34 = ((($q)) + 72|0);
   HEAP32[$34>>2] = $33;
   break;
  }
  case 73:  {
   $35 = ((($q)) + 8|0);
   $36 = HEAP32[$35>>2]|0;
   $37 = (_sbrk(($36|0))|0);
   $38 = ((($q)) + 72|0);
   HEAP32[$38>>2] = $37;
   break;
  }
  case 110:  {
   $39 = ((($q)) + 8|0);
   $40 = HEAP32[$39>>2]|0;
   $41 = (_atexit(($40|0))|0);
   $42 = ((($q)) + 72|0);
   HEAP32[$42>>2] = $41;
   break;
  }
  case 111:  {
   $43 = ((($q)) + 8|0);
   $44 = HEAP32[$43>>2]|0;
   $45 = (_getenv(($44|0))|0);
   $46 = ((($q)) + 72|0);
   HEAP32[$46>>2] = $45;
   break;
  }
  case 112:  {
   $47 = (_clearenv()|0);
   $48 = ((($q)) + 72|0);
   HEAP32[$48>>2] = $47;
   break;
  }
  case 113:  {
   $49 = ((($q)) + 8|0);
   $50 = HEAP32[$49>>2]|0;
   $51 = ((($q)) + 16|0);
   $52 = HEAP32[$51>>2]|0;
   $53 = ((($q)) + 24|0);
   $54 = HEAP32[$53>>2]|0;
   $55 = (_setenv(($50|0),($52|0),($54|0))|0);
   $56 = ((($q)) + 72|0);
   HEAP32[$56>>2] = $55;
   break;
  }
  case 114:  {
   $57 = ((($q)) + 8|0);
   $58 = HEAP32[$57>>2]|0;
   $59 = (_unsetenv(($58|0))|0);
   $60 = ((($q)) + 72|0);
   HEAP32[$60>>2] = $59;
   break;
  }
  case 115:  {
   $61 = ((($q)) + 8|0);
   $62 = HEAP32[$61>>2]|0;
   $63 = (_putenv(($62|0))|0);
   $64 = ((($q)) + 72|0);
   HEAP32[$64>>2] = $63;
   break;
  }
  case 119:  {
   _tzset();
   break;
  }
  case 137:  {
   $65 = ((($q)) + 8|0);
   $66 = HEAP32[$65>>2]|0;
   $67 = ((($q)) + 16|0);
   $68 = HEAP32[$67>>2]|0;
   $69 = ((($q)) + 24|0);
   $70 = HEAP32[$69>>2]|0;
   $71 = ((($q)) + 32|0);
   $72 = HEAP32[$71>>2]|0;
   $73 = (_pthread_create(($66|0),($68|0),($70|0),($72|0))|0);
   $74 = ((($q)) + 72|0);
   HEAP32[$74>>2] = $73;
   break;
  }
  case 138:  {
   $75 = ((($q)) + 8|0);
   $76 = HEAP32[$75>>2]|0;
   $77 = ((($q)) + 16|0);
   $78 = HEAP32[$77>>2]|0;
   $79 = (_emscripten_syscall(($76|0),($78|0))|0);
   $80 = ((($q)) + 72|0);
   HEAP32[$80>>2] = $79;
   break;
  }
  default: {
   ___assert_fail((3366|0),(3239|0),280,(3417|0));
   // unreachable;
  }
  }
 } while(0);
 $81 = ((($q)) + 4|0);
 HEAP32[$81>>2] = 1;
 (_emscripten_futex_wake(($81|0),2147483647)|0);
 return;
}
function _emscripten_sync_run_in_main_thread($call) {
 $call = $call|0;
 var $$expand_i1_val = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $call_queue$init$val = 0, $call_queue$init$val$pre_trunc = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = ($call|0)==(0|0);
 if ($0) {
  ___assert_fail((3426|0),(3239|0),293,(3431|0));
  // unreachable;
 }
 $1 = (_emscripten_is_main_runtime_thread()|0);
 $2 = ($1|0)==(0);
 if (!($2)) {
  __do_call($call);
  return;
 }
 (_pthread_mutex_lock(4696)|0);
 $call_queue$init$val$pre_trunc = HEAP8[7344]|0;
 $call_queue$init$val = $call_queue$init$val$pre_trunc&1;
 if (!($call_queue$init$val)) {
  $$expand_i1_val = 1;
  HEAP8[7344] = $$expand_i1_val;
 }
 $3 = HEAP32[1181]|0;
 $4 = ($3|0)<(128);
 if (!($4)) {
  ___assert_fail((3466|0),(3239|0),302,(3431|0));
  // unreachable;
 }
 $5 = (4736 + ($3<<2)|0);
 HEAP32[$5>>2] = $call;
 $6 = (($3) + 1)|0;
 HEAP32[1181] = $6;
 $7 = ($3|0)==(0);
 if ($7) {
  _emscripten_asm_const_v(4);
 }
 (_pthread_mutex_unlock(4696)|0);
 _emscripten_set_current_thread_status(5);
 $8 = ((($call)) + 4|0);
 while(1) {
  $9 = (_emscripten_futex_wait(($8|0),0,inf)|0);
  $10 = ($9|0)==(0);
  if ($10) {
   break;
  }
  $11 = HEAP32[$8>>2]|0;
  $12 = ($11|0)==(0);
  if (!($12)) {
   break;
  }
 }
 _emscripten_set_current_thread_status(1);
 return;
}
function _emscripten_sync_run_in_main_thread_0($function) {
 $function = $function|0;
 var $0 = 0, $1 = 0, $q = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $q = sp;
 dest=$q; stop=dest+80|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0));
 HEAP32[$q>>2] = $function;
 $0 = ((($q)) + 72|0);
 HEAP32[$0>>2] = 0;
 _emscripten_sync_run_in_main_thread($q);
 $1 = HEAP32[$0>>2]|0;
 STACKTOP = sp;return ($1|0);
}
function _emscripten_sync_run_in_main_thread_1($function,$arg1) {
 $function = $function|0;
 $arg1 = $arg1|0;
 var $0 = 0, $1 = 0, $2 = 0, $q = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $q = sp;
 dest=$q; stop=dest+80|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0));
 HEAP32[$q>>2] = $function;
 $0 = ((($q)) + 8|0);
 HEAP32[$0>>2] = $arg1;
 $1 = ((($q)) + 72|0);
 HEAP32[$1>>2] = 0;
 _emscripten_sync_run_in_main_thread($q);
 $2 = HEAP32[$1>>2]|0;
 STACKTOP = sp;return ($2|0);
}
function _emscripten_sync_run_in_main_thread_2($function,$arg1,$arg2) {
 $function = $function|0;
 $arg1 = $arg1|0;
 $arg2 = $arg2|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $q = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $q = sp;
 dest=$q; stop=dest+80|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0));
 HEAP32[$q>>2] = $function;
 $0 = ((($q)) + 8|0);
 HEAP32[$0>>2] = $arg1;
 $1 = ((($q)) + 16|0);
 HEAP32[$1>>2] = $arg2;
 $2 = ((($q)) + 72|0);
 HEAP32[$2>>2] = 0;
 _emscripten_sync_run_in_main_thread($q);
 $3 = HEAP32[$2>>2]|0;
 STACKTOP = sp;return ($3|0);
}
function _emscripten_sync_run_in_main_thread_3($function,$arg1,$arg2,$arg3) {
 $function = $function|0;
 $arg1 = $arg1|0;
 $arg2 = $arg2|0;
 $arg3 = $arg3|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $q = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $q = sp;
 dest=$q; stop=dest+80|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0));
 HEAP32[$q>>2] = $function;
 $0 = ((($q)) + 8|0);
 HEAP32[$0>>2] = $arg1;
 $1 = ((($q)) + 16|0);
 HEAP32[$1>>2] = $arg2;
 $2 = ((($q)) + 24|0);
 HEAP32[$2>>2] = $arg3;
 $3 = ((($q)) + 72|0);
 HEAP32[$3>>2] = 0;
 _emscripten_sync_run_in_main_thread($q);
 $4 = HEAP32[$3>>2]|0;
 STACKTOP = sp;return ($4|0);
}
function _emscripten_sync_run_in_main_thread_4($function,$arg1,$arg2,$arg3,$arg4) {
 $function = $function|0;
 $arg1 = $arg1|0;
 $arg2 = $arg2|0;
 $arg3 = $arg3|0;
 $arg4 = $arg4|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $q = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $q = sp;
 dest=$q; stop=dest+80|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0));
 HEAP32[$q>>2] = $function;
 $0 = ((($q)) + 8|0);
 HEAP32[$0>>2] = $arg1;
 $1 = ((($q)) + 16|0);
 HEAP32[$1>>2] = $arg2;
 $2 = ((($q)) + 24|0);
 HEAP32[$2>>2] = $arg3;
 $3 = ((($q)) + 32|0);
 HEAP32[$3>>2] = $arg4;
 $4 = ((($q)) + 72|0);
 HEAP32[$4>>2] = 0;
 _emscripten_sync_run_in_main_thread($q);
 $5 = HEAP32[$4>>2]|0;
 STACKTOP = sp;return ($5|0);
}
function _emscripten_sync_run_in_main_thread_5($function,$arg1,$arg2,$arg3,$arg4,$arg5) {
 $function = $function|0;
 $arg1 = $arg1|0;
 $arg2 = $arg2|0;
 $arg3 = $arg3|0;
 $arg4 = $arg4|0;
 $arg5 = $arg5|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $q = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $q = sp;
 dest=$q; stop=dest+80|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0));
 HEAP32[$q>>2] = $function;
 $0 = ((($q)) + 8|0);
 HEAP32[$0>>2] = $arg1;
 $1 = ((($q)) + 16|0);
 HEAP32[$1>>2] = $arg2;
 $2 = ((($q)) + 24|0);
 HEAP32[$2>>2] = $arg3;
 $3 = ((($q)) + 32|0);
 HEAP32[$3>>2] = $arg4;
 $4 = ((($q)) + 40|0);
 HEAP32[$4>>2] = $arg5;
 $5 = ((($q)) + 72|0);
 HEAP32[$5>>2] = 0;
 _emscripten_sync_run_in_main_thread($q);
 $6 = HEAP32[$5>>2]|0;
 STACKTOP = sp;return ($6|0);
}
function _emscripten_sync_run_in_main_thread_6($function,$arg1,$arg2,$arg3,$arg4,$arg5,$arg6) {
 $function = $function|0;
 $arg1 = $arg1|0;
 $arg2 = $arg2|0;
 $arg3 = $arg3|0;
 $arg4 = $arg4|0;
 $arg5 = $arg5|0;
 $arg6 = $arg6|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $q = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $q = sp;
 dest=$q; stop=dest+80|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0));
 HEAP32[$q>>2] = $function;
 $0 = ((($q)) + 8|0);
 HEAP32[$0>>2] = $arg1;
 $1 = ((($q)) + 16|0);
 HEAP32[$1>>2] = $arg2;
 $2 = ((($q)) + 24|0);
 HEAP32[$2>>2] = $arg3;
 $3 = ((($q)) + 32|0);
 HEAP32[$3>>2] = $arg4;
 $4 = ((($q)) + 40|0);
 HEAP32[$4>>2] = $arg5;
 $5 = ((($q)) + 48|0);
 HEAP32[$5>>2] = $arg6;
 $6 = ((($q)) + 72|0);
 HEAP32[$6>>2] = 0;
 _emscripten_sync_run_in_main_thread($q);
 $7 = HEAP32[$6>>2]|0;
 STACKTOP = sp;return ($7|0);
}
function _emscripten_sync_run_in_main_thread_7($function,$arg1,$arg2,$arg3,$arg4,$arg5,$arg6,$arg7) {
 $function = $function|0;
 $arg1 = $arg1|0;
 $arg2 = $arg2|0;
 $arg3 = $arg3|0;
 $arg4 = $arg4|0;
 $arg5 = $arg5|0;
 $arg6 = $arg6|0;
 $arg7 = $arg7|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $q = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $q = sp;
 dest=$q; stop=dest+80|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0));
 HEAP32[$q>>2] = $function;
 $0 = ((($q)) + 8|0);
 HEAP32[$0>>2] = $arg1;
 $1 = ((($q)) + 16|0);
 HEAP32[$1>>2] = $arg2;
 $2 = ((($q)) + 24|0);
 HEAP32[$2>>2] = $arg3;
 $3 = ((($q)) + 32|0);
 HEAP32[$3>>2] = $arg4;
 $4 = ((($q)) + 40|0);
 HEAP32[$4>>2] = $arg5;
 $5 = ((($q)) + 48|0);
 HEAP32[$5>>2] = $arg6;
 $6 = ((($q)) + 56|0);
 HEAP32[$6>>2] = $arg7;
 $7 = ((($q)) + 72|0);
 HEAP32[$7>>2] = 0;
 _emscripten_sync_run_in_main_thread($q);
 $8 = HEAP32[$7>>2]|0;
 STACKTOP = sp;return ($8|0);
}
function _emscripten_sync_run_in_main_thread_xprintf_varargs($function,$param0,$format,$varargs) {
 $function = $function|0;
 $param0 = $param0|0;
 $format = $format|0;
 $varargs = $varargs|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $args = 0, $q = 0, $s$0 = 0, $str = 0, dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 224|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $args = sp + 80|0;
 $str = sp + 96|0;
 $q = sp;
 HEAP32[$args>>2] = $varargs;
 $0 = (_vsnprintf($str,128,$format,$args)|0);
 $1 = ($0|0)>(127);
 if ($1) {
  $2 = (($0) + 1)|0;
  $3 = (_malloc($2)|0);
  HEAP32[$args>>2] = $varargs;
  (_vsnprintf($3,$2,$format,$args)|0);
  $s$0 = $3;
 } else {
  $s$0 = $str;
 }
 dest=$q; stop=dest+80|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0));
 HEAP32[$q>>2] = $function;
 $4 = $param0;
 $5 = ((($q)) + 8|0);
 HEAP32[$5>>2] = $4;
 $6 = ((($q)) + 16|0);
 HEAP32[$6>>2] = $s$0;
 $7 = ((($q)) + 72|0);
 HEAP32[$7>>2] = 0;
 _emscripten_sync_run_in_main_thread($q);
 $8 = ($s$0|0)==($str|0);
 if ($8) {
  $9 = HEAP32[$7>>2]|0;
  STACKTOP = sp;return ($9|0);
 }
 _free($s$0);
 $9 = HEAP32[$7>>2]|0;
 STACKTOP = sp;return ($9|0);
}
function ___pthread_tsd_run_dtors() {
 var $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $exitcond = 0, $i$02 = 0;
 var $j$03 = 0, $not_finished$11 = 0, $not_finished$2 = 0, $not_finished$2$lcssa = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = (_pthread_self()|0);
 $1 = ((($0)) + 56|0);
 $2 = HEAP32[$1>>2]|0;
 $3 = ($2|0)==(0);
 if ($3) {
  return;
 }
 $4 = ((($0)) + 116|0);
 $j$03 = 0;
 while(1) {
  $i$02 = 0;$not_finished$11 = 0;
  while(1) {
   $5 = HEAP32[$4>>2]|0;
   $6 = (($5) + ($i$02<<2)|0);
   $7 = HEAP32[$6>>2]|0;
   $8 = ($7|0)==(0|0);
   if ($8) {
    $not_finished$2 = $not_finished$11;
   } else {
    $9 = (5248 + ($i$02<<2)|0);
    $10 = HEAP32[$9>>2]|0;
    $11 = ($10|0)==(0|0);
    if ($11) {
     $not_finished$2 = $not_finished$11;
    } else {
     HEAP32[$6>>2] = 0;
     $12 = HEAP32[$9>>2]|0;
     FUNCTION_TABLE_vi[$12 & 7]($7);
     $not_finished$2 = 1;
    }
   }
   $13 = (($i$02) + 1)|0;
   $exitcond = ($13|0)==(128);
   if ($exitcond) {
    $not_finished$2$lcssa = $not_finished$2;
    break;
   } else {
    $i$02 = $13;$not_finished$11 = $not_finished$2;
   }
  }
  $14 = (($j$03) + 1)|0;
  $15 = ($not_finished$2$lcssa|0)!=(0);
  $16 = ($14|0)<(4);
  $17 = $16 & $15;
  if ($17) {
   $j$03 = $14;
  } else {
   break;
  }
 }
 return;
}
function _pthread_attr_destroy($a) {
 $a = $a|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0;
}
function _pthread_attr_init($a) {
 $a = $a|0;
 var dest = 0, label = 0, sp = 0, stop = 0;
 sp = STACKTOP;
 dest=$a; stop=dest+36|0; do { HEAP32[dest>>2]=0|0; dest=dest+4|0; } while ((dest|0) < (stop|0));
 return 0;
}
function _pthread_attr_setdetachstate($a,$state) {
 $a = $a|0;
 $state = $state|0;
 var $$0 = 0, $0 = 0, $1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = ($state>>>0)>(1);
 if ($0) {
  $$0 = 22;
  return ($$0|0);
 }
 $1 = ((($a)) + 12|0);
 HEAP32[$1>>2] = $state;
 $$0 = 0;
 return ($$0|0);
}
function _pthread_mutexattr_destroy($a) {
 $a = $a|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0;
}
function _pthread_mutexattr_init($a) {
 $a = $a|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 HEAP32[$a>>2] = 0;
 return 0;
}
function _pthread_mutex_init($m,$a) {
 $m = $m|0;
 $a = $a|0;
 var $0 = 0, $1 = 0, $2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 ;HEAP32[$m>>2]=0|0;HEAP32[$m+4>>2]=0|0;HEAP32[$m+8>>2]=0|0;HEAP32[$m+12>>2]=0|0;HEAP32[$m+16>>2]=0|0;HEAP32[$m+20>>2]=0|0;HEAP32[$m+24>>2]=0|0;
 $0 = ($a|0)==(0|0);
 if ($0) {
  return 0;
 }
 $1 = HEAP32[$a>>2]|0;
 $2 = $1 & 7;
 HEAP32[$m>>2] = $2;
 return 0;
}
function _malloc($bytes) {
 $bytes = $bytes|0;
 var $$1 = 0, $$lcssa = 0, $$lcssa142 = 0, $$lcssa143 = 0, $$lcssa145 = 0, $$lcssa148 = 0, $$lcssa150 = 0, $$lcssa152 = 0, $$lcssa154 = 0, $$lcssa156 = 0, $$lcssa158 = 0, $$pre = 0, $$pre$i = 0, $$pre$i$i = 0, $$pre$i13 = 0, $$pre$i16$i = 0, $$pre$phi$i$iZ2D = 0, $$pre$phi$i14Z2D = 0, $$pre$phi$i17$iZ2D = 0, $$pre$phi$iZ2D = 0;
 var $$pre$phi10$i$iZ2D = 0, $$pre$phiZ2D = 0, $$pre72 = 0, $$pre9$i$i = 0, $$rsize$0$i = 0, $$rsize$4$i = 0, $$v$0$i = 0, $0 = 0, $1 = 0, $10 = 0, $100 = 0, $1000 = 0, $1001 = 0, $1002 = 0, $1003 = 0, $1004 = 0, $1005 = 0, $1006 = 0, $1007 = 0, $1008 = 0;
 var $1009 = 0, $101 = 0, $1010 = 0, $1011 = 0, $1012 = 0, $1013 = 0, $1014 = 0, $1015 = 0, $1016 = 0, $1017 = 0, $1018 = 0, $1019 = 0, $102 = 0, $1020 = 0, $1021 = 0, $1022 = 0, $1023 = 0, $1024 = 0, $1025 = 0, $1026 = 0;
 var $1027 = 0, $1028 = 0, $1029 = 0, $103 = 0, $1030 = 0, $1031 = 0, $1032 = 0, $1033 = 0, $1034 = 0, $1035 = 0, $1036 = 0, $1037 = 0, $1038 = 0, $1039 = 0, $104 = 0, $1040 = 0, $1041 = 0, $1042 = 0, $1043 = 0, $1044 = 0;
 var $1045 = 0, $1046 = 0, $1047 = 0, $1048 = 0, $1049 = 0, $105 = 0, $1050 = 0, $1051 = 0, $1052 = 0, $1053 = 0, $1054 = 0, $1055 = 0, $1056 = 0, $1057 = 0, $1058 = 0, $1059 = 0, $106 = 0, $1060 = 0, $1061 = 0, $1062 = 0;
 var $1063 = 0, $1064 = 0, $1065 = 0, $1066 = 0, $1067 = 0, $1068 = 0, $1069 = 0, $107 = 0, $1070 = 0, $1071 = 0, $1072 = 0, $1073 = 0, $1074 = 0, $1075 = 0, $1076 = 0, $1077 = 0, $1078 = 0, $1079 = 0, $108 = 0, $1080 = 0;
 var $1081 = 0, $1082 = 0, $1083 = 0, $1084 = 0, $1085 = 0, $1086 = 0, $1087 = 0, $1088 = 0, $1089 = 0, $109 = 0, $1090 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0;
 var $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0;
 var $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0;
 var $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0;
 var $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0;
 var $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0;
 var $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0, $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0;
 var $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0, $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0;
 var $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0, $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0;
 var $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0, $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0;
 var $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0, $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0;
 var $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0, $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0;
 var $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0, $326 = 0, $327 = 0, $328 = 0, $329 = 0, $33 = 0, $330 = 0, $331 = 0, $332 = 0, $333 = 0;
 var $334 = 0, $335 = 0, $336 = 0, $337 = 0, $338 = 0, $339 = 0, $34 = 0, $340 = 0, $341 = 0, $342 = 0, $343 = 0, $344 = 0, $345 = 0, $346 = 0, $347 = 0, $348 = 0, $349 = 0, $35 = 0, $350 = 0, $351 = 0;
 var $352 = 0, $353 = 0, $354 = 0, $355 = 0, $356 = 0, $357 = 0, $358 = 0, $359 = 0, $36 = 0, $360 = 0, $361 = 0, $362 = 0, $363 = 0, $364 = 0, $365 = 0, $366 = 0, $367 = 0, $368 = 0, $369 = 0, $37 = 0;
 var $370 = 0, $371 = 0, $372 = 0, $373 = 0, $374 = 0, $375 = 0, $376 = 0, $377 = 0, $378 = 0, $379 = 0, $38 = 0, $380 = 0, $381 = 0, $382 = 0, $383 = 0, $384 = 0, $385 = 0, $386 = 0, $387 = 0, $388 = 0;
 var $389 = 0, $39 = 0, $390 = 0, $391 = 0, $392 = 0, $393 = 0, $394 = 0, $395 = 0, $396 = 0, $397 = 0, $398 = 0, $399 = 0, $4 = 0, $40 = 0, $400 = 0, $401 = 0, $402 = 0, $403 = 0, $404 = 0, $405 = 0;
 var $406 = 0, $407 = 0, $408 = 0, $409 = 0, $41 = 0, $410 = 0, $411 = 0, $412 = 0, $413 = 0, $414 = 0, $415 = 0, $416 = 0, $417 = 0, $418 = 0, $419 = 0, $42 = 0, $420 = 0, $421 = 0, $422 = 0, $423 = 0;
 var $424 = 0, $425 = 0, $426 = 0, $427 = 0, $428 = 0, $429 = 0, $43 = 0, $430 = 0, $431 = 0, $432 = 0, $433 = 0, $434 = 0, $435 = 0, $436 = 0, $437 = 0, $438 = 0, $439 = 0, $44 = 0, $440 = 0, $441 = 0;
 var $442 = 0, $443 = 0, $444 = 0, $445 = 0, $446 = 0, $447 = 0, $448 = 0, $449 = 0, $45 = 0, $450 = 0, $451 = 0, $452 = 0, $453 = 0, $454 = 0, $455 = 0, $456 = 0, $457 = 0, $458 = 0, $459 = 0, $46 = 0;
 var $460 = 0, $461 = 0, $462 = 0, $463 = 0, $464 = 0, $465 = 0, $466 = 0, $467 = 0, $468 = 0, $469 = 0, $47 = 0, $470 = 0, $471 = 0, $472 = 0, $473 = 0, $474 = 0, $475 = 0, $476 = 0, $477 = 0, $478 = 0;
 var $479 = 0, $48 = 0, $480 = 0, $481 = 0, $482 = 0, $483 = 0, $484 = 0, $485 = 0, $486 = 0, $487 = 0, $488 = 0, $489 = 0, $49 = 0, $490 = 0, $491 = 0, $492 = 0, $493 = 0, $494 = 0, $495 = 0, $496 = 0;
 var $497 = 0, $498 = 0, $499 = 0, $5 = 0, $50 = 0, $500 = 0, $501 = 0, $502 = 0, $503 = 0, $504 = 0, $505 = 0, $506 = 0, $507 = 0, $508 = 0, $509 = 0, $51 = 0, $510 = 0, $511 = 0, $512 = 0, $513 = 0;
 var $514 = 0, $515 = 0, $516 = 0, $517 = 0, $518 = 0, $519 = 0, $52 = 0, $520 = 0, $521 = 0, $522 = 0, $523 = 0, $524 = 0, $525 = 0, $526 = 0, $527 = 0, $528 = 0, $529 = 0, $53 = 0, $530 = 0, $531 = 0;
 var $532 = 0, $533 = 0, $534 = 0, $535 = 0, $536 = 0, $537 = 0, $538 = 0, $539 = 0, $54 = 0, $540 = 0, $541 = 0, $542 = 0, $543 = 0, $544 = 0, $545 = 0, $546 = 0, $547 = 0, $548 = 0, $549 = 0, $55 = 0;
 var $550 = 0, $551 = 0, $552 = 0, $553 = 0, $554 = 0, $555 = 0, $556 = 0, $557 = 0, $558 = 0, $559 = 0, $56 = 0, $560 = 0, $561 = 0, $562 = 0, $563 = 0, $564 = 0, $565 = 0, $566 = 0, $567 = 0, $568 = 0;
 var $569 = 0, $57 = 0, $570 = 0, $571 = 0, $572 = 0, $573 = 0, $574 = 0, $575 = 0, $576 = 0, $577 = 0, $578 = 0, $579 = 0, $58 = 0, $580 = 0, $581 = 0, $582 = 0, $583 = 0, $584 = 0, $585 = 0, $586 = 0;
 var $587 = 0, $588 = 0, $589 = 0, $59 = 0, $590 = 0, $591 = 0, $592 = 0, $593 = 0, $594 = 0, $595 = 0, $596 = 0, $597 = 0, $598 = 0, $599 = 0, $6 = 0, $60 = 0, $600 = 0, $601 = 0, $602 = 0, $603 = 0;
 var $604 = 0, $605 = 0, $606 = 0, $607 = 0, $608 = 0, $609 = 0, $61 = 0, $610 = 0, $611 = 0, $612 = 0, $613 = 0, $614 = 0, $615 = 0, $616 = 0, $617 = 0, $618 = 0, $619 = 0, $62 = 0, $620 = 0, $621 = 0;
 var $622 = 0, $623 = 0, $624 = 0, $625 = 0, $626 = 0, $627 = 0, $628 = 0, $629 = 0, $63 = 0, $630 = 0, $631 = 0, $632 = 0, $633 = 0, $634 = 0, $635 = 0, $636 = 0, $637 = 0, $638 = 0, $639 = 0, $64 = 0;
 var $640 = 0, $641 = 0, $642 = 0, $643 = 0, $644 = 0, $645 = 0, $646 = 0, $647 = 0, $648 = 0, $649 = 0, $65 = 0, $650 = 0, $651 = 0, $652 = 0, $653 = 0, $654 = 0, $655 = 0, $656 = 0, $657 = 0, $658 = 0;
 var $659 = 0, $66 = 0, $660 = 0, $661 = 0, $662 = 0, $663 = 0, $664 = 0, $665 = 0, $666 = 0, $667 = 0, $668 = 0, $669 = 0, $67 = 0, $670 = 0, $671 = 0, $672 = 0, $673 = 0, $674 = 0, $675 = 0, $676 = 0;
 var $677 = 0, $678 = 0, $679 = 0, $68 = 0, $680 = 0, $681 = 0, $682 = 0, $683 = 0, $684 = 0, $685 = 0, $686 = 0, $687 = 0, $688 = 0, $689 = 0, $69 = 0, $690 = 0, $691 = 0, $692 = 0, $693 = 0, $694 = 0;
 var $695 = 0, $696 = 0, $697 = 0, $698 = 0, $699 = 0, $7 = 0, $70 = 0, $700 = 0, $701 = 0, $702 = 0, $703 = 0, $704 = 0, $705 = 0, $706 = 0, $707 = 0, $708 = 0, $709 = 0, $71 = 0, $710 = 0, $711 = 0;
 var $712 = 0, $713 = 0, $714 = 0, $715 = 0, $716 = 0, $717 = 0, $718 = 0, $719 = 0, $72 = 0, $720 = 0, $721 = 0, $722 = 0, $723 = 0, $724 = 0, $725 = 0, $726 = 0, $727 = 0, $728 = 0, $729 = 0, $73 = 0;
 var $730 = 0, $731 = 0, $732 = 0, $733 = 0, $734 = 0, $735 = 0, $736 = 0, $737 = 0, $738 = 0, $739 = 0, $74 = 0, $740 = 0, $741 = 0, $742 = 0, $743 = 0, $744 = 0, $745 = 0, $746 = 0, $747 = 0, $748 = 0;
 var $749 = 0, $75 = 0, $750 = 0, $751 = 0, $752 = 0, $753 = 0, $754 = 0, $755 = 0, $756 = 0, $757 = 0, $758 = 0, $759 = 0, $76 = 0, $760 = 0, $761 = 0, $762 = 0, $763 = 0, $764 = 0, $765 = 0, $766 = 0;
 var $767 = 0, $768 = 0, $769 = 0, $77 = 0, $770 = 0, $771 = 0, $772 = 0, $773 = 0, $774 = 0, $775 = 0, $776 = 0, $777 = 0, $778 = 0, $779 = 0, $78 = 0, $780 = 0, $781 = 0, $782 = 0, $783 = 0, $784 = 0;
 var $785 = 0, $786 = 0, $787 = 0, $788 = 0, $789 = 0, $79 = 0, $790 = 0, $791 = 0, $792 = 0, $793 = 0, $794 = 0, $795 = 0, $796 = 0, $797 = 0, $798 = 0, $799 = 0, $8 = 0, $80 = 0, $800 = 0, $801 = 0;
 var $802 = 0, $803 = 0, $804 = 0, $805 = 0, $806 = 0, $807 = 0, $808 = 0, $809 = 0, $81 = 0, $810 = 0, $811 = 0, $812 = 0, $813 = 0, $814 = 0, $815 = 0, $816 = 0, $817 = 0, $818 = 0, $819 = 0, $82 = 0;
 var $820 = 0, $821 = 0, $822 = 0, $823 = 0, $824 = 0, $825 = 0, $826 = 0, $827 = 0, $828 = 0, $829 = 0, $83 = 0, $830 = 0, $831 = 0, $832 = 0, $833 = 0, $834 = 0, $835 = 0, $836 = 0, $837 = 0, $838 = 0;
 var $839 = 0, $84 = 0, $840 = 0, $841 = 0, $842 = 0, $843 = 0, $844 = 0, $845 = 0, $846 = 0, $847 = 0, $848 = 0, $849 = 0, $85 = 0, $850 = 0, $851 = 0, $852 = 0, $853 = 0, $854 = 0, $855 = 0, $856 = 0;
 var $857 = 0, $858 = 0, $859 = 0, $86 = 0, $860 = 0, $861 = 0, $862 = 0, $863 = 0, $864 = 0, $865 = 0, $866 = 0, $867 = 0, $868 = 0, $869 = 0, $87 = 0, $870 = 0, $871 = 0, $872 = 0, $873 = 0, $874 = 0;
 var $875 = 0, $876 = 0, $877 = 0, $878 = 0, $879 = 0, $88 = 0, $880 = 0, $881 = 0, $882 = 0, $883 = 0, $884 = 0, $885 = 0, $886 = 0, $887 = 0, $888 = 0, $889 = 0, $89 = 0, $890 = 0, $891 = 0, $892 = 0;
 var $893 = 0, $894 = 0, $895 = 0, $896 = 0, $897 = 0, $898 = 0, $899 = 0, $9 = 0, $90 = 0, $900 = 0, $901 = 0, $902 = 0, $903 = 0, $904 = 0, $905 = 0, $906 = 0, $907 = 0, $908 = 0, $909 = 0, $91 = 0;
 var $910 = 0, $911 = 0, $912 = 0, $913 = 0, $914 = 0, $915 = 0, $916 = 0, $917 = 0, $918 = 0, $919 = 0, $92 = 0, $920 = 0, $921 = 0, $922 = 0, $923 = 0, $924 = 0, $925 = 0, $926 = 0, $927 = 0, $928 = 0;
 var $929 = 0, $93 = 0, $930 = 0, $931 = 0, $932 = 0, $933 = 0, $934 = 0, $935 = 0, $936 = 0, $937 = 0, $938 = 0, $939 = 0, $94 = 0, $940 = 0, $941 = 0, $942 = 0, $943 = 0, $944 = 0, $945 = 0, $946 = 0;
 var $947 = 0, $948 = 0, $949 = 0, $95 = 0, $950 = 0, $951 = 0, $952 = 0, $953 = 0, $954 = 0, $955 = 0, $956 = 0, $957 = 0, $958 = 0, $959 = 0, $96 = 0, $960 = 0, $961 = 0, $962 = 0, $963 = 0, $964 = 0;
 var $965 = 0, $966 = 0, $967 = 0, $968 = 0, $969 = 0, $97 = 0, $970 = 0, $971 = 0, $972 = 0, $973 = 0, $974 = 0, $975 = 0, $976 = 0, $977 = 0, $978 = 0, $979 = 0, $98 = 0, $980 = 0, $981 = 0, $982 = 0;
 var $983 = 0, $984 = 0, $985 = 0, $986 = 0, $987 = 0, $988 = 0, $989 = 0, $99 = 0, $990 = 0, $991 = 0, $992 = 0, $993 = 0, $994 = 0, $995 = 0, $996 = 0, $997 = 0, $998 = 0, $999 = 0, $F$0$i$i = 0, $F1$0$i = 0;
 var $F4$0 = 0, $F4$0$i$i = 0, $F5$0$i = 0, $I1$0$i$i = 0, $I7$0$i = 0, $I7$0$i$i = 0, $K12$0$i = 0, $K2$0$i$i = 0, $K8$0$i$i = 0, $R$1$i = 0, $R$1$i$i = 0, $R$1$i$i$lcssa = 0, $R$1$i$lcssa = 0, $R$1$i9 = 0, $R$1$i9$lcssa = 0, $R$3$i = 0, $R$3$i$i = 0, $R$3$i11 = 0, $RP$1$i = 0, $RP$1$i$i = 0;
 var $RP$1$i$i$lcssa = 0, $RP$1$i$lcssa = 0, $RP$1$i8 = 0, $RP$1$i8$lcssa = 0, $T$0$i = 0, $T$0$i$i = 0, $T$0$i$i$lcssa = 0, $T$0$i$i$lcssa140 = 0, $T$0$i$lcssa = 0, $T$0$i$lcssa157 = 0, $T$0$i18$i = 0, $T$0$i18$i$lcssa = 0, $T$0$i18$i$lcssa141 = 0, $attr$i$i = 0, $attr$i$i$i = 0, $br$2$ph$i = 0, $cond$i = 0, $cond$i$i = 0, $cond$i12 = 0, $exitcond$i$i = 0;
 var $i$01$i$i = 0, $idx$0$i = 0, $magic$i = 0, $magic$i$i = 0, $mem$2 = 0, $nb$0 = 0, $not$$i$i = 0, $not$$i20$i = 0, $not$7$i = 0, $oldfirst$0$i$i = 0, $or$cond$i = 0, $or$cond$i17 = 0, $or$cond1$i = 0, $or$cond1$i16 = 0, $or$cond10$i = 0, $or$cond11$i = 0, $or$cond2$i = 0, $or$cond38$i = 0, $or$cond5$i = 0, $or$cond7$i = 0;
 var $or$cond8$i = 0, $or$cond9$i = 0, $p$0$i$i = 0, $qsize$0$i$i = 0, $rsize$0$i = 0, $rsize$0$i$lcssa = 0, $rsize$0$i5 = 0, $rsize$1$i = 0, $rsize$3$i = 0, $rsize$4$lcssa$i = 0, $rsize$412$i = 0, $rst$0$i = 0, $rst$1$i = 0, $sizebits$0$$i = 0, $sizebits$0$i = 0, $sp$0$i$i = 0, $sp$0$i$i$i = 0, $sp$058$i = 0, $sp$058$i$lcssa = 0, $sp$157$i = 0;
 var $sp$157$i$lcssa = 0, $ssize$0$i = 0, $ssize$2$ph$i = 0, $ssize$5$i = 0, $t$0$i = 0, $t$0$i4 = 0, $t$2$i = 0, $t$4$ph$i = 0, $t$4$v$4$i = 0, $t$411$i = 0, $tbase$3$i = 0, $tbase$4$i = 0, $tbase$7$i = 0, $tsize$2243136$i = 0, $tsize$3$i = 0, $tsize$4$i = 0, $tsize$7$i = 0, $v$0$i = 0, $v$0$i$lcssa = 0, $v$0$i6 = 0;
 var $v$1$i = 0, $v$3$i = 0, $v$4$lcssa$i = 0, $v$413$i = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abort();
 $attr$i$i$i = sp + 12|0;
 $magic$i$i = sp + 8|0;
 $attr$i$i = sp + 4|0;
 $magic$i = sp;
 $0 = HEAP32[1440]|0;
 $1 = ($0|0)==(0);
 if ($1) {
  (_pthread_mutex_lock(5784)|0);
  $2 = HEAP32[1440]|0;
  $3 = ($2|0)==(0);
  if ($3) {
   HEAP32[(5768)>>2] = 4096;
   HEAP32[(5764)>>2] = 4096;
   HEAP32[(5772)>>2] = -1;
   HEAP32[(5776)>>2] = -1;
   HEAP32[(5780)>>2] = 2;
   HEAP32[(6256)>>2] = 2;
   $4 = (_pthread_mutexattr_init($attr$i$i)|0);
   $5 = ($4|0)==(0);
   if ($5) {
    $6 = (_pthread_mutex_init((6260),$attr$i$i)|0);
    $7 = ($6|0)==(0);
    if ($7) {
    }
   }
   $8 = $magic$i;
   $9 = $8 & -16;
   $10 = $9 ^ 1431655768;
   HEAP32[$magic$i>>2] = $10;
   Atomics_store(HEAP32,1440,$10)|0;
  }
  (_pthread_mutex_unlock(5784)|0);
 }
 $11 = HEAP32[(6256)>>2]|0;
 $12 = $11 & 2;
 $13 = ($12|0)==(0);
 if (!($13)) {
  $14 = (_pthread_mutex_lock((6260))|0);
  $15 = ($14|0)==(0);
  if (!($15)) {
   $$1 = 0;
   STACKTOP = sp;return ($$1|0);
  }
 }
 $16 = ($bytes>>>0)<(245);
 do {
  if ($16) {
   $17 = ($bytes>>>0)<(11);
   $18 = (($bytes) + 11)|0;
   $19 = $18 & -8;
   $20 = $17 ? 16 : $19;
   $21 = $20 >>> 3;
   $22 = HEAP32[1453]|0;
   $23 = $22 >>> $21;
   $24 = $23 & 3;
   $25 = ($24|0)==(0);
   if (!($25)) {
    $26 = $23 & 1;
    $27 = $26 ^ 1;
    $28 = (($27) + ($21))|0;
    $29 = $28 << 1;
    $30 = (5852 + ($29<<2)|0);
    $31 = ((($30)) + 8|0);
    $32 = HEAP32[$31>>2]|0;
    $33 = ((($32)) + 8|0);
    $34 = HEAP32[$33>>2]|0;
    $35 = ($30|0)==($34|0);
    do {
     if ($35) {
      $36 = 1 << $28;
      $37 = $36 ^ -1;
      $38 = $22 & $37;
      HEAP32[1453] = $38;
     } else {
      $39 = HEAP32[(5828)>>2]|0;
      $40 = ($34>>>0)<($39>>>0);
      if ($40) {
       _abort();
       // unreachable;
      }
      $41 = ((($34)) + 12|0);
      $42 = HEAP32[$41>>2]|0;
      $43 = ($42|0)==($32|0);
      if ($43) {
       HEAP32[$41>>2] = $30;
       HEAP32[$31>>2] = $34;
       break;
      } else {
       _abort();
       // unreachable;
      }
     }
    } while(0);
    $44 = $28 << 3;
    $45 = $44 | 3;
    $46 = ((($32)) + 4|0);
    HEAP32[$46>>2] = $45;
    $47 = (($32) + ($44)|0);
    $48 = ((($47)) + 4|0);
    $49 = HEAP32[$48>>2]|0;
    $50 = $49 | 1;
    HEAP32[$48>>2] = $50;
    $mem$2 = $33;
    break;
   }
   $51 = HEAP32[(5820)>>2]|0;
   $52 = ($20>>>0)>($51>>>0);
   if ($52) {
    $53 = ($23|0)==(0);
    if (!($53)) {
     $54 = $23 << $21;
     $55 = 2 << $21;
     $56 = (0 - ($55))|0;
     $57 = $55 | $56;
     $58 = $54 & $57;
     $59 = (0 - ($58))|0;
     $60 = $58 & $59;
     $61 = (($60) + -1)|0;
     $62 = $61 >>> 12;
     $63 = $62 & 16;
     $64 = $61 >>> $63;
     $65 = $64 >>> 5;
     $66 = $65 & 8;
     $67 = $66 | $63;
     $68 = $64 >>> $66;
     $69 = $68 >>> 2;
     $70 = $69 & 4;
     $71 = $67 | $70;
     $72 = $68 >>> $70;
     $73 = $72 >>> 1;
     $74 = $73 & 2;
     $75 = $71 | $74;
     $76 = $72 >>> $74;
     $77 = $76 >>> 1;
     $78 = $77 & 1;
     $79 = $75 | $78;
     $80 = $76 >>> $78;
     $81 = (($79) + ($80))|0;
     $82 = $81 << 1;
     $83 = (5852 + ($82<<2)|0);
     $84 = ((($83)) + 8|0);
     $85 = HEAP32[$84>>2]|0;
     $86 = ((($85)) + 8|0);
     $87 = HEAP32[$86>>2]|0;
     $88 = ($83|0)==($87|0);
     do {
      if ($88) {
       $89 = 1 << $81;
       $90 = $89 ^ -1;
       $91 = $22 & $90;
       HEAP32[1453] = $91;
       $106 = $51;
      } else {
       $92 = HEAP32[(5828)>>2]|0;
       $93 = ($87>>>0)<($92>>>0);
       if ($93) {
        _abort();
        // unreachable;
       }
       $94 = ((($87)) + 12|0);
       $95 = HEAP32[$94>>2]|0;
       $96 = ($95|0)==($85|0);
       if ($96) {
        HEAP32[$94>>2] = $83;
        HEAP32[$84>>2] = $87;
        $$pre = HEAP32[(5820)>>2]|0;
        $106 = $$pre;
        break;
       } else {
        _abort();
        // unreachable;
       }
      }
     } while(0);
     $97 = $81 << 3;
     $98 = (($97) - ($20))|0;
     $99 = $20 | 3;
     $100 = ((($85)) + 4|0);
     HEAP32[$100>>2] = $99;
     $101 = (($85) + ($20)|0);
     $102 = $98 | 1;
     $103 = ((($101)) + 4|0);
     HEAP32[$103>>2] = $102;
     $104 = (($101) + ($98)|0);
     HEAP32[$104>>2] = $98;
     $105 = ($106|0)==(0);
     if (!($105)) {
      $107 = HEAP32[(5832)>>2]|0;
      $108 = $106 >>> 3;
      $109 = $108 << 1;
      $110 = (5852 + ($109<<2)|0);
      $111 = HEAP32[1453]|0;
      $112 = 1 << $108;
      $113 = $111 & $112;
      $114 = ($113|0)==(0);
      if ($114) {
       $115 = $111 | $112;
       HEAP32[1453] = $115;
       $$pre72 = ((($110)) + 8|0);
       $$pre$phiZ2D = $$pre72;$F4$0 = $110;
      } else {
       $116 = ((($110)) + 8|0);
       $117 = HEAP32[$116>>2]|0;
       $118 = HEAP32[(5828)>>2]|0;
       $119 = ($117>>>0)<($118>>>0);
       if ($119) {
        _abort();
        // unreachable;
       } else {
        $$pre$phiZ2D = $116;$F4$0 = $117;
       }
      }
      HEAP32[$$pre$phiZ2D>>2] = $107;
      $120 = ((($F4$0)) + 12|0);
      HEAP32[$120>>2] = $107;
      $121 = ((($107)) + 8|0);
      HEAP32[$121>>2] = $F4$0;
      $122 = ((($107)) + 12|0);
      HEAP32[$122>>2] = $110;
     }
     HEAP32[(5820)>>2] = $98;
     HEAP32[(5832)>>2] = $101;
     $mem$2 = $86;
     break;
    }
    $123 = HEAP32[(5816)>>2]|0;
    $124 = ($123|0)==(0);
    if ($124) {
     $nb$0 = $20;
     label = 162;
    } else {
     $125 = (0 - ($123))|0;
     $126 = $123 & $125;
     $127 = (($126) + -1)|0;
     $128 = $127 >>> 12;
     $129 = $128 & 16;
     $130 = $127 >>> $129;
     $131 = $130 >>> 5;
     $132 = $131 & 8;
     $133 = $132 | $129;
     $134 = $130 >>> $132;
     $135 = $134 >>> 2;
     $136 = $135 & 4;
     $137 = $133 | $136;
     $138 = $134 >>> $136;
     $139 = $138 >>> 1;
     $140 = $139 & 2;
     $141 = $137 | $140;
     $142 = $138 >>> $140;
     $143 = $142 >>> 1;
     $144 = $143 & 1;
     $145 = $141 | $144;
     $146 = $142 >>> $144;
     $147 = (($145) + ($146))|0;
     $148 = (6116 + ($147<<2)|0);
     $149 = HEAP32[$148>>2]|0;
     $150 = ((($149)) + 4|0);
     $151 = HEAP32[$150>>2]|0;
     $152 = $151 & -8;
     $153 = (($152) - ($20))|0;
     $rsize$0$i = $153;$t$0$i = $149;$v$0$i = $149;
     while(1) {
      $154 = ((($t$0$i)) + 16|0);
      $155 = HEAP32[$154>>2]|0;
      $156 = ($155|0)==(0|0);
      if ($156) {
       $157 = ((($t$0$i)) + 20|0);
       $158 = HEAP32[$157>>2]|0;
       $159 = ($158|0)==(0|0);
       if ($159) {
        $rsize$0$i$lcssa = $rsize$0$i;$v$0$i$lcssa = $v$0$i;
        break;
       } else {
        $161 = $158;
       }
      } else {
       $161 = $155;
      }
      $160 = ((($161)) + 4|0);
      $162 = HEAP32[$160>>2]|0;
      $163 = $162 & -8;
      $164 = (($163) - ($20))|0;
      $165 = ($164>>>0)<($rsize$0$i>>>0);
      $$rsize$0$i = $165 ? $164 : $rsize$0$i;
      $$v$0$i = $165 ? $161 : $v$0$i;
      $rsize$0$i = $$rsize$0$i;$t$0$i = $161;$v$0$i = $$v$0$i;
     }
     $166 = HEAP32[(5828)>>2]|0;
     $167 = ($v$0$i$lcssa>>>0)<($166>>>0);
     if ($167) {
      _abort();
      // unreachable;
     }
     $168 = (($v$0$i$lcssa) + ($20)|0);
     $169 = ($v$0$i$lcssa>>>0)<($168>>>0);
     if (!($169)) {
      _abort();
      // unreachable;
     }
     $170 = ((($v$0$i$lcssa)) + 24|0);
     $171 = HEAP32[$170>>2]|0;
     $172 = ((($v$0$i$lcssa)) + 12|0);
     $173 = HEAP32[$172>>2]|0;
     $174 = ($173|0)==($v$0$i$lcssa|0);
     do {
      if ($174) {
       $184 = ((($v$0$i$lcssa)) + 20|0);
       $185 = HEAP32[$184>>2]|0;
       $186 = ($185|0)==(0|0);
       if ($186) {
        $187 = ((($v$0$i$lcssa)) + 16|0);
        $188 = HEAP32[$187>>2]|0;
        $189 = ($188|0)==(0|0);
        if ($189) {
         $R$3$i = 0;
         break;
        } else {
         $R$1$i = $188;$RP$1$i = $187;
        }
       } else {
        $R$1$i = $185;$RP$1$i = $184;
       }
       while(1) {
        $190 = ((($R$1$i)) + 20|0);
        $191 = HEAP32[$190>>2]|0;
        $192 = ($191|0)==(0|0);
        if (!($192)) {
         $R$1$i = $191;$RP$1$i = $190;
         continue;
        }
        $193 = ((($R$1$i)) + 16|0);
        $194 = HEAP32[$193>>2]|0;
        $195 = ($194|0)==(0|0);
        if ($195) {
         $R$1$i$lcssa = $R$1$i;$RP$1$i$lcssa = $RP$1$i;
         break;
        } else {
         $R$1$i = $194;$RP$1$i = $193;
        }
       }
       $196 = ($RP$1$i$lcssa>>>0)<($166>>>0);
       if ($196) {
        _abort();
        // unreachable;
       } else {
        HEAP32[$RP$1$i$lcssa>>2] = 0;
        $R$3$i = $R$1$i$lcssa;
        break;
       }
      } else {
       $175 = ((($v$0$i$lcssa)) + 8|0);
       $176 = HEAP32[$175>>2]|0;
       $177 = ($176>>>0)<($166>>>0);
       if ($177) {
        _abort();
        // unreachable;
       }
       $178 = ((($176)) + 12|0);
       $179 = HEAP32[$178>>2]|0;
       $180 = ($179|0)==($v$0$i$lcssa|0);
       if (!($180)) {
        _abort();
        // unreachable;
       }
       $181 = ((($173)) + 8|0);
       $182 = HEAP32[$181>>2]|0;
       $183 = ($182|0)==($v$0$i$lcssa|0);
       if ($183) {
        HEAP32[$178>>2] = $173;
        HEAP32[$181>>2] = $176;
        $R$3$i = $173;
        break;
       } else {
        _abort();
        // unreachable;
       }
      }
     } while(0);
     $197 = ($171|0)==(0|0);
     do {
      if (!($197)) {
       $198 = ((($v$0$i$lcssa)) + 28|0);
       $199 = HEAP32[$198>>2]|0;
       $200 = (6116 + ($199<<2)|0);
       $201 = HEAP32[$200>>2]|0;
       $202 = ($v$0$i$lcssa|0)==($201|0);
       if ($202) {
        HEAP32[$200>>2] = $R$3$i;
        $cond$i = ($R$3$i|0)==(0|0);
        if ($cond$i) {
         $203 = 1 << $199;
         $204 = $203 ^ -1;
         $205 = HEAP32[(5816)>>2]|0;
         $206 = $205 & $204;
         HEAP32[(5816)>>2] = $206;
         break;
        }
       } else {
        $207 = HEAP32[(5828)>>2]|0;
        $208 = ($171>>>0)<($207>>>0);
        if ($208) {
         _abort();
         // unreachable;
        }
        $209 = ((($171)) + 16|0);
        $210 = HEAP32[$209>>2]|0;
        $211 = ($210|0)==($v$0$i$lcssa|0);
        if ($211) {
         HEAP32[$209>>2] = $R$3$i;
        } else {
         $212 = ((($171)) + 20|0);
         HEAP32[$212>>2] = $R$3$i;
        }
        $213 = ($R$3$i|0)==(0|0);
        if ($213) {
         break;
        }
       }
       $214 = HEAP32[(5828)>>2]|0;
       $215 = ($R$3$i>>>0)<($214>>>0);
       if ($215) {
        _abort();
        // unreachable;
       }
       $216 = ((($R$3$i)) + 24|0);
       HEAP32[$216>>2] = $171;
       $217 = ((($v$0$i$lcssa)) + 16|0);
       $218 = HEAP32[$217>>2]|0;
       $219 = ($218|0)==(0|0);
       do {
        if (!($219)) {
         $220 = ($218>>>0)<($214>>>0);
         if ($220) {
          _abort();
          // unreachable;
         } else {
          $221 = ((($R$3$i)) + 16|0);
          HEAP32[$221>>2] = $218;
          $222 = ((($218)) + 24|0);
          HEAP32[$222>>2] = $R$3$i;
          break;
         }
        }
       } while(0);
       $223 = ((($v$0$i$lcssa)) + 20|0);
       $224 = HEAP32[$223>>2]|0;
       $225 = ($224|0)==(0|0);
       if (!($225)) {
        $226 = HEAP32[(5828)>>2]|0;
        $227 = ($224>>>0)<($226>>>0);
        if ($227) {
         _abort();
         // unreachable;
        } else {
         $228 = ((($R$3$i)) + 20|0);
         HEAP32[$228>>2] = $224;
         $229 = ((($224)) + 24|0);
         HEAP32[$229>>2] = $R$3$i;
         break;
        }
       }
      }
     } while(0);
     $230 = ($rsize$0$i$lcssa>>>0)<(16);
     if ($230) {
      $231 = (($rsize$0$i$lcssa) + ($20))|0;
      $232 = $231 | 3;
      $233 = ((($v$0$i$lcssa)) + 4|0);
      HEAP32[$233>>2] = $232;
      $234 = (($v$0$i$lcssa) + ($231)|0);
      $235 = ((($234)) + 4|0);
      $236 = HEAP32[$235>>2]|0;
      $237 = $236 | 1;
      HEAP32[$235>>2] = $237;
     } else {
      $238 = $20 | 3;
      $239 = ((($v$0$i$lcssa)) + 4|0);
      HEAP32[$239>>2] = $238;
      $240 = $rsize$0$i$lcssa | 1;
      $241 = ((($168)) + 4|0);
      HEAP32[$241>>2] = $240;
      $242 = (($168) + ($rsize$0$i$lcssa)|0);
      HEAP32[$242>>2] = $rsize$0$i$lcssa;
      $243 = HEAP32[(5820)>>2]|0;
      $244 = ($243|0)==(0);
      if (!($244)) {
       $245 = HEAP32[(5832)>>2]|0;
       $246 = $243 >>> 3;
       $247 = $246 << 1;
       $248 = (5852 + ($247<<2)|0);
       $249 = HEAP32[1453]|0;
       $250 = 1 << $246;
       $251 = $249 & $250;
       $252 = ($251|0)==(0);
       if ($252) {
        $253 = $249 | $250;
        HEAP32[1453] = $253;
        $$pre$i = ((($248)) + 8|0);
        $$pre$phi$iZ2D = $$pre$i;$F1$0$i = $248;
       } else {
        $254 = ((($248)) + 8|0);
        $255 = HEAP32[$254>>2]|0;
        $256 = HEAP32[(5828)>>2]|0;
        $257 = ($255>>>0)<($256>>>0);
        if ($257) {
         _abort();
         // unreachable;
        } else {
         $$pre$phi$iZ2D = $254;$F1$0$i = $255;
        }
       }
       HEAP32[$$pre$phi$iZ2D>>2] = $245;
       $258 = ((($F1$0$i)) + 12|0);
       HEAP32[$258>>2] = $245;
       $259 = ((($245)) + 8|0);
       HEAP32[$259>>2] = $F1$0$i;
       $260 = ((($245)) + 12|0);
       HEAP32[$260>>2] = $248;
      }
      HEAP32[(5820)>>2] = $rsize$0$i$lcssa;
      HEAP32[(5832)>>2] = $168;
     }
     $261 = ((($v$0$i$lcssa)) + 8|0);
     $mem$2 = $261;
    }
   } else {
    $nb$0 = $20;
    label = 162;
   }
  } else {
   $262 = ($bytes>>>0)>(4294967231);
   if ($262) {
    $nb$0 = -1;
    label = 162;
   } else {
    $263 = (($bytes) + 11)|0;
    $264 = $263 & -8;
    $265 = HEAP32[(5816)>>2]|0;
    $266 = ($265|0)==(0);
    if ($266) {
     $nb$0 = $264;
     label = 162;
    } else {
     $267 = (0 - ($264))|0;
     $268 = $263 >>> 8;
     $269 = ($268|0)==(0);
     if ($269) {
      $idx$0$i = 0;
     } else {
      $270 = ($264>>>0)>(16777215);
      if ($270) {
       $idx$0$i = 31;
      } else {
       $271 = (($268) + 1048320)|0;
       $272 = $271 >>> 16;
       $273 = $272 & 8;
       $274 = $268 << $273;
       $275 = (($274) + 520192)|0;
       $276 = $275 >>> 16;
       $277 = $276 & 4;
       $278 = $277 | $273;
       $279 = $274 << $277;
       $280 = (($279) + 245760)|0;
       $281 = $280 >>> 16;
       $282 = $281 & 2;
       $283 = $278 | $282;
       $284 = (14 - ($283))|0;
       $285 = $279 << $282;
       $286 = $285 >>> 15;
       $287 = (($284) + ($286))|0;
       $288 = $287 << 1;
       $289 = (($287) + 7)|0;
       $290 = $264 >>> $289;
       $291 = $290 & 1;
       $292 = $291 | $288;
       $idx$0$i = $292;
      }
     }
     $293 = (6116 + ($idx$0$i<<2)|0);
     $294 = HEAP32[$293>>2]|0;
     $295 = ($294|0)==(0|0);
     L134: do {
      if ($295) {
       $rsize$3$i = $267;$t$2$i = 0;$v$3$i = 0;
       label = 95;
      } else {
       $296 = ($idx$0$i|0)==(31);
       $297 = $idx$0$i >>> 1;
       $298 = (25 - ($297))|0;
       $299 = $296 ? 0 : $298;
       $300 = $264 << $299;
       $rsize$0$i5 = $267;$rst$0$i = 0;$sizebits$0$i = $300;$t$0$i4 = $294;$v$0$i6 = 0;
       while(1) {
        $301 = ((($t$0$i4)) + 4|0);
        $302 = HEAP32[$301>>2]|0;
        $303 = $302 & -8;
        $304 = (($303) - ($264))|0;
        $305 = ($304>>>0)<($rsize$0$i5>>>0);
        if ($305) {
         $306 = ($303|0)==($264|0);
         if ($306) {
          $rsize$412$i = $304;$t$411$i = $t$0$i4;$v$413$i = $t$0$i4;
          label = 99;
          break L134;
         } else {
          $rsize$1$i = $304;$v$1$i = $t$0$i4;
         }
        } else {
         $rsize$1$i = $rsize$0$i5;$v$1$i = $v$0$i6;
        }
        $307 = ((($t$0$i4)) + 20|0);
        $308 = HEAP32[$307>>2]|0;
        $309 = $sizebits$0$i >>> 31;
        $310 = (((($t$0$i4)) + 16|0) + ($309<<2)|0);
        $311 = HEAP32[$310>>2]|0;
        $312 = ($308|0)==(0|0);
        $313 = ($308|0)==($311|0);
        $or$cond1$i = $312 | $313;
        $rst$1$i = $or$cond1$i ? $rst$0$i : $308;
        $314 = ($311|0)==(0|0);
        $315 = $314&1;
        $316 = $315 ^ 1;
        $sizebits$0$$i = $sizebits$0$i << $316;
        if ($314) {
         $rsize$3$i = $rsize$1$i;$t$2$i = $rst$1$i;$v$3$i = $v$1$i;
         label = 95;
         break;
        } else {
         $rsize$0$i5 = $rsize$1$i;$rst$0$i = $rst$1$i;$sizebits$0$i = $sizebits$0$$i;$t$0$i4 = $311;$v$0$i6 = $v$1$i;
        }
       }
      }
     } while(0);
     if ((label|0) == 95) {
      $317 = ($t$2$i|0)==(0|0);
      $318 = ($v$3$i|0)==(0|0);
      $or$cond$i = $317 & $318;
      if ($or$cond$i) {
       $319 = 2 << $idx$0$i;
       $320 = (0 - ($319))|0;
       $321 = $319 | $320;
       $322 = $265 & $321;
       $323 = ($322|0)==(0);
       if ($323) {
        $nb$0 = $264;
        label = 162;
        break;
       }
       $324 = (0 - ($322))|0;
       $325 = $322 & $324;
       $326 = (($325) + -1)|0;
       $327 = $326 >>> 12;
       $328 = $327 & 16;
       $329 = $326 >>> $328;
       $330 = $329 >>> 5;
       $331 = $330 & 8;
       $332 = $331 | $328;
       $333 = $329 >>> $331;
       $334 = $333 >>> 2;
       $335 = $334 & 4;
       $336 = $332 | $335;
       $337 = $333 >>> $335;
       $338 = $337 >>> 1;
       $339 = $338 & 2;
       $340 = $336 | $339;
       $341 = $337 >>> $339;
       $342 = $341 >>> 1;
       $343 = $342 & 1;
       $344 = $340 | $343;
       $345 = $341 >>> $343;
       $346 = (($344) + ($345))|0;
       $347 = (6116 + ($346<<2)|0);
       $348 = HEAP32[$347>>2]|0;
       $t$4$ph$i = $348;
      } else {
       $t$4$ph$i = $t$2$i;
      }
      $349 = ($t$4$ph$i|0)==(0|0);
      if ($349) {
       $rsize$4$lcssa$i = $rsize$3$i;$v$4$lcssa$i = $v$3$i;
      } else {
       $rsize$412$i = $rsize$3$i;$t$411$i = $t$4$ph$i;$v$413$i = $v$3$i;
       label = 99;
      }
     }
     if ((label|0) == 99) {
      while(1) {
       label = 0;
       $350 = ((($t$411$i)) + 4|0);
       $351 = HEAP32[$350>>2]|0;
       $352 = $351 & -8;
       $353 = (($352) - ($264))|0;
       $354 = ($353>>>0)<($rsize$412$i>>>0);
       $$rsize$4$i = $354 ? $353 : $rsize$412$i;
       $t$4$v$4$i = $354 ? $t$411$i : $v$413$i;
       $355 = ((($t$411$i)) + 16|0);
       $356 = HEAP32[$355>>2]|0;
       $357 = ($356|0)==(0|0);
       if (!($357)) {
        $rsize$412$i = $$rsize$4$i;$t$411$i = $356;$v$413$i = $t$4$v$4$i;
        label = 99;
        continue;
       }
       $358 = ((($t$411$i)) + 20|0);
       $359 = HEAP32[$358>>2]|0;
       $360 = ($359|0)==(0|0);
       if ($360) {
        $rsize$4$lcssa$i = $$rsize$4$i;$v$4$lcssa$i = $t$4$v$4$i;
        break;
       } else {
        $rsize$412$i = $$rsize$4$i;$t$411$i = $359;$v$413$i = $t$4$v$4$i;
        label = 99;
       }
      }
     }
     $361 = ($v$4$lcssa$i|0)==(0|0);
     if ($361) {
      $nb$0 = $264;
      label = 162;
     } else {
      $362 = HEAP32[(5820)>>2]|0;
      $363 = (($362) - ($264))|0;
      $364 = ($rsize$4$lcssa$i>>>0)<($363>>>0);
      if ($364) {
       $365 = HEAP32[(5828)>>2]|0;
       $366 = ($v$4$lcssa$i>>>0)<($365>>>0);
       if ($366) {
        _abort();
        // unreachable;
       }
       $367 = (($v$4$lcssa$i) + ($264)|0);
       $368 = ($v$4$lcssa$i>>>0)<($367>>>0);
       if (!($368)) {
        _abort();
        // unreachable;
       }
       $369 = ((($v$4$lcssa$i)) + 24|0);
       $370 = HEAP32[$369>>2]|0;
       $371 = ((($v$4$lcssa$i)) + 12|0);
       $372 = HEAP32[$371>>2]|0;
       $373 = ($372|0)==($v$4$lcssa$i|0);
       do {
        if ($373) {
         $383 = ((($v$4$lcssa$i)) + 20|0);
         $384 = HEAP32[$383>>2]|0;
         $385 = ($384|0)==(0|0);
         if ($385) {
          $386 = ((($v$4$lcssa$i)) + 16|0);
          $387 = HEAP32[$386>>2]|0;
          $388 = ($387|0)==(0|0);
          if ($388) {
           $R$3$i11 = 0;
           break;
          } else {
           $R$1$i9 = $387;$RP$1$i8 = $386;
          }
         } else {
          $R$1$i9 = $384;$RP$1$i8 = $383;
         }
         while(1) {
          $389 = ((($R$1$i9)) + 20|0);
          $390 = HEAP32[$389>>2]|0;
          $391 = ($390|0)==(0|0);
          if (!($391)) {
           $R$1$i9 = $390;$RP$1$i8 = $389;
           continue;
          }
          $392 = ((($R$1$i9)) + 16|0);
          $393 = HEAP32[$392>>2]|0;
          $394 = ($393|0)==(0|0);
          if ($394) {
           $R$1$i9$lcssa = $R$1$i9;$RP$1$i8$lcssa = $RP$1$i8;
           break;
          } else {
           $R$1$i9 = $393;$RP$1$i8 = $392;
          }
         }
         $395 = ($RP$1$i8$lcssa>>>0)<($365>>>0);
         if ($395) {
          _abort();
          // unreachable;
         } else {
          HEAP32[$RP$1$i8$lcssa>>2] = 0;
          $R$3$i11 = $R$1$i9$lcssa;
          break;
         }
        } else {
         $374 = ((($v$4$lcssa$i)) + 8|0);
         $375 = HEAP32[$374>>2]|0;
         $376 = ($375>>>0)<($365>>>0);
         if ($376) {
          _abort();
          // unreachable;
         }
         $377 = ((($375)) + 12|0);
         $378 = HEAP32[$377>>2]|0;
         $379 = ($378|0)==($v$4$lcssa$i|0);
         if (!($379)) {
          _abort();
          // unreachable;
         }
         $380 = ((($372)) + 8|0);
         $381 = HEAP32[$380>>2]|0;
         $382 = ($381|0)==($v$4$lcssa$i|0);
         if ($382) {
          HEAP32[$377>>2] = $372;
          HEAP32[$380>>2] = $375;
          $R$3$i11 = $372;
          break;
         } else {
          _abort();
          // unreachable;
         }
        }
       } while(0);
       $396 = ($370|0)==(0|0);
       do {
        if (!($396)) {
         $397 = ((($v$4$lcssa$i)) + 28|0);
         $398 = HEAP32[$397>>2]|0;
         $399 = (6116 + ($398<<2)|0);
         $400 = HEAP32[$399>>2]|0;
         $401 = ($v$4$lcssa$i|0)==($400|0);
         if ($401) {
          HEAP32[$399>>2] = $R$3$i11;
          $cond$i12 = ($R$3$i11|0)==(0|0);
          if ($cond$i12) {
           $402 = 1 << $398;
           $403 = $402 ^ -1;
           $404 = HEAP32[(5816)>>2]|0;
           $405 = $404 & $403;
           HEAP32[(5816)>>2] = $405;
           break;
          }
         } else {
          $406 = HEAP32[(5828)>>2]|0;
          $407 = ($370>>>0)<($406>>>0);
          if ($407) {
           _abort();
           // unreachable;
          }
          $408 = ((($370)) + 16|0);
          $409 = HEAP32[$408>>2]|0;
          $410 = ($409|0)==($v$4$lcssa$i|0);
          if ($410) {
           HEAP32[$408>>2] = $R$3$i11;
          } else {
           $411 = ((($370)) + 20|0);
           HEAP32[$411>>2] = $R$3$i11;
          }
          $412 = ($R$3$i11|0)==(0|0);
          if ($412) {
           break;
          }
         }
         $413 = HEAP32[(5828)>>2]|0;
         $414 = ($R$3$i11>>>0)<($413>>>0);
         if ($414) {
          _abort();
          // unreachable;
         }
         $415 = ((($R$3$i11)) + 24|0);
         HEAP32[$415>>2] = $370;
         $416 = ((($v$4$lcssa$i)) + 16|0);
         $417 = HEAP32[$416>>2]|0;
         $418 = ($417|0)==(0|0);
         do {
          if (!($418)) {
           $419 = ($417>>>0)<($413>>>0);
           if ($419) {
            _abort();
            // unreachable;
           } else {
            $420 = ((($R$3$i11)) + 16|0);
            HEAP32[$420>>2] = $417;
            $421 = ((($417)) + 24|0);
            HEAP32[$421>>2] = $R$3$i11;
            break;
           }
          }
         } while(0);
         $422 = ((($v$4$lcssa$i)) + 20|0);
         $423 = HEAP32[$422>>2]|0;
         $424 = ($423|0)==(0|0);
         if (!($424)) {
          $425 = HEAP32[(5828)>>2]|0;
          $426 = ($423>>>0)<($425>>>0);
          if ($426) {
           _abort();
           // unreachable;
          } else {
           $427 = ((($R$3$i11)) + 20|0);
           HEAP32[$427>>2] = $423;
           $428 = ((($423)) + 24|0);
           HEAP32[$428>>2] = $R$3$i11;
           break;
          }
         }
        }
       } while(0);
       $429 = ($rsize$4$lcssa$i>>>0)<(16);
       do {
        if ($429) {
         $430 = (($rsize$4$lcssa$i) + ($264))|0;
         $431 = $430 | 3;
         $432 = ((($v$4$lcssa$i)) + 4|0);
         HEAP32[$432>>2] = $431;
         $433 = (($v$4$lcssa$i) + ($430)|0);
         $434 = ((($433)) + 4|0);
         $435 = HEAP32[$434>>2]|0;
         $436 = $435 | 1;
         HEAP32[$434>>2] = $436;
        } else {
         $437 = $264 | 3;
         $438 = ((($v$4$lcssa$i)) + 4|0);
         HEAP32[$438>>2] = $437;
         $439 = $rsize$4$lcssa$i | 1;
         $440 = ((($367)) + 4|0);
         HEAP32[$440>>2] = $439;
         $441 = (($367) + ($rsize$4$lcssa$i)|0);
         HEAP32[$441>>2] = $rsize$4$lcssa$i;
         $442 = $rsize$4$lcssa$i >>> 3;
         $443 = ($rsize$4$lcssa$i>>>0)<(256);
         if ($443) {
          $444 = $442 << 1;
          $445 = (5852 + ($444<<2)|0);
          $446 = HEAP32[1453]|0;
          $447 = 1 << $442;
          $448 = $446 & $447;
          $449 = ($448|0)==(0);
          do {
           if ($449) {
            $450 = $446 | $447;
            HEAP32[1453] = $450;
            $$pre$i13 = ((($445)) + 8|0);
            $$pre$phi$i14Z2D = $$pre$i13;$F5$0$i = $445;
           } else {
            $451 = ((($445)) + 8|0);
            $452 = HEAP32[$451>>2]|0;
            $453 = HEAP32[(5828)>>2]|0;
            $454 = ($452>>>0)<($453>>>0);
            if (!($454)) {
             $$pre$phi$i14Z2D = $451;$F5$0$i = $452;
             break;
            }
            _abort();
            // unreachable;
           }
          } while(0);
          HEAP32[$$pre$phi$i14Z2D>>2] = $367;
          $455 = ((($F5$0$i)) + 12|0);
          HEAP32[$455>>2] = $367;
          $456 = ((($367)) + 8|0);
          HEAP32[$456>>2] = $F5$0$i;
          $457 = ((($367)) + 12|0);
          HEAP32[$457>>2] = $445;
          break;
         }
         $458 = $rsize$4$lcssa$i >>> 8;
         $459 = ($458|0)==(0);
         if ($459) {
          $I7$0$i = 0;
         } else {
          $460 = ($rsize$4$lcssa$i>>>0)>(16777215);
          if ($460) {
           $I7$0$i = 31;
          } else {
           $461 = (($458) + 1048320)|0;
           $462 = $461 >>> 16;
           $463 = $462 & 8;
           $464 = $458 << $463;
           $465 = (($464) + 520192)|0;
           $466 = $465 >>> 16;
           $467 = $466 & 4;
           $468 = $467 | $463;
           $469 = $464 << $467;
           $470 = (($469) + 245760)|0;
           $471 = $470 >>> 16;
           $472 = $471 & 2;
           $473 = $468 | $472;
           $474 = (14 - ($473))|0;
           $475 = $469 << $472;
           $476 = $475 >>> 15;
           $477 = (($474) + ($476))|0;
           $478 = $477 << 1;
           $479 = (($477) + 7)|0;
           $480 = $rsize$4$lcssa$i >>> $479;
           $481 = $480 & 1;
           $482 = $481 | $478;
           $I7$0$i = $482;
          }
         }
         $483 = (6116 + ($I7$0$i<<2)|0);
         $484 = ((($367)) + 28|0);
         HEAP32[$484>>2] = $I7$0$i;
         $485 = ((($367)) + 16|0);
         $486 = ((($485)) + 4|0);
         HEAP32[$486>>2] = 0;
         HEAP32[$485>>2] = 0;
         $487 = HEAP32[(5816)>>2]|0;
         $488 = 1 << $I7$0$i;
         $489 = $487 & $488;
         $490 = ($489|0)==(0);
         if ($490) {
          $491 = $487 | $488;
          HEAP32[(5816)>>2] = $491;
          HEAP32[$483>>2] = $367;
          $492 = ((($367)) + 24|0);
          HEAP32[$492>>2] = $483;
          $493 = ((($367)) + 12|0);
          HEAP32[$493>>2] = $367;
          $494 = ((($367)) + 8|0);
          HEAP32[$494>>2] = $367;
          break;
         }
         $495 = HEAP32[$483>>2]|0;
         $496 = ($I7$0$i|0)==(31);
         $497 = $I7$0$i >>> 1;
         $498 = (25 - ($497))|0;
         $499 = $496 ? 0 : $498;
         $500 = $rsize$4$lcssa$i << $499;
         $K12$0$i = $500;$T$0$i = $495;
         while(1) {
          $501 = ((($T$0$i)) + 4|0);
          $502 = HEAP32[$501>>2]|0;
          $503 = $502 & -8;
          $504 = ($503|0)==($rsize$4$lcssa$i|0);
          if ($504) {
           $T$0$i$lcssa = $T$0$i;
           label = 157;
           break;
          }
          $505 = $K12$0$i >>> 31;
          $506 = (((($T$0$i)) + 16|0) + ($505<<2)|0);
          $507 = $K12$0$i << 1;
          $508 = HEAP32[$506>>2]|0;
          $509 = ($508|0)==(0|0);
          if ($509) {
           $$lcssa158 = $506;$T$0$i$lcssa157 = $T$0$i;
           label = 154;
           break;
          } else {
           $K12$0$i = $507;$T$0$i = $508;
          }
         }
         if ((label|0) == 154) {
          $510 = HEAP32[(5828)>>2]|0;
          $511 = ($$lcssa158>>>0)<($510>>>0);
          if ($511) {
           _abort();
           // unreachable;
          } else {
           HEAP32[$$lcssa158>>2] = $367;
           $512 = ((($367)) + 24|0);
           HEAP32[$512>>2] = $T$0$i$lcssa157;
           $513 = ((($367)) + 12|0);
           HEAP32[$513>>2] = $367;
           $514 = ((($367)) + 8|0);
           HEAP32[$514>>2] = $367;
           break;
          }
         }
         else if ((label|0) == 157) {
          $515 = ((($T$0$i$lcssa)) + 8|0);
          $516 = HEAP32[$515>>2]|0;
          $517 = HEAP32[(5828)>>2]|0;
          $518 = ($516>>>0)>=($517>>>0);
          $not$7$i = ($T$0$i$lcssa>>>0)>=($517>>>0);
          $519 = $518 & $not$7$i;
          if ($519) {
           $520 = ((($516)) + 12|0);
           HEAP32[$520>>2] = $367;
           HEAP32[$515>>2] = $367;
           $521 = ((($367)) + 8|0);
           HEAP32[$521>>2] = $516;
           $522 = ((($367)) + 12|0);
           HEAP32[$522>>2] = $T$0$i$lcssa;
           $523 = ((($367)) + 24|0);
           HEAP32[$523>>2] = 0;
           break;
          } else {
           _abort();
           // unreachable;
          }
         }
        }
       } while(0);
       $524 = ((($v$4$lcssa$i)) + 8|0);
       $mem$2 = $524;
      } else {
       $nb$0 = $264;
       label = 162;
      }
     }
    }
   }
  }
 } while(0);
 L241: do {
  if ((label|0) == 162) {
   $525 = HEAP32[(5820)>>2]|0;
   $526 = ($525>>>0)<($nb$0>>>0);
   if (!($526)) {
    $527 = (($525) - ($nb$0))|0;
    $528 = HEAP32[(5832)>>2]|0;
    $529 = ($527>>>0)>(15);
    if ($529) {
     $530 = (($528) + ($nb$0)|0);
     HEAP32[(5832)>>2] = $530;
     HEAP32[(5820)>>2] = $527;
     $531 = $527 | 1;
     $532 = ((($530)) + 4|0);
     HEAP32[$532>>2] = $531;
     $533 = (($530) + ($527)|0);
     HEAP32[$533>>2] = $527;
     $534 = $nb$0 | 3;
     $535 = ((($528)) + 4|0);
     HEAP32[$535>>2] = $534;
    } else {
     HEAP32[(5820)>>2] = 0;
     HEAP32[(5832)>>2] = 0;
     $536 = $525 | 3;
     $537 = ((($528)) + 4|0);
     HEAP32[$537>>2] = $536;
     $538 = (($528) + ($525)|0);
     $539 = ((($538)) + 4|0);
     $540 = HEAP32[$539>>2]|0;
     $541 = $540 | 1;
     HEAP32[$539>>2] = $541;
    }
    $542 = ((($528)) + 8|0);
    $mem$2 = $542;
    break;
   }
   $543 = HEAP32[(5824)>>2]|0;
   $544 = ($543>>>0)>($nb$0>>>0);
   if ($544) {
    $545 = (($543) - ($nb$0))|0;
    HEAP32[(5824)>>2] = $545;
    $546 = HEAP32[(5836)>>2]|0;
    $547 = (($546) + ($nb$0)|0);
    HEAP32[(5836)>>2] = $547;
    $548 = $545 | 1;
    $549 = ((($547)) + 4|0);
    HEAP32[$549>>2] = $548;
    $550 = $nb$0 | 3;
    $551 = ((($546)) + 4|0);
    HEAP32[$551>>2] = $550;
    $552 = ((($546)) + 8|0);
    $mem$2 = $552;
    break;
   }
   $553 = HEAP32[1440]|0;
   $554 = ($553|0)==(0);
   if ($554) {
    (_pthread_mutex_lock(5784)|0);
    $555 = HEAP32[1440]|0;
    $556 = ($555|0)==(0);
    if ($556) {
     HEAP32[(5768)>>2] = 4096;
     HEAP32[(5764)>>2] = 4096;
     HEAP32[(5772)>>2] = -1;
     HEAP32[(5776)>>2] = -1;
     HEAP32[(5780)>>2] = 2;
     HEAP32[(6256)>>2] = 2;
     $557 = (_pthread_mutexattr_init($attr$i$i$i)|0);
     $558 = ($557|0)==(0);
     if ($558) {
      $559 = (_pthread_mutex_init((6260),$attr$i$i$i)|0);
      $560 = ($559|0)==(0);
      if ($560) {
      }
     }
     $561 = $magic$i$i;
     $562 = $561 & -16;
     $563 = $562 ^ 1431655768;
     HEAP32[$magic$i$i>>2] = $563;
     Atomics_store(HEAP32,1440,$563)|0;
    }
    (_pthread_mutex_unlock(5784)|0);
   }
   $564 = (($nb$0) + 48)|0;
   $565 = HEAP32[(5768)>>2]|0;
   $566 = (($nb$0) + 47)|0;
   $567 = (($565) + ($566))|0;
   $568 = (0 - ($565))|0;
   $569 = $567 & $568;
   $570 = ($569>>>0)>($nb$0>>>0);
   if ($570) {
    $571 = HEAP32[(6252)>>2]|0;
    $572 = ($571|0)==(0);
    if (!($572)) {
     $573 = HEAP32[(6244)>>2]|0;
     $574 = (($573) + ($569))|0;
     $575 = ($574>>>0)<=($573>>>0);
     $576 = ($574>>>0)>($571>>>0);
     $or$cond1$i16 = $575 | $576;
     if ($or$cond1$i16) {
      $mem$2 = 0;
      break;
     }
    }
    $577 = HEAP32[(6256)>>2]|0;
    $578 = $577 & 4;
    $579 = ($578|0)==(0);
    if ($579) {
     $580 = HEAP32[(5836)>>2]|0;
     $581 = ($580|0)==(0|0);
     L269: do {
      if ($581) {
       label = 185;
      } else {
       $sp$0$i$i = (6288);
       while(1) {
        $582 = HEAP32[$sp$0$i$i>>2]|0;
        $583 = ($582>>>0)>($580>>>0);
        if (!($583)) {
         $584 = ((($sp$0$i$i)) + 4|0);
         $585 = HEAP32[$584>>2]|0;
         $586 = (($582) + ($585)|0);
         $587 = ($586>>>0)>($580>>>0);
         if ($587) {
          $$lcssa154 = $sp$0$i$i;$$lcssa156 = $584;
          break;
         }
        }
        $588 = ((($sp$0$i$i)) + 8|0);
        $589 = HEAP32[$588>>2]|0;
        $590 = ($589|0)==(0|0);
        if ($590) {
         label = 185;
         break L269;
        } else {
         $sp$0$i$i = $589;
        }
       }
       (_pthread_mutex_lock(5784)|0);
       $613 = HEAP32[(5824)>>2]|0;
       $614 = HEAP32[(5768)>>2]|0;
       $615 = (($566) - ($613))|0;
       $616 = (($615) + ($614))|0;
       $617 = (0 - ($614))|0;
       $618 = $616 & $617;
       $619 = ($618>>>0)<(2147483647);
       if ($619) {
        $620 = (_sbrk(($618|0))|0);
        $621 = HEAP32[$$lcssa154>>2]|0;
        $622 = HEAP32[$$lcssa156>>2]|0;
        $623 = (($621) + ($622)|0);
        $624 = ($620|0)==($623|0);
        if ($624) {
         $625 = ($620|0)==((-1)|0);
         if ($625) {
          $tsize$2243136$i = $618;
          label = 201;
         } else {
          $tbase$3$i = $620;$tsize$3$i = $618;
         }
        } else {
         $br$2$ph$i = $620;$ssize$2$ph$i = $618;
         label = 195;
        }
       } else {
        $tsize$2243136$i = 0;
        label = 201;
       }
      }
     } while(0);
     do {
      if ((label|0) == 185) {
       (_pthread_mutex_lock(5784)|0);
       $591 = (_sbrk(0)|0);
       $592 = ($591|0)==((-1)|0);
       if ($592) {
        $tsize$2243136$i = 0;
        label = 201;
       } else {
        $593 = $591;
        $594 = HEAP32[(5764)>>2]|0;
        $595 = (($594) + -1)|0;
        $596 = $595 & $593;
        $597 = ($596|0)==(0);
        if ($597) {
         $ssize$0$i = $569;
        } else {
         $598 = (($595) + ($593))|0;
         $599 = (0 - ($594))|0;
         $600 = $598 & $599;
         $601 = (($569) - ($593))|0;
         $602 = (($601) + ($600))|0;
         $ssize$0$i = $602;
        }
        $603 = HEAP32[(6244)>>2]|0;
        $604 = (($603) + ($ssize$0$i))|0;
        $605 = ($ssize$0$i>>>0)>($nb$0>>>0);
        $606 = ($ssize$0$i>>>0)<(2147483647);
        $or$cond$i17 = $605 & $606;
        if ($or$cond$i17) {
         $607 = HEAP32[(6252)>>2]|0;
         $608 = ($607|0)==(0);
         if (!($608)) {
          $609 = ($604>>>0)<=($603>>>0);
          $610 = ($604>>>0)>($607>>>0);
          $or$cond2$i = $609 | $610;
          if ($or$cond2$i) {
           $tsize$2243136$i = 0;
           label = 201;
           break;
          }
         }
         $611 = (_sbrk(($ssize$0$i|0))|0);
         $612 = ($611|0)==($591|0);
         if ($612) {
          $tbase$3$i = $591;$tsize$3$i = $ssize$0$i;
         } else {
          $br$2$ph$i = $611;$ssize$2$ph$i = $ssize$0$i;
          label = 195;
         }
        } else {
         $tsize$2243136$i = 0;
         label = 201;
        }
       }
      }
     } while(0);
     L289: do {
      if ((label|0) == 195) {
       $626 = (0 - ($ssize$2$ph$i))|0;
       $627 = ($br$2$ph$i|0)!=((-1)|0);
       $628 = ($ssize$2$ph$i>>>0)<(2147483647);
       $or$cond7$i = $628 & $627;
       $629 = ($564>>>0)>($ssize$2$ph$i>>>0);
       $or$cond8$i = $629 & $or$cond7$i;
       do {
        if ($or$cond8$i) {
         $630 = HEAP32[(5768)>>2]|0;
         $631 = (($566) - ($ssize$2$ph$i))|0;
         $632 = (($631) + ($630))|0;
         $633 = (0 - ($630))|0;
         $634 = $632 & $633;
         $635 = ($634>>>0)<(2147483647);
         if ($635) {
          $636 = (_sbrk(($634|0))|0);
          $637 = ($636|0)==((-1)|0);
          if ($637) {
           (_sbrk(($626|0))|0);
           $tsize$2243136$i = 0;
           label = 201;
           break L289;
          } else {
           $638 = (($634) + ($ssize$2$ph$i))|0;
           $ssize$5$i = $638;
           break;
          }
         } else {
          $ssize$5$i = $ssize$2$ph$i;
         }
        } else {
         $ssize$5$i = $ssize$2$ph$i;
        }
       } while(0);
       $639 = ($br$2$ph$i|0)==((-1)|0);
       if ($639) {
        $tsize$2243136$i = 0;
        label = 201;
       } else {
        $tbase$3$i = $br$2$ph$i;$tsize$3$i = $ssize$5$i;
       }
      }
     } while(0);
     if ((label|0) == 201) {
      $640 = HEAP32[(6256)>>2]|0;
      $641 = $640 | 4;
      HEAP32[(6256)>>2] = $641;
      $tbase$3$i = (-1);$tsize$3$i = $tsize$2243136$i;
     }
     (_pthread_mutex_unlock(5784)|0);
     $tbase$4$i = $tbase$3$i;$tsize$4$i = $tsize$3$i;
    } else {
     $tbase$4$i = (-1);$tsize$4$i = 0;
    }
    $642 = ($tbase$4$i|0)==((-1)|0);
    $643 = ($569>>>0)<(2147483647);
    $or$cond9$i = $643 & $642;
    if ($or$cond9$i) {
     (_pthread_mutex_lock(5784)|0);
     $644 = (_sbrk(($569|0))|0);
     $645 = (_sbrk(0)|0);
     (_pthread_mutex_unlock(5784)|0);
     $646 = ($644|0)!=((-1)|0);
     $647 = ($645|0)!=((-1)|0);
     $or$cond5$i = $646 & $647;
     $648 = ($644>>>0)<($645>>>0);
     $or$cond10$i = $648 & $or$cond5$i;
     if ($or$cond10$i) {
      $649 = $645;
      $650 = $644;
      $651 = (($649) - ($650))|0;
      $652 = (($nb$0) + 40)|0;
      $653 = ($651>>>0)>($652>>>0);
      if ($653) {
       $tbase$7$i = $644;$tsize$7$i = $651;
       label = 206;
      }
     }
    } else {
     $tbase$7$i = $tbase$4$i;$tsize$7$i = $tsize$4$i;
     label = 206;
    }
    if ((label|0) == 206) {
     $654 = ($tbase$7$i|0)==((-1)|0);
     if (!($654)) {
      $655 = HEAP32[(6244)>>2]|0;
      $656 = (($655) + ($tsize$7$i))|0;
      HEAP32[(6244)>>2] = $656;
      $657 = HEAP32[(6248)>>2]|0;
      $658 = ($656>>>0)>($657>>>0);
      if ($658) {
       HEAP32[(6248)>>2] = $656;
      }
      $659 = HEAP32[(5836)>>2]|0;
      $660 = ($659|0)==(0|0);
      do {
       if ($660) {
        $661 = HEAP32[(5828)>>2]|0;
        $662 = ($661|0)==(0|0);
        $663 = ($tbase$7$i>>>0)<($661>>>0);
        $or$cond11$i = $662 | $663;
        if ($or$cond11$i) {
         HEAP32[(5828)>>2] = $tbase$7$i;
        }
        HEAP32[(6288)>>2] = $tbase$7$i;
        HEAP32[(6292)>>2] = $tsize$7$i;
        HEAP32[(6300)>>2] = 0;
        $664 = HEAP32[1440]|0;
        HEAP32[(5848)>>2] = $664;
        HEAP32[(5844)>>2] = -1;
        $i$01$i$i = 0;
        while(1) {
         $665 = $i$01$i$i << 1;
         $666 = (5852 + ($665<<2)|0);
         $667 = ((($666)) + 12|0);
         HEAP32[$667>>2] = $666;
         $668 = ((($666)) + 8|0);
         HEAP32[$668>>2] = $666;
         $669 = (($i$01$i$i) + 1)|0;
         $exitcond$i$i = ($669|0)==(32);
         if ($exitcond$i$i) {
          break;
         } else {
          $i$01$i$i = $669;
         }
        }
        $670 = (($tsize$7$i) + -40)|0;
        $671 = ((($tbase$7$i)) + 8|0);
        $672 = $671;
        $673 = $672 & 7;
        $674 = ($673|0)==(0);
        $675 = (0 - ($672))|0;
        $676 = $675 & 7;
        $677 = $674 ? 0 : $676;
        $678 = (($tbase$7$i) + ($677)|0);
        $679 = (($670) - ($677))|0;
        HEAP32[(5836)>>2] = $678;
        HEAP32[(5824)>>2] = $679;
        $680 = $679 | 1;
        $681 = ((($678)) + 4|0);
        HEAP32[$681>>2] = $680;
        $682 = (($678) + ($679)|0);
        $683 = ((($682)) + 4|0);
        HEAP32[$683>>2] = 40;
        $684 = HEAP32[(5776)>>2]|0;
        HEAP32[(5840)>>2] = $684;
       } else {
        $sp$058$i = (6288);
        while(1) {
         $685 = HEAP32[$sp$058$i>>2]|0;
         $686 = ((($sp$058$i)) + 4|0);
         $687 = HEAP32[$686>>2]|0;
         $688 = (($685) + ($687)|0);
         $689 = ($tbase$7$i|0)==($688|0);
         if ($689) {
          $$lcssa148 = $685;$$lcssa150 = $686;$$lcssa152 = $687;$sp$058$i$lcssa = $sp$058$i;
          label = 217;
          break;
         }
         $690 = ((($sp$058$i)) + 8|0);
         $691 = HEAP32[$690>>2]|0;
         $692 = ($691|0)==(0|0);
         if ($692) {
          break;
         } else {
          $sp$058$i = $691;
         }
        }
        if ((label|0) == 217) {
         $693 = ((($sp$058$i$lcssa)) + 12|0);
         $694 = HEAP32[$693>>2]|0;
         $695 = $694 & 8;
         $696 = ($695|0)==(0);
         if ($696) {
          $697 = ($659>>>0)>=($$lcssa148>>>0);
          $698 = ($659>>>0)<($tbase$7$i>>>0);
          $or$cond38$i = $698 & $697;
          if ($or$cond38$i) {
           $699 = (($$lcssa152) + ($tsize$7$i))|0;
           HEAP32[$$lcssa150>>2] = $699;
           $700 = HEAP32[(5824)>>2]|0;
           $701 = ((($659)) + 8|0);
           $702 = $701;
           $703 = $702 & 7;
           $704 = ($703|0)==(0);
           $705 = (0 - ($702))|0;
           $706 = $705 & 7;
           $707 = $704 ? 0 : $706;
           $708 = (($659) + ($707)|0);
           $709 = (($tsize$7$i) - ($707))|0;
           $710 = (($709) + ($700))|0;
           HEAP32[(5836)>>2] = $708;
           HEAP32[(5824)>>2] = $710;
           $711 = $710 | 1;
           $712 = ((($708)) + 4|0);
           HEAP32[$712>>2] = $711;
           $713 = (($708) + ($710)|0);
           $714 = ((($713)) + 4|0);
           HEAP32[$714>>2] = 40;
           $715 = HEAP32[(5776)>>2]|0;
           HEAP32[(5840)>>2] = $715;
           break;
          }
         }
        }
        $716 = HEAP32[(5828)>>2]|0;
        $717 = ($tbase$7$i>>>0)<($716>>>0);
        if ($717) {
         HEAP32[(5828)>>2] = $tbase$7$i;
         $781 = $tbase$7$i;
        } else {
         $781 = $716;
        }
        $718 = (($tbase$7$i) + ($tsize$7$i)|0);
        $sp$157$i = (6288);
        while(1) {
         $719 = HEAP32[$sp$157$i>>2]|0;
         $720 = ($719|0)==($718|0);
         if ($720) {
          $$lcssa145 = $sp$157$i;$sp$157$i$lcssa = $sp$157$i;
          label = 225;
          break;
         }
         $721 = ((($sp$157$i)) + 8|0);
         $722 = HEAP32[$721>>2]|0;
         $723 = ($722|0)==(0|0);
         if ($723) {
          $sp$0$i$i$i = (6288);
          break;
         } else {
          $sp$157$i = $722;
         }
        }
        if ((label|0) == 225) {
         $724 = ((($sp$157$i$lcssa)) + 12|0);
         $725 = HEAP32[$724>>2]|0;
         $726 = $725 & 8;
         $727 = ($726|0)==(0);
         if ($727) {
          HEAP32[$$lcssa145>>2] = $tbase$7$i;
          $728 = ((($sp$157$i$lcssa)) + 4|0);
          $729 = HEAP32[$728>>2]|0;
          $730 = (($729) + ($tsize$7$i))|0;
          HEAP32[$728>>2] = $730;
          $731 = ((($tbase$7$i)) + 8|0);
          $732 = $731;
          $733 = $732 & 7;
          $734 = ($733|0)==(0);
          $735 = (0 - ($732))|0;
          $736 = $735 & 7;
          $737 = $734 ? 0 : $736;
          $738 = (($tbase$7$i) + ($737)|0);
          $739 = ((($718)) + 8|0);
          $740 = $739;
          $741 = $740 & 7;
          $742 = ($741|0)==(0);
          $743 = (0 - ($740))|0;
          $744 = $743 & 7;
          $745 = $742 ? 0 : $744;
          $746 = (($718) + ($745)|0);
          $747 = $746;
          $748 = $738;
          $749 = (($747) - ($748))|0;
          $750 = (($738) + ($nb$0)|0);
          $751 = (($749) - ($nb$0))|0;
          $752 = $nb$0 | 3;
          $753 = ((($738)) + 4|0);
          HEAP32[$753>>2] = $752;
          $754 = ($746|0)==($659|0);
          do {
           if ($754) {
            $755 = HEAP32[(5824)>>2]|0;
            $756 = (($755) + ($751))|0;
            HEAP32[(5824)>>2] = $756;
            HEAP32[(5836)>>2] = $750;
            $757 = $756 | 1;
            $758 = ((($750)) + 4|0);
            HEAP32[$758>>2] = $757;
           } else {
            $759 = HEAP32[(5832)>>2]|0;
            $760 = ($746|0)==($759|0);
            if ($760) {
             $761 = HEAP32[(5820)>>2]|0;
             $762 = (($761) + ($751))|0;
             HEAP32[(5820)>>2] = $762;
             HEAP32[(5832)>>2] = $750;
             $763 = $762 | 1;
             $764 = ((($750)) + 4|0);
             HEAP32[$764>>2] = $763;
             $765 = (($750) + ($762)|0);
             HEAP32[$765>>2] = $762;
             break;
            }
            $766 = ((($746)) + 4|0);
            $767 = HEAP32[$766>>2]|0;
            $768 = $767 & 3;
            $769 = ($768|0)==(1);
            if ($769) {
             $770 = $767 & -8;
             $771 = $767 >>> 3;
             $772 = ($767>>>0)<(256);
             L344: do {
              if ($772) {
               $773 = ((($746)) + 8|0);
               $774 = HEAP32[$773>>2]|0;
               $775 = ((($746)) + 12|0);
               $776 = HEAP32[$775>>2]|0;
               $777 = $771 << 1;
               $778 = (5852 + ($777<<2)|0);
               $779 = ($774|0)==($778|0);
               do {
                if (!($779)) {
                 $780 = ($774>>>0)<($781>>>0);
                 if ($780) {
                  _abort();
                  // unreachable;
                 }
                 $782 = ((($774)) + 12|0);
                 $783 = HEAP32[$782>>2]|0;
                 $784 = ($783|0)==($746|0);
                 if ($784) {
                  break;
                 }
                 _abort();
                 // unreachable;
                }
               } while(0);
               $785 = ($776|0)==($774|0);
               if ($785) {
                $786 = 1 << $771;
                $787 = $786 ^ -1;
                $788 = HEAP32[1453]|0;
                $789 = $788 & $787;
                HEAP32[1453] = $789;
                break;
               }
               $790 = ($776|0)==($778|0);
               do {
                if ($790) {
                 $$pre9$i$i = ((($776)) + 8|0);
                 $$pre$phi10$i$iZ2D = $$pre9$i$i;
                } else {
                 $791 = ($776>>>0)<($781>>>0);
                 if ($791) {
                  _abort();
                  // unreachable;
                 }
                 $792 = ((($776)) + 8|0);
                 $793 = HEAP32[$792>>2]|0;
                 $794 = ($793|0)==($746|0);
                 if ($794) {
                  $$pre$phi10$i$iZ2D = $792;
                  break;
                 }
                 _abort();
                 // unreachable;
                }
               } while(0);
               $795 = ((($774)) + 12|0);
               HEAP32[$795>>2] = $776;
               HEAP32[$$pre$phi10$i$iZ2D>>2] = $774;
              } else {
               $796 = ((($746)) + 24|0);
               $797 = HEAP32[$796>>2]|0;
               $798 = ((($746)) + 12|0);
               $799 = HEAP32[$798>>2]|0;
               $800 = ($799|0)==($746|0);
               do {
                if ($800) {
                 $810 = ((($746)) + 16|0);
                 $811 = ((($810)) + 4|0);
                 $812 = HEAP32[$811>>2]|0;
                 $813 = ($812|0)==(0|0);
                 if ($813) {
                  $814 = HEAP32[$810>>2]|0;
                  $815 = ($814|0)==(0|0);
                  if ($815) {
                   $R$3$i$i = 0;
                   break;
                  } else {
                   $R$1$i$i = $814;$RP$1$i$i = $810;
                  }
                 } else {
                  $R$1$i$i = $812;$RP$1$i$i = $811;
                 }
                 while(1) {
                  $816 = ((($R$1$i$i)) + 20|0);
                  $817 = HEAP32[$816>>2]|0;
                  $818 = ($817|0)==(0|0);
                  if (!($818)) {
                   $R$1$i$i = $817;$RP$1$i$i = $816;
                   continue;
                  }
                  $819 = ((($R$1$i$i)) + 16|0);
                  $820 = HEAP32[$819>>2]|0;
                  $821 = ($820|0)==(0|0);
                  if ($821) {
                   $R$1$i$i$lcssa = $R$1$i$i;$RP$1$i$i$lcssa = $RP$1$i$i;
                   break;
                  } else {
                   $R$1$i$i = $820;$RP$1$i$i = $819;
                  }
                 }
                 $822 = ($RP$1$i$i$lcssa>>>0)<($781>>>0);
                 if ($822) {
                  _abort();
                  // unreachable;
                 } else {
                  HEAP32[$RP$1$i$i$lcssa>>2] = 0;
                  $R$3$i$i = $R$1$i$i$lcssa;
                  break;
                 }
                } else {
                 $801 = ((($746)) + 8|0);
                 $802 = HEAP32[$801>>2]|0;
                 $803 = ($802>>>0)<($781>>>0);
                 if ($803) {
                  _abort();
                  // unreachable;
                 }
                 $804 = ((($802)) + 12|0);
                 $805 = HEAP32[$804>>2]|0;
                 $806 = ($805|0)==($746|0);
                 if (!($806)) {
                  _abort();
                  // unreachable;
                 }
                 $807 = ((($799)) + 8|0);
                 $808 = HEAP32[$807>>2]|0;
                 $809 = ($808|0)==($746|0);
                 if ($809) {
                  HEAP32[$804>>2] = $799;
                  HEAP32[$807>>2] = $802;
                  $R$3$i$i = $799;
                  break;
                 } else {
                  _abort();
                  // unreachable;
                 }
                }
               } while(0);
               $823 = ($797|0)==(0|0);
               if ($823) {
                break;
               }
               $824 = ((($746)) + 28|0);
               $825 = HEAP32[$824>>2]|0;
               $826 = (6116 + ($825<<2)|0);
               $827 = HEAP32[$826>>2]|0;
               $828 = ($746|0)==($827|0);
               do {
                if ($828) {
                 HEAP32[$826>>2] = $R$3$i$i;
                 $cond$i$i = ($R$3$i$i|0)==(0|0);
                 if (!($cond$i$i)) {
                  break;
                 }
                 $829 = 1 << $825;
                 $830 = $829 ^ -1;
                 $831 = HEAP32[(5816)>>2]|0;
                 $832 = $831 & $830;
                 HEAP32[(5816)>>2] = $832;
                 break L344;
                } else {
                 $833 = HEAP32[(5828)>>2]|0;
                 $834 = ($797>>>0)<($833>>>0);
                 if ($834) {
                  _abort();
                  // unreachable;
                 }
                 $835 = ((($797)) + 16|0);
                 $836 = HEAP32[$835>>2]|0;
                 $837 = ($836|0)==($746|0);
                 if ($837) {
                  HEAP32[$835>>2] = $R$3$i$i;
                 } else {
                  $838 = ((($797)) + 20|0);
                  HEAP32[$838>>2] = $R$3$i$i;
                 }
                 $839 = ($R$3$i$i|0)==(0|0);
                 if ($839) {
                  break L344;
                 }
                }
               } while(0);
               $840 = HEAP32[(5828)>>2]|0;
               $841 = ($R$3$i$i>>>0)<($840>>>0);
               if ($841) {
                _abort();
                // unreachable;
               }
               $842 = ((($R$3$i$i)) + 24|0);
               HEAP32[$842>>2] = $797;
               $843 = ((($746)) + 16|0);
               $844 = HEAP32[$843>>2]|0;
               $845 = ($844|0)==(0|0);
               do {
                if (!($845)) {
                 $846 = ($844>>>0)<($840>>>0);
                 if ($846) {
                  _abort();
                  // unreachable;
                 } else {
                  $847 = ((($R$3$i$i)) + 16|0);
                  HEAP32[$847>>2] = $844;
                  $848 = ((($844)) + 24|0);
                  HEAP32[$848>>2] = $R$3$i$i;
                  break;
                 }
                }
               } while(0);
               $849 = ((($843)) + 4|0);
               $850 = HEAP32[$849>>2]|0;
               $851 = ($850|0)==(0|0);
               if ($851) {
                break;
               }
               $852 = HEAP32[(5828)>>2]|0;
               $853 = ($850>>>0)<($852>>>0);
               if ($853) {
                _abort();
                // unreachable;
               } else {
                $854 = ((($R$3$i$i)) + 20|0);
                HEAP32[$854>>2] = $850;
                $855 = ((($850)) + 24|0);
                HEAP32[$855>>2] = $R$3$i$i;
                break;
               }
              }
             } while(0);
             $856 = (($746) + ($770)|0);
             $857 = (($770) + ($751))|0;
             $oldfirst$0$i$i = $856;$qsize$0$i$i = $857;
            } else {
             $oldfirst$0$i$i = $746;$qsize$0$i$i = $751;
            }
            $858 = ((($oldfirst$0$i$i)) + 4|0);
            $859 = HEAP32[$858>>2]|0;
            $860 = $859 & -2;
            HEAP32[$858>>2] = $860;
            $861 = $qsize$0$i$i | 1;
            $862 = ((($750)) + 4|0);
            HEAP32[$862>>2] = $861;
            $863 = (($750) + ($qsize$0$i$i)|0);
            HEAP32[$863>>2] = $qsize$0$i$i;
            $864 = $qsize$0$i$i >>> 3;
            $865 = ($qsize$0$i$i>>>0)<(256);
            if ($865) {
             $866 = $864 << 1;
             $867 = (5852 + ($866<<2)|0);
             $868 = HEAP32[1453]|0;
             $869 = 1 << $864;
             $870 = $868 & $869;
             $871 = ($870|0)==(0);
             do {
              if ($871) {
               $872 = $868 | $869;
               HEAP32[1453] = $872;
               $$pre$i$i = ((($867)) + 8|0);
               $$pre$phi$i$iZ2D = $$pre$i$i;$F4$0$i$i = $867;
              } else {
               $873 = ((($867)) + 8|0);
               $874 = HEAP32[$873>>2]|0;
               $875 = HEAP32[(5828)>>2]|0;
               $876 = ($874>>>0)<($875>>>0);
               if (!($876)) {
                $$pre$phi$i$iZ2D = $873;$F4$0$i$i = $874;
                break;
               }
               _abort();
               // unreachable;
              }
             } while(0);
             HEAP32[$$pre$phi$i$iZ2D>>2] = $750;
             $877 = ((($F4$0$i$i)) + 12|0);
             HEAP32[$877>>2] = $750;
             $878 = ((($750)) + 8|0);
             HEAP32[$878>>2] = $F4$0$i$i;
             $879 = ((($750)) + 12|0);
             HEAP32[$879>>2] = $867;
             break;
            }
            $880 = $qsize$0$i$i >>> 8;
            $881 = ($880|0)==(0);
            do {
             if ($881) {
              $I7$0$i$i = 0;
             } else {
              $882 = ($qsize$0$i$i>>>0)>(16777215);
              if ($882) {
               $I7$0$i$i = 31;
               break;
              }
              $883 = (($880) + 1048320)|0;
              $884 = $883 >>> 16;
              $885 = $884 & 8;
              $886 = $880 << $885;
              $887 = (($886) + 520192)|0;
              $888 = $887 >>> 16;
              $889 = $888 & 4;
              $890 = $889 | $885;
              $891 = $886 << $889;
              $892 = (($891) + 245760)|0;
              $893 = $892 >>> 16;
              $894 = $893 & 2;
              $895 = $890 | $894;
              $896 = (14 - ($895))|0;
              $897 = $891 << $894;
              $898 = $897 >>> 15;
              $899 = (($896) + ($898))|0;
              $900 = $899 << 1;
              $901 = (($899) + 7)|0;
              $902 = $qsize$0$i$i >>> $901;
              $903 = $902 & 1;
              $904 = $903 | $900;
              $I7$0$i$i = $904;
             }
            } while(0);
            $905 = (6116 + ($I7$0$i$i<<2)|0);
            $906 = ((($750)) + 28|0);
            HEAP32[$906>>2] = $I7$0$i$i;
            $907 = ((($750)) + 16|0);
            $908 = ((($907)) + 4|0);
            HEAP32[$908>>2] = 0;
            HEAP32[$907>>2] = 0;
            $909 = HEAP32[(5816)>>2]|0;
            $910 = 1 << $I7$0$i$i;
            $911 = $909 & $910;
            $912 = ($911|0)==(0);
            if ($912) {
             $913 = $909 | $910;
             HEAP32[(5816)>>2] = $913;
             HEAP32[$905>>2] = $750;
             $914 = ((($750)) + 24|0);
             HEAP32[$914>>2] = $905;
             $915 = ((($750)) + 12|0);
             HEAP32[$915>>2] = $750;
             $916 = ((($750)) + 8|0);
             HEAP32[$916>>2] = $750;
             break;
            }
            $917 = HEAP32[$905>>2]|0;
            $918 = ($I7$0$i$i|0)==(31);
            $919 = $I7$0$i$i >>> 1;
            $920 = (25 - ($919))|0;
            $921 = $918 ? 0 : $920;
            $922 = $qsize$0$i$i << $921;
            $K8$0$i$i = $922;$T$0$i$i = $917;
            while(1) {
             $923 = ((($T$0$i$i)) + 4|0);
             $924 = HEAP32[$923>>2]|0;
             $925 = $924 & -8;
             $926 = ($925|0)==($qsize$0$i$i|0);
             if ($926) {
              $T$0$i$i$lcssa = $T$0$i$i;
              label = 295;
              break;
             }
             $927 = $K8$0$i$i >>> 31;
             $928 = (((($T$0$i$i)) + 16|0) + ($927<<2)|0);
             $929 = $K8$0$i$i << 1;
             $930 = HEAP32[$928>>2]|0;
             $931 = ($930|0)==(0|0);
             if ($931) {
              $$lcssa = $928;$T$0$i$i$lcssa140 = $T$0$i$i;
              label = 292;
              break;
             } else {
              $K8$0$i$i = $929;$T$0$i$i = $930;
             }
            }
            if ((label|0) == 292) {
             $932 = HEAP32[(5828)>>2]|0;
             $933 = ($$lcssa>>>0)<($932>>>0);
             if ($933) {
              _abort();
              // unreachable;
             } else {
              HEAP32[$$lcssa>>2] = $750;
              $934 = ((($750)) + 24|0);
              HEAP32[$934>>2] = $T$0$i$i$lcssa140;
              $935 = ((($750)) + 12|0);
              HEAP32[$935>>2] = $750;
              $936 = ((($750)) + 8|0);
              HEAP32[$936>>2] = $750;
              break;
             }
            }
            else if ((label|0) == 295) {
             $937 = ((($T$0$i$i$lcssa)) + 8|0);
             $938 = HEAP32[$937>>2]|0;
             $939 = HEAP32[(5828)>>2]|0;
             $940 = ($938>>>0)>=($939>>>0);
             $not$$i$i = ($T$0$i$i$lcssa>>>0)>=($939>>>0);
             $941 = $940 & $not$$i$i;
             if ($941) {
              $942 = ((($938)) + 12|0);
              HEAP32[$942>>2] = $750;
              HEAP32[$937>>2] = $750;
              $943 = ((($750)) + 8|0);
              HEAP32[$943>>2] = $938;
              $944 = ((($750)) + 12|0);
              HEAP32[$944>>2] = $T$0$i$i$lcssa;
              $945 = ((($750)) + 24|0);
              HEAP32[$945>>2] = 0;
              break;
             } else {
              _abort();
              // unreachable;
             }
            }
           }
          } while(0);
          $1076 = ((($738)) + 8|0);
          $mem$2 = $1076;
          break L241;
         } else {
          $sp$0$i$i$i = (6288);
         }
        }
        while(1) {
         $946 = HEAP32[$sp$0$i$i$i>>2]|0;
         $947 = ($946>>>0)>($659>>>0);
         if (!($947)) {
          $948 = ((($sp$0$i$i$i)) + 4|0);
          $949 = HEAP32[$948>>2]|0;
          $950 = (($946) + ($949)|0);
          $951 = ($950>>>0)>($659>>>0);
          if ($951) {
           $$lcssa143 = $950;
           break;
          }
         }
         $952 = ((($sp$0$i$i$i)) + 8|0);
         $953 = HEAP32[$952>>2]|0;
         $sp$0$i$i$i = $953;
        }
        $954 = ((($$lcssa143)) + -47|0);
        $955 = ((($954)) + 8|0);
        $956 = $955;
        $957 = $956 & 7;
        $958 = ($957|0)==(0);
        $959 = (0 - ($956))|0;
        $960 = $959 & 7;
        $961 = $958 ? 0 : $960;
        $962 = (($954) + ($961)|0);
        $963 = ((($659)) + 16|0);
        $964 = ($962>>>0)<($963>>>0);
        $965 = $964 ? $659 : $962;
        $966 = ((($965)) + 8|0);
        $967 = ((($965)) + 24|0);
        $968 = (($tsize$7$i) + -40)|0;
        $969 = ((($tbase$7$i)) + 8|0);
        $970 = $969;
        $971 = $970 & 7;
        $972 = ($971|0)==(0);
        $973 = (0 - ($970))|0;
        $974 = $973 & 7;
        $975 = $972 ? 0 : $974;
        $976 = (($tbase$7$i) + ($975)|0);
        $977 = (($968) - ($975))|0;
        HEAP32[(5836)>>2] = $976;
        HEAP32[(5824)>>2] = $977;
        $978 = $977 | 1;
        $979 = ((($976)) + 4|0);
        HEAP32[$979>>2] = $978;
        $980 = (($976) + ($977)|0);
        $981 = ((($980)) + 4|0);
        HEAP32[$981>>2] = 40;
        $982 = HEAP32[(5776)>>2]|0;
        HEAP32[(5840)>>2] = $982;
        $983 = ((($965)) + 4|0);
        HEAP32[$983>>2] = 27;
        ;HEAP32[$966>>2]=HEAP32[(6288)>>2]|0;HEAP32[$966+4>>2]=HEAP32[(6288)+4>>2]|0;HEAP32[$966+8>>2]=HEAP32[(6288)+8>>2]|0;HEAP32[$966+12>>2]=HEAP32[(6288)+12>>2]|0;
        HEAP32[(6288)>>2] = $tbase$7$i;
        HEAP32[(6292)>>2] = $tsize$7$i;
        HEAP32[(6300)>>2] = 0;
        HEAP32[(6296)>>2] = $966;
        $p$0$i$i = $967;
        while(1) {
         $984 = ((($p$0$i$i)) + 4|0);
         HEAP32[$984>>2] = 7;
         $985 = ((($984)) + 4|0);
         $986 = ($985>>>0)<($$lcssa143>>>0);
         if ($986) {
          $p$0$i$i = $984;
         } else {
          break;
         }
        }
        $987 = ($965|0)==($659|0);
        if (!($987)) {
         $988 = $965;
         $989 = $659;
         $990 = (($988) - ($989))|0;
         $991 = HEAP32[$983>>2]|0;
         $992 = $991 & -2;
         HEAP32[$983>>2] = $992;
         $993 = $990 | 1;
         $994 = ((($659)) + 4|0);
         HEAP32[$994>>2] = $993;
         HEAP32[$965>>2] = $990;
         $995 = $990 >>> 3;
         $996 = ($990>>>0)<(256);
         if ($996) {
          $997 = $995 << 1;
          $998 = (5852 + ($997<<2)|0);
          $999 = HEAP32[1453]|0;
          $1000 = 1 << $995;
          $1001 = $999 & $1000;
          $1002 = ($1001|0)==(0);
          do {
           if ($1002) {
            $1003 = $999 | $1000;
            HEAP32[1453] = $1003;
            $$pre$i16$i = ((($998)) + 8|0);
            $$pre$phi$i17$iZ2D = $$pre$i16$i;$F$0$i$i = $998;
           } else {
            $1004 = ((($998)) + 8|0);
            $1005 = HEAP32[$1004>>2]|0;
            $1006 = HEAP32[(5828)>>2]|0;
            $1007 = ($1005>>>0)<($1006>>>0);
            if (!($1007)) {
             $$pre$phi$i17$iZ2D = $1004;$F$0$i$i = $1005;
             break;
            }
            _abort();
            // unreachable;
           }
          } while(0);
          HEAP32[$$pre$phi$i17$iZ2D>>2] = $659;
          $1008 = ((($F$0$i$i)) + 12|0);
          HEAP32[$1008>>2] = $659;
          $1009 = ((($659)) + 8|0);
          HEAP32[$1009>>2] = $F$0$i$i;
          $1010 = ((($659)) + 12|0);
          HEAP32[$1010>>2] = $998;
          break;
         }
         $1011 = $990 >>> 8;
         $1012 = ($1011|0)==(0);
         do {
          if ($1012) {
           $I1$0$i$i = 0;
          } else {
           $1013 = ($990>>>0)>(16777215);
           if ($1013) {
            $I1$0$i$i = 31;
            break;
           }
           $1014 = (($1011) + 1048320)|0;
           $1015 = $1014 >>> 16;
           $1016 = $1015 & 8;
           $1017 = $1011 << $1016;
           $1018 = (($1017) + 520192)|0;
           $1019 = $1018 >>> 16;
           $1020 = $1019 & 4;
           $1021 = $1020 | $1016;
           $1022 = $1017 << $1020;
           $1023 = (($1022) + 245760)|0;
           $1024 = $1023 >>> 16;
           $1025 = $1024 & 2;
           $1026 = $1021 | $1025;
           $1027 = (14 - ($1026))|0;
           $1028 = $1022 << $1025;
           $1029 = $1028 >>> 15;
           $1030 = (($1027) + ($1029))|0;
           $1031 = $1030 << 1;
           $1032 = (($1030) + 7)|0;
           $1033 = $990 >>> $1032;
           $1034 = $1033 & 1;
           $1035 = $1034 | $1031;
           $I1$0$i$i = $1035;
          }
         } while(0);
         $1036 = (6116 + ($I1$0$i$i<<2)|0);
         $1037 = ((($659)) + 28|0);
         HEAP32[$1037>>2] = $I1$0$i$i;
         $1038 = ((($659)) + 20|0);
         HEAP32[$1038>>2] = 0;
         HEAP32[$963>>2] = 0;
         $1039 = HEAP32[(5816)>>2]|0;
         $1040 = 1 << $I1$0$i$i;
         $1041 = $1039 & $1040;
         $1042 = ($1041|0)==(0);
         if ($1042) {
          $1043 = $1039 | $1040;
          HEAP32[(5816)>>2] = $1043;
          HEAP32[$1036>>2] = $659;
          $1044 = ((($659)) + 24|0);
          HEAP32[$1044>>2] = $1036;
          $1045 = ((($659)) + 12|0);
          HEAP32[$1045>>2] = $659;
          $1046 = ((($659)) + 8|0);
          HEAP32[$1046>>2] = $659;
          break;
         }
         $1047 = HEAP32[$1036>>2]|0;
         $1048 = ($I1$0$i$i|0)==(31);
         $1049 = $I1$0$i$i >>> 1;
         $1050 = (25 - ($1049))|0;
         $1051 = $1048 ? 0 : $1050;
         $1052 = $990 << $1051;
         $K2$0$i$i = $1052;$T$0$i18$i = $1047;
         while(1) {
          $1053 = ((($T$0$i18$i)) + 4|0);
          $1054 = HEAP32[$1053>>2]|0;
          $1055 = $1054 & -8;
          $1056 = ($1055|0)==($990|0);
          if ($1056) {
           $T$0$i18$i$lcssa = $T$0$i18$i;
           label = 321;
           break;
          }
          $1057 = $K2$0$i$i >>> 31;
          $1058 = (((($T$0$i18$i)) + 16|0) + ($1057<<2)|0);
          $1059 = $K2$0$i$i << 1;
          $1060 = HEAP32[$1058>>2]|0;
          $1061 = ($1060|0)==(0|0);
          if ($1061) {
           $$lcssa142 = $1058;$T$0$i18$i$lcssa141 = $T$0$i18$i;
           label = 318;
           break;
          } else {
           $K2$0$i$i = $1059;$T$0$i18$i = $1060;
          }
         }
         if ((label|0) == 318) {
          $1062 = HEAP32[(5828)>>2]|0;
          $1063 = ($$lcssa142>>>0)<($1062>>>0);
          if ($1063) {
           _abort();
           // unreachable;
          } else {
           HEAP32[$$lcssa142>>2] = $659;
           $1064 = ((($659)) + 24|0);
           HEAP32[$1064>>2] = $T$0$i18$i$lcssa141;
           $1065 = ((($659)) + 12|0);
           HEAP32[$1065>>2] = $659;
           $1066 = ((($659)) + 8|0);
           HEAP32[$1066>>2] = $659;
           break;
          }
         }
         else if ((label|0) == 321) {
          $1067 = ((($T$0$i18$i$lcssa)) + 8|0);
          $1068 = HEAP32[$1067>>2]|0;
          $1069 = HEAP32[(5828)>>2]|0;
          $1070 = ($1068>>>0)>=($1069>>>0);
          $not$$i20$i = ($T$0$i18$i$lcssa>>>0)>=($1069>>>0);
          $1071 = $1070 & $not$$i20$i;
          if ($1071) {
           $1072 = ((($1068)) + 12|0);
           HEAP32[$1072>>2] = $659;
           HEAP32[$1067>>2] = $659;
           $1073 = ((($659)) + 8|0);
           HEAP32[$1073>>2] = $1068;
           $1074 = ((($659)) + 12|0);
           HEAP32[$1074>>2] = $T$0$i18$i$lcssa;
           $1075 = ((($659)) + 24|0);
           HEAP32[$1075>>2] = 0;
           break;
          } else {
           _abort();
           // unreachable;
          }
         }
        }
       }
      } while(0);
      $1077 = HEAP32[(5824)>>2]|0;
      $1078 = ($1077>>>0)>($nb$0>>>0);
      if ($1078) {
       $1079 = (($1077) - ($nb$0))|0;
       HEAP32[(5824)>>2] = $1079;
       $1080 = HEAP32[(5836)>>2]|0;
       $1081 = (($1080) + ($nb$0)|0);
       HEAP32[(5836)>>2] = $1081;
       $1082 = $1079 | 1;
       $1083 = ((($1081)) + 4|0);
       HEAP32[$1083>>2] = $1082;
       $1084 = $nb$0 | 3;
       $1085 = ((($1080)) + 4|0);
       HEAP32[$1085>>2] = $1084;
       $1086 = ((($1080)) + 8|0);
       $mem$2 = $1086;
       break;
      }
     }
    }
    $1087 = (___errno_location()|0);
    HEAP32[$1087>>2] = 12;
    $mem$2 = 0;
   } else {
    $mem$2 = 0;
   }
  }
 } while(0);
 $1088 = HEAP32[(6256)>>2]|0;
 $1089 = $1088 & 2;
 $1090 = ($1089|0)==(0);
 if ($1090) {
  $$1 = $mem$2;
  STACKTOP = sp;return ($$1|0);
 }
 (_pthread_mutex_unlock((6260))|0);
 $$1 = $mem$2;
 STACKTOP = sp;return ($$1|0);
}
function _free($mem) {
 $mem = $mem|0;
 var $$lcssa = 0, $$pre = 0, $$pre$phi41Z2D = 0, $$pre$phi43Z2D = 0, $$pre$phiZ2D = 0, $$pre40 = 0, $$pre42 = 0, $0 = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0, $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0;
 var $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0, $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0;
 var $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0, $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0;
 var $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0, $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0;
 var $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0, $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0;
 var $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0, $196 = 0, $197 = 0, $198 = 0, $199 = 0, $2 = 0;
 var $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $204 = 0, $205 = 0, $206 = 0, $207 = 0, $208 = 0, $209 = 0, $21 = 0, $210 = 0, $211 = 0, $212 = 0, $213 = 0, $214 = 0, $215 = 0, $216 = 0, $217 = 0;
 var $218 = 0, $219 = 0, $22 = 0, $220 = 0, $221 = 0, $222 = 0, $223 = 0, $224 = 0, $225 = 0, $226 = 0, $227 = 0, $228 = 0, $229 = 0, $23 = 0, $230 = 0, $231 = 0, $232 = 0, $233 = 0, $234 = 0, $235 = 0;
 var $236 = 0, $237 = 0, $238 = 0, $239 = 0, $24 = 0, $240 = 0, $241 = 0, $242 = 0, $243 = 0, $244 = 0, $245 = 0, $246 = 0, $247 = 0, $248 = 0, $249 = 0, $25 = 0, $250 = 0, $251 = 0, $252 = 0, $253 = 0;
 var $254 = 0, $255 = 0, $256 = 0, $257 = 0, $258 = 0, $259 = 0, $26 = 0, $260 = 0, $261 = 0, $262 = 0, $263 = 0, $264 = 0, $265 = 0, $266 = 0, $267 = 0, $268 = 0, $269 = 0, $27 = 0, $270 = 0, $271 = 0;
 var $272 = 0, $273 = 0, $274 = 0, $275 = 0, $276 = 0, $277 = 0, $278 = 0, $279 = 0, $28 = 0, $280 = 0, $281 = 0, $282 = 0, $283 = 0, $284 = 0, $285 = 0, $286 = 0, $287 = 0, $288 = 0, $289 = 0, $29 = 0;
 var $290 = 0, $291 = 0, $292 = 0, $293 = 0, $294 = 0, $295 = 0, $296 = 0, $297 = 0, $298 = 0, $299 = 0, $3 = 0, $30 = 0, $300 = 0, $301 = 0, $302 = 0, $303 = 0, $304 = 0, $305 = 0, $306 = 0, $307 = 0;
 var $308 = 0, $309 = 0, $31 = 0, $310 = 0, $311 = 0, $312 = 0, $313 = 0, $314 = 0, $315 = 0, $316 = 0, $317 = 0, $318 = 0, $319 = 0, $32 = 0, $320 = 0, $321 = 0, $322 = 0, $323 = 0, $324 = 0, $325 = 0;
 var $326 = 0, $327 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0;
 var $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0;
 var $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0, $85 = 0;
 var $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $F18$0 = 0, $I20$0 = 0, $K21$0 = 0, $R$1 = 0, $R$1$lcssa = 0;
 var $R$3 = 0, $R8$1 = 0, $R8$1$lcssa = 0, $R8$3 = 0, $RP$1 = 0, $RP$1$lcssa = 0, $RP10$1 = 0, $RP10$1$lcssa = 0, $T$0 = 0, $T$0$lcssa = 0, $T$0$lcssa48 = 0, $cond20 = 0, $cond21 = 0, $not$ = 0, $p$1 = 0, $psize$1 = 0, $psize$2 = 0, $sp$0$i = 0, $sp$0$in$i = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $0 = ($mem|0)==(0|0);
 if ($0) {
  return;
 }
 $1 = ((($mem)) + -8|0);
 $2 = HEAP32[(6256)>>2]|0;
 $3 = $2 & 2;
 $4 = ($3|0)==(0);
 if (!($4)) {
  $5 = (_pthread_mutex_lock((6260))|0);
  $6 = ($5|0)==(0);
  if (!($6)) {
   return;
  }
 }
 $7 = HEAP32[(5828)>>2]|0;
 $8 = ($1>>>0)<($7>>>0);
 if ($8) {
  _abort();
  // unreachable;
 }
 $9 = ((($mem)) + -4|0);
 $10 = HEAP32[$9>>2]|0;
 $11 = $10 & 3;
 $12 = ($11|0)==(1);
 if ($12) {
  _abort();
  // unreachable;
 }
 $13 = $10 & -8;
 $14 = (($1) + ($13)|0);
 $15 = $10 & 1;
 $16 = ($15|0)==(0);
 do {
  if ($16) {
   $17 = HEAP32[$1>>2]|0;
   $18 = ($11|0)==(0);
   if (!($18)) {
    $19 = (0 - ($17))|0;
    $20 = (($1) + ($19)|0);
    $21 = (($17) + ($13))|0;
    $22 = ($20>>>0)<($7>>>0);
    if ($22) {
     _abort();
     // unreachable;
    }
    $23 = HEAP32[(5832)>>2]|0;
    $24 = ($20|0)==($23|0);
    if ($24) {
     $109 = ((($14)) + 4|0);
     $110 = HEAP32[$109>>2]|0;
     $111 = $110 & 3;
     $112 = ($111|0)==(3);
     if (!($112)) {
      $p$1 = $20;$psize$1 = $21;
      label = 58;
      break;
     }
     HEAP32[(5820)>>2] = $21;
     $113 = $110 & -2;
     HEAP32[$109>>2] = $113;
     $114 = $21 | 1;
     $115 = ((($20)) + 4|0);
     HEAP32[$115>>2] = $114;
     $116 = (($20) + ($21)|0);
     HEAP32[$116>>2] = $21;
     break;
    }
    $25 = $17 >>> 3;
    $26 = ($17>>>0)<(256);
    if ($26) {
     $27 = ((($20)) + 8|0);
     $28 = HEAP32[$27>>2]|0;
     $29 = ((($20)) + 12|0);
     $30 = HEAP32[$29>>2]|0;
     $31 = $25 << 1;
     $32 = (5852 + ($31<<2)|0);
     $33 = ($28|0)==($32|0);
     if (!($33)) {
      $34 = ($28>>>0)<($7>>>0);
      if ($34) {
       _abort();
       // unreachable;
      }
      $35 = ((($28)) + 12|0);
      $36 = HEAP32[$35>>2]|0;
      $37 = ($36|0)==($20|0);
      if (!($37)) {
       _abort();
       // unreachable;
      }
     }
     $38 = ($30|0)==($28|0);
     if ($38) {
      $39 = 1 << $25;
      $40 = $39 ^ -1;
      $41 = HEAP32[1453]|0;
      $42 = $41 & $40;
      HEAP32[1453] = $42;
      $p$1 = $20;$psize$1 = $21;
      label = 58;
      break;
     }
     $43 = ($30|0)==($32|0);
     if ($43) {
      $$pre42 = ((($30)) + 8|0);
      $$pre$phi43Z2D = $$pre42;
     } else {
      $44 = ($30>>>0)<($7>>>0);
      if ($44) {
       _abort();
       // unreachable;
      }
      $45 = ((($30)) + 8|0);
      $46 = HEAP32[$45>>2]|0;
      $47 = ($46|0)==($20|0);
      if ($47) {
       $$pre$phi43Z2D = $45;
      } else {
       _abort();
       // unreachable;
      }
     }
     $48 = ((($28)) + 12|0);
     HEAP32[$48>>2] = $30;
     HEAP32[$$pre$phi43Z2D>>2] = $28;
     $p$1 = $20;$psize$1 = $21;
     label = 58;
     break;
    }
    $49 = ((($20)) + 24|0);
    $50 = HEAP32[$49>>2]|0;
    $51 = ((($20)) + 12|0);
    $52 = HEAP32[$51>>2]|0;
    $53 = ($52|0)==($20|0);
    do {
     if ($53) {
      $63 = ((($20)) + 16|0);
      $64 = ((($63)) + 4|0);
      $65 = HEAP32[$64>>2]|0;
      $66 = ($65|0)==(0|0);
      if ($66) {
       $67 = HEAP32[$63>>2]|0;
       $68 = ($67|0)==(0|0);
       if ($68) {
        $R$3 = 0;
        break;
       } else {
        $R$1 = $67;$RP$1 = $63;
       }
      } else {
       $R$1 = $65;$RP$1 = $64;
      }
      while(1) {
       $69 = ((($R$1)) + 20|0);
       $70 = HEAP32[$69>>2]|0;
       $71 = ($70|0)==(0|0);
       if (!($71)) {
        $R$1 = $70;$RP$1 = $69;
        continue;
       }
       $72 = ((($R$1)) + 16|0);
       $73 = HEAP32[$72>>2]|0;
       $74 = ($73|0)==(0|0);
       if ($74) {
        $R$1$lcssa = $R$1;$RP$1$lcssa = $RP$1;
        break;
       } else {
        $R$1 = $73;$RP$1 = $72;
       }
      }
      $75 = ($RP$1$lcssa>>>0)<($7>>>0);
      if ($75) {
       _abort();
       // unreachable;
      } else {
       HEAP32[$RP$1$lcssa>>2] = 0;
       $R$3 = $R$1$lcssa;
       break;
      }
     } else {
      $54 = ((($20)) + 8|0);
      $55 = HEAP32[$54>>2]|0;
      $56 = ($55>>>0)<($7>>>0);
      if ($56) {
       _abort();
       // unreachable;
      }
      $57 = ((($55)) + 12|0);
      $58 = HEAP32[$57>>2]|0;
      $59 = ($58|0)==($20|0);
      if (!($59)) {
       _abort();
       // unreachable;
      }
      $60 = ((($52)) + 8|0);
      $61 = HEAP32[$60>>2]|0;
      $62 = ($61|0)==($20|0);
      if ($62) {
       HEAP32[$57>>2] = $52;
       HEAP32[$60>>2] = $55;
       $R$3 = $52;
       break;
      } else {
       _abort();
       // unreachable;
      }
     }
    } while(0);
    $76 = ($50|0)==(0|0);
    if ($76) {
     $p$1 = $20;$psize$1 = $21;
     label = 58;
    } else {
     $77 = ((($20)) + 28|0);
     $78 = HEAP32[$77>>2]|0;
     $79 = (6116 + ($78<<2)|0);
     $80 = HEAP32[$79>>2]|0;
     $81 = ($20|0)==($80|0);
     if ($81) {
      HEAP32[$79>>2] = $R$3;
      $cond20 = ($R$3|0)==(0|0);
      if ($cond20) {
       $82 = 1 << $78;
       $83 = $82 ^ -1;
       $84 = HEAP32[(5816)>>2]|0;
       $85 = $84 & $83;
       HEAP32[(5816)>>2] = $85;
       $p$1 = $20;$psize$1 = $21;
       label = 58;
       break;
      }
     } else {
      $86 = HEAP32[(5828)>>2]|0;
      $87 = ($50>>>0)<($86>>>0);
      if ($87) {
       _abort();
       // unreachable;
      }
      $88 = ((($50)) + 16|0);
      $89 = HEAP32[$88>>2]|0;
      $90 = ($89|0)==($20|0);
      if ($90) {
       HEAP32[$88>>2] = $R$3;
      } else {
       $91 = ((($50)) + 20|0);
       HEAP32[$91>>2] = $R$3;
      }
      $92 = ($R$3|0)==(0|0);
      if ($92) {
       $p$1 = $20;$psize$1 = $21;
       label = 58;
       break;
      }
     }
     $93 = HEAP32[(5828)>>2]|0;
     $94 = ($R$3>>>0)<($93>>>0);
     if ($94) {
      _abort();
      // unreachable;
     }
     $95 = ((($R$3)) + 24|0);
     HEAP32[$95>>2] = $50;
     $96 = ((($20)) + 16|0);
     $97 = HEAP32[$96>>2]|0;
     $98 = ($97|0)==(0|0);
     do {
      if (!($98)) {
       $99 = ($97>>>0)<($93>>>0);
       if ($99) {
        _abort();
        // unreachable;
       } else {
        $100 = ((($R$3)) + 16|0);
        HEAP32[$100>>2] = $97;
        $101 = ((($97)) + 24|0);
        HEAP32[$101>>2] = $R$3;
        break;
       }
      }
     } while(0);
     $102 = ((($96)) + 4|0);
     $103 = HEAP32[$102>>2]|0;
     $104 = ($103|0)==(0|0);
     if ($104) {
      $p$1 = $20;$psize$1 = $21;
      label = 58;
     } else {
      $105 = HEAP32[(5828)>>2]|0;
      $106 = ($103>>>0)<($105>>>0);
      if ($106) {
       _abort();
       // unreachable;
      } else {
       $107 = ((($R$3)) + 20|0);
       HEAP32[$107>>2] = $103;
       $108 = ((($103)) + 24|0);
       HEAP32[$108>>2] = $R$3;
       $p$1 = $20;$psize$1 = $21;
       label = 58;
       break;
      }
     }
    }
   }
  } else {
   $p$1 = $1;$psize$1 = $13;
   label = 58;
  }
 } while(0);
 do {
  if ((label|0) == 58) {
   $117 = ($p$1>>>0)<($14>>>0);
   if (!($117)) {
    _abort();
    // unreachable;
   }
   $118 = ((($14)) + 4|0);
   $119 = HEAP32[$118>>2]|0;
   $120 = $119 & 1;
   $121 = ($120|0)==(0);
   if ($121) {
    _abort();
    // unreachable;
   }
   $122 = $119 & 2;
   $123 = ($122|0)==(0);
   if ($123) {
    $124 = HEAP32[(5836)>>2]|0;
    $125 = ($14|0)==($124|0);
    if ($125) {
     $126 = HEAP32[(5824)>>2]|0;
     $127 = (($126) + ($psize$1))|0;
     HEAP32[(5824)>>2] = $127;
     HEAP32[(5836)>>2] = $p$1;
     $128 = $127 | 1;
     $129 = ((($p$1)) + 4|0);
     HEAP32[$129>>2] = $128;
     $130 = HEAP32[(5832)>>2]|0;
     $131 = ($p$1|0)==($130|0);
     if (!($131)) {
      break;
     }
     HEAP32[(5832)>>2] = 0;
     HEAP32[(5820)>>2] = 0;
     break;
    }
    $132 = HEAP32[(5832)>>2]|0;
    $133 = ($14|0)==($132|0);
    if ($133) {
     $134 = HEAP32[(5820)>>2]|0;
     $135 = (($134) + ($psize$1))|0;
     HEAP32[(5820)>>2] = $135;
     HEAP32[(5832)>>2] = $p$1;
     $136 = $135 | 1;
     $137 = ((($p$1)) + 4|0);
     HEAP32[$137>>2] = $136;
     $138 = (($p$1) + ($135)|0);
     HEAP32[$138>>2] = $135;
     break;
    }
    $139 = $119 & -8;
    $140 = (($139) + ($psize$1))|0;
    $141 = $119 >>> 3;
    $142 = ($119>>>0)<(256);
    do {
     if ($142) {
      $143 = ((($14)) + 8|0);
      $144 = HEAP32[$143>>2]|0;
      $145 = ((($14)) + 12|0);
      $146 = HEAP32[$145>>2]|0;
      $147 = $141 << 1;
      $148 = (5852 + ($147<<2)|0);
      $149 = ($144|0)==($148|0);
      if (!($149)) {
       $150 = HEAP32[(5828)>>2]|0;
       $151 = ($144>>>0)<($150>>>0);
       if ($151) {
        _abort();
        // unreachable;
       }
       $152 = ((($144)) + 12|0);
       $153 = HEAP32[$152>>2]|0;
       $154 = ($153|0)==($14|0);
       if (!($154)) {
        _abort();
        // unreachable;
       }
      }
      $155 = ($146|0)==($144|0);
      if ($155) {
       $156 = 1 << $141;
       $157 = $156 ^ -1;
       $158 = HEAP32[1453]|0;
       $159 = $158 & $157;
       HEAP32[1453] = $159;
       break;
      }
      $160 = ($146|0)==($148|0);
      if ($160) {
       $$pre40 = ((($146)) + 8|0);
       $$pre$phi41Z2D = $$pre40;
      } else {
       $161 = HEAP32[(5828)>>2]|0;
       $162 = ($146>>>0)<($161>>>0);
       if ($162) {
        _abort();
        // unreachable;
       }
       $163 = ((($146)) + 8|0);
       $164 = HEAP32[$163>>2]|0;
       $165 = ($164|0)==($14|0);
       if ($165) {
        $$pre$phi41Z2D = $163;
       } else {
        _abort();
        // unreachable;
       }
      }
      $166 = ((($144)) + 12|0);
      HEAP32[$166>>2] = $146;
      HEAP32[$$pre$phi41Z2D>>2] = $144;
     } else {
      $167 = ((($14)) + 24|0);
      $168 = HEAP32[$167>>2]|0;
      $169 = ((($14)) + 12|0);
      $170 = HEAP32[$169>>2]|0;
      $171 = ($170|0)==($14|0);
      do {
       if ($171) {
        $182 = ((($14)) + 16|0);
        $183 = ((($182)) + 4|0);
        $184 = HEAP32[$183>>2]|0;
        $185 = ($184|0)==(0|0);
        if ($185) {
         $186 = HEAP32[$182>>2]|0;
         $187 = ($186|0)==(0|0);
         if ($187) {
          $R8$3 = 0;
          break;
         } else {
          $R8$1 = $186;$RP10$1 = $182;
         }
        } else {
         $R8$1 = $184;$RP10$1 = $183;
        }
        while(1) {
         $188 = ((($R8$1)) + 20|0);
         $189 = HEAP32[$188>>2]|0;
         $190 = ($189|0)==(0|0);
         if (!($190)) {
          $R8$1 = $189;$RP10$1 = $188;
          continue;
         }
         $191 = ((($R8$1)) + 16|0);
         $192 = HEAP32[$191>>2]|0;
         $193 = ($192|0)==(0|0);
         if ($193) {
          $R8$1$lcssa = $R8$1;$RP10$1$lcssa = $RP10$1;
          break;
         } else {
          $R8$1 = $192;$RP10$1 = $191;
         }
        }
        $194 = HEAP32[(5828)>>2]|0;
        $195 = ($RP10$1$lcssa>>>0)<($194>>>0);
        if ($195) {
         _abort();
         // unreachable;
        } else {
         HEAP32[$RP10$1$lcssa>>2] = 0;
         $R8$3 = $R8$1$lcssa;
         break;
        }
       } else {
        $172 = ((($14)) + 8|0);
        $173 = HEAP32[$172>>2]|0;
        $174 = HEAP32[(5828)>>2]|0;
        $175 = ($173>>>0)<($174>>>0);
        if ($175) {
         _abort();
         // unreachable;
        }
        $176 = ((($173)) + 12|0);
        $177 = HEAP32[$176>>2]|0;
        $178 = ($177|0)==($14|0);
        if (!($178)) {
         _abort();
         // unreachable;
        }
        $179 = ((($170)) + 8|0);
        $180 = HEAP32[$179>>2]|0;
        $181 = ($180|0)==($14|0);
        if ($181) {
         HEAP32[$176>>2] = $170;
         HEAP32[$179>>2] = $173;
         $R8$3 = $170;
         break;
        } else {
         _abort();
         // unreachable;
        }
       }
      } while(0);
      $196 = ($168|0)==(0|0);
      if (!($196)) {
       $197 = ((($14)) + 28|0);
       $198 = HEAP32[$197>>2]|0;
       $199 = (6116 + ($198<<2)|0);
       $200 = HEAP32[$199>>2]|0;
       $201 = ($14|0)==($200|0);
       if ($201) {
        HEAP32[$199>>2] = $R8$3;
        $cond21 = ($R8$3|0)==(0|0);
        if ($cond21) {
         $202 = 1 << $198;
         $203 = $202 ^ -1;
         $204 = HEAP32[(5816)>>2]|0;
         $205 = $204 & $203;
         HEAP32[(5816)>>2] = $205;
         break;
        }
       } else {
        $206 = HEAP32[(5828)>>2]|0;
        $207 = ($168>>>0)<($206>>>0);
        if ($207) {
         _abort();
         // unreachable;
        }
        $208 = ((($168)) + 16|0);
        $209 = HEAP32[$208>>2]|0;
        $210 = ($209|0)==($14|0);
        if ($210) {
         HEAP32[$208>>2] = $R8$3;
        } else {
         $211 = ((($168)) + 20|0);
         HEAP32[$211>>2] = $R8$3;
        }
        $212 = ($R8$3|0)==(0|0);
        if ($212) {
         break;
        }
       }
       $213 = HEAP32[(5828)>>2]|0;
       $214 = ($R8$3>>>0)<($213>>>0);
       if ($214) {
        _abort();
        // unreachable;
       }
       $215 = ((($R8$3)) + 24|0);
       HEAP32[$215>>2] = $168;
       $216 = ((($14)) + 16|0);
       $217 = HEAP32[$216>>2]|0;
       $218 = ($217|0)==(0|0);
       do {
        if (!($218)) {
         $219 = ($217>>>0)<($213>>>0);
         if ($219) {
          _abort();
          // unreachable;
         } else {
          $220 = ((($R8$3)) + 16|0);
          HEAP32[$220>>2] = $217;
          $221 = ((($217)) + 24|0);
          HEAP32[$221>>2] = $R8$3;
          break;
         }
        }
       } while(0);
       $222 = ((($216)) + 4|0);
       $223 = HEAP32[$222>>2]|0;
       $224 = ($223|0)==(0|0);
       if (!($224)) {
        $225 = HEAP32[(5828)>>2]|0;
        $226 = ($223>>>0)<($225>>>0);
        if ($226) {
         _abort();
         // unreachable;
        } else {
         $227 = ((($R8$3)) + 20|0);
         HEAP32[$227>>2] = $223;
         $228 = ((($223)) + 24|0);
         HEAP32[$228>>2] = $R8$3;
         break;
        }
       }
      }
     }
    } while(0);
    $229 = $140 | 1;
    $230 = ((($p$1)) + 4|0);
    HEAP32[$230>>2] = $229;
    $231 = (($p$1) + ($140)|0);
    HEAP32[$231>>2] = $140;
    $232 = HEAP32[(5832)>>2]|0;
    $233 = ($p$1|0)==($232|0);
    if ($233) {
     HEAP32[(5820)>>2] = $140;
     break;
    } else {
     $psize$2 = $140;
    }
   } else {
    $234 = $119 & -2;
    HEAP32[$118>>2] = $234;
    $235 = $psize$1 | 1;
    $236 = ((($p$1)) + 4|0);
    HEAP32[$236>>2] = $235;
    $237 = (($p$1) + ($psize$1)|0);
    HEAP32[$237>>2] = $psize$1;
    $psize$2 = $psize$1;
   }
   $238 = $psize$2 >>> 3;
   $239 = ($psize$2>>>0)<(256);
   if ($239) {
    $240 = $238 << 1;
    $241 = (5852 + ($240<<2)|0);
    $242 = HEAP32[1453]|0;
    $243 = 1 << $238;
    $244 = $242 & $243;
    $245 = ($244|0)==(0);
    if ($245) {
     $246 = $242 | $243;
     HEAP32[1453] = $246;
     $$pre = ((($241)) + 8|0);
     $$pre$phiZ2D = $$pre;$F18$0 = $241;
    } else {
     $247 = ((($241)) + 8|0);
     $248 = HEAP32[$247>>2]|0;
     $249 = HEAP32[(5828)>>2]|0;
     $250 = ($248>>>0)<($249>>>0);
     if ($250) {
      _abort();
      // unreachable;
     } else {
      $$pre$phiZ2D = $247;$F18$0 = $248;
     }
    }
    HEAP32[$$pre$phiZ2D>>2] = $p$1;
    $251 = ((($F18$0)) + 12|0);
    HEAP32[$251>>2] = $p$1;
    $252 = ((($p$1)) + 8|0);
    HEAP32[$252>>2] = $F18$0;
    $253 = ((($p$1)) + 12|0);
    HEAP32[$253>>2] = $241;
    break;
   }
   $254 = $psize$2 >>> 8;
   $255 = ($254|0)==(0);
   if ($255) {
    $I20$0 = 0;
   } else {
    $256 = ($psize$2>>>0)>(16777215);
    if ($256) {
     $I20$0 = 31;
    } else {
     $257 = (($254) + 1048320)|0;
     $258 = $257 >>> 16;
     $259 = $258 & 8;
     $260 = $254 << $259;
     $261 = (($260) + 520192)|0;
     $262 = $261 >>> 16;
     $263 = $262 & 4;
     $264 = $263 | $259;
     $265 = $260 << $263;
     $266 = (($265) + 245760)|0;
     $267 = $266 >>> 16;
     $268 = $267 & 2;
     $269 = $264 | $268;
     $270 = (14 - ($269))|0;
     $271 = $265 << $268;
     $272 = $271 >>> 15;
     $273 = (($270) + ($272))|0;
     $274 = $273 << 1;
     $275 = (($273) + 7)|0;
     $276 = $psize$2 >>> $275;
     $277 = $276 & 1;
     $278 = $277 | $274;
     $I20$0 = $278;
    }
   }
   $279 = (6116 + ($I20$0<<2)|0);
   $280 = ((($p$1)) + 28|0);
   HEAP32[$280>>2] = $I20$0;
   $281 = ((($p$1)) + 16|0);
   $282 = ((($p$1)) + 20|0);
   HEAP32[$282>>2] = 0;
   HEAP32[$281>>2] = 0;
   $283 = HEAP32[(5816)>>2]|0;
   $284 = 1 << $I20$0;
   $285 = $283 & $284;
   $286 = ($285|0)==(0);
   do {
    if ($286) {
     $287 = $283 | $284;
     HEAP32[(5816)>>2] = $287;
     HEAP32[$279>>2] = $p$1;
     $288 = ((($p$1)) + 24|0);
     HEAP32[$288>>2] = $279;
     $289 = ((($p$1)) + 12|0);
     HEAP32[$289>>2] = $p$1;
     $290 = ((($p$1)) + 8|0);
     HEAP32[$290>>2] = $p$1;
    } else {
     $291 = HEAP32[$279>>2]|0;
     $292 = ($I20$0|0)==(31);
     $293 = $I20$0 >>> 1;
     $294 = (25 - ($293))|0;
     $295 = $292 ? 0 : $294;
     $296 = $psize$2 << $295;
     $K21$0 = $296;$T$0 = $291;
     while(1) {
      $297 = ((($T$0)) + 4|0);
      $298 = HEAP32[$297>>2]|0;
      $299 = $298 & -8;
      $300 = ($299|0)==($psize$2|0);
      if ($300) {
       $T$0$lcssa = $T$0;
       label = 132;
       break;
      }
      $301 = $K21$0 >>> 31;
      $302 = (((($T$0)) + 16|0) + ($301<<2)|0);
      $303 = $K21$0 << 1;
      $304 = HEAP32[$302>>2]|0;
      $305 = ($304|0)==(0|0);
      if ($305) {
       $$lcssa = $302;$T$0$lcssa48 = $T$0;
       label = 129;
       break;
      } else {
       $K21$0 = $303;$T$0 = $304;
      }
     }
     if ((label|0) == 129) {
      $306 = HEAP32[(5828)>>2]|0;
      $307 = ($$lcssa>>>0)<($306>>>0);
      if ($307) {
       _abort();
       // unreachable;
      } else {
       HEAP32[$$lcssa>>2] = $p$1;
       $308 = ((($p$1)) + 24|0);
       HEAP32[$308>>2] = $T$0$lcssa48;
       $309 = ((($p$1)) + 12|0);
       HEAP32[$309>>2] = $p$1;
       $310 = ((($p$1)) + 8|0);
       HEAP32[$310>>2] = $p$1;
       break;
      }
     }
     else if ((label|0) == 132) {
      $311 = ((($T$0$lcssa)) + 8|0);
      $312 = HEAP32[$311>>2]|0;
      $313 = HEAP32[(5828)>>2]|0;
      $314 = ($312>>>0)>=($313>>>0);
      $not$ = ($T$0$lcssa>>>0)>=($313>>>0);
      $315 = $314 & $not$;
      if ($315) {
       $316 = ((($312)) + 12|0);
       HEAP32[$316>>2] = $p$1;
       HEAP32[$311>>2] = $p$1;
       $317 = ((($p$1)) + 8|0);
       HEAP32[$317>>2] = $312;
       $318 = ((($p$1)) + 12|0);
       HEAP32[$318>>2] = $T$0$lcssa;
       $319 = ((($p$1)) + 24|0);
       HEAP32[$319>>2] = 0;
       break;
      } else {
       _abort();
       // unreachable;
      }
     }
    }
   } while(0);
   $320 = HEAP32[(5844)>>2]|0;
   $321 = (($320) + -1)|0;
   HEAP32[(5844)>>2] = $321;
   $322 = ($321|0)==(0);
   if ($322) {
    $sp$0$in$i = (6296);
    while(1) {
     $sp$0$i = HEAP32[$sp$0$in$i>>2]|0;
     $323 = ($sp$0$i|0)==(0|0);
     $324 = ((($sp$0$i)) + 8|0);
     if ($323) {
      break;
     } else {
      $sp$0$in$i = $324;
     }
    }
    HEAP32[(5844)>>2] = -1;
   }
  }
 } while(0);
 $325 = HEAP32[(6256)>>2]|0;
 $326 = $325 & 2;
 $327 = ($326|0)==(0);
 if ($327) {
  return;
 }
 (_pthread_mutex_unlock((6260))|0);
 return;
}
function runPostSets() {
}
function _i64Subtract(a, b, c, d) {
    a = a|0; b = b|0; c = c|0; d = d|0;
    var l = 0, h = 0;
    l = (a - c)>>>0;
    h = (b - d)>>>0;
    h = (b - d - (((c>>>0) > (a>>>0))|0))>>>0; // Borrow one from high word to low word on underflow.
    return ((tempRet0 = h,l|0)|0);
}
function _emscripten_set_current_thread_status(newStatus) {
    newStatus = newStatus|0;
}
function _memset(ptr, value, num) {
    ptr = ptr|0; value = value|0; num = num|0;
    var stop = 0, value4 = 0, stop4 = 0, unaligned = 0;
    stop = (ptr + num)|0;
    if ((num|0) >= 20) {
      // This is unaligned, but quite large, so work hard to get to aligned settings
      value = value & 0xff;
      unaligned = ptr & 3;
      value4 = value | (value << 8) | (value << 16) | (value << 24);
      stop4 = stop & ~3;
      if (unaligned) {
        unaligned = (ptr + 4 - unaligned)|0;
        while ((ptr|0) < (unaligned|0)) { // no need to check for stop, since we have large num
          HEAP8[((ptr)>>0)]=value;
          ptr = (ptr+1)|0;
        }
      }
      while ((ptr|0) < (stop4|0)) {
        HEAP32[((ptr)>>2)]=value4;
        ptr = (ptr+4)|0;
      }
    }
    while ((ptr|0) < (stop|0)) {
      HEAP8[((ptr)>>0)]=value;
      ptr = (ptr+1)|0;
    }
    return (ptr-num)|0;
}
function _i64Add(a, b, c, d) {
    /*
      x = a + b*2^32
      y = c + d*2^32
      result = l + h*2^32
    */
    a = a|0; b = b|0; c = c|0; d = d|0;
    var l = 0, h = 0;
    l = (a + c)>>>0;
    h = (b + d + (((l>>>0) < (a>>>0))|0))>>>0; // Add carry from low word to high word on overflow.
    return ((tempRet0 = h,l|0)|0);
}
function _bitshift64Lshr(low, high, bits) {
    low = low|0; high = high|0; bits = bits|0;
    var ander = 0;
    if ((bits|0) < 32) {
      ander = ((1 << bits) - 1)|0;
      tempRet0 = high >>> bits;
      return (low >>> bits) | ((high&ander) << (32 - bits));
    }
    tempRet0 = 0;
    return (high >>> (bits - 32))|0;
}
function _emscripten_conditional_set_current_thread_status(expectedStatus, newStatus) {
    expectedStatus = expectedStatus|0;
    newStatus = newStatus|0;
}
function _memcpy(dest, src, num) {
    dest = dest|0; src = src|0; num = num|0;
    var ret = 0;
    if ((num|0) >= 4096) return _emscripten_memcpy_big(dest|0, src|0, num|0)|0;
    ret = dest|0;
    if ((dest&3) == (src&3)) {
      while (dest & 3) {
        if ((num|0) == 0) return ret|0;
        HEAP8[((dest)>>0)]=((HEAP8[((src)>>0)])|0);
        dest = (dest+1)|0;
        src = (src+1)|0;
        num = (num-1)|0;
      }
      while ((num|0) >= 4) {
        HEAP32[((dest)>>2)]=((HEAP32[((src)>>2)])|0);
        dest = (dest+4)|0;
        src = (src+4)|0;
        num = (num-4)|0;
      }
    }
    while ((num|0) > 0) {
      HEAP8[((dest)>>0)]=((HEAP8[((src)>>0)])|0);
      dest = (dest+1)|0;
      src = (src+1)|0;
      num = (num-1)|0;
    }
    return ret|0;
}
function _llvm_cttz_i32(x) {
    x = x|0;
    var ret = 0;
    ret = ((HEAP8[(((cttz_i8)+(x & 0xff))>>0)])|0);
    if ((ret|0) < 8) return ret|0;
    ret = ((HEAP8[(((cttz_i8)+((x >> 8)&0xff))>>0)])|0);
    if ((ret|0) < 8) return (ret + 8)|0;
    ret = ((HEAP8[(((cttz_i8)+((x >> 16)&0xff))>>0)])|0);
    if ((ret|0) < 8) return (ret + 16)|0;
    return (((HEAP8[(((cttz_i8)+(x >>> 24))>>0)])|0) + 24)|0;
}
function ___udivmoddi4($a$0, $a$1, $b$0, $b$1, $rem) {
    $a$0 = $a$0 | 0;
    $a$1 = $a$1 | 0;
    $b$0 = $b$0 | 0;
    $b$1 = $b$1 | 0;
    $rem = $rem | 0;
    var $n_sroa_0_0_extract_trunc = 0, $n_sroa_1_4_extract_shift$0 = 0, $n_sroa_1_4_extract_trunc = 0, $d_sroa_0_0_extract_trunc = 0, $d_sroa_1_4_extract_shift$0 = 0, $d_sroa_1_4_extract_trunc = 0, $4 = 0, $17 = 0, $37 = 0, $49 = 0, $51 = 0, $57 = 0, $58 = 0, $66 = 0, $78 = 0, $86 = 0, $88 = 0, $89 = 0, $91 = 0, $92 = 0, $95 = 0, $105 = 0, $117 = 0, $119 = 0, $125 = 0, $126 = 0, $130 = 0, $q_sroa_1_1_ph = 0, $q_sroa_0_1_ph = 0, $r_sroa_1_1_ph = 0, $r_sroa_0_1_ph = 0, $sr_1_ph = 0, $d_sroa_0_0_insert_insert99$0 = 0, $d_sroa_0_0_insert_insert99$1 = 0, $137$0 = 0, $137$1 = 0, $carry_0203 = 0, $sr_1202 = 0, $r_sroa_0_1201 = 0, $r_sroa_1_1200 = 0, $q_sroa_0_1199 = 0, $q_sroa_1_1198 = 0, $147 = 0, $149 = 0, $r_sroa_0_0_insert_insert42$0 = 0, $r_sroa_0_0_insert_insert42$1 = 0, $150$1 = 0, $151$0 = 0, $152 = 0, $154$0 = 0, $r_sroa_0_0_extract_trunc = 0, $r_sroa_1_4_extract_trunc = 0, $155 = 0, $carry_0_lcssa$0 = 0, $carry_0_lcssa$1 = 0, $r_sroa_0_1_lcssa = 0, $r_sroa_1_1_lcssa = 0, $q_sroa_0_1_lcssa = 0, $q_sroa_1_1_lcssa = 0, $q_sroa_0_0_insert_ext75$0 = 0, $q_sroa_0_0_insert_ext75$1 = 0, $q_sroa_0_0_insert_insert77$1 = 0, $_0$0 = 0, $_0$1 = 0;
    $n_sroa_0_0_extract_trunc = $a$0;
    $n_sroa_1_4_extract_shift$0 = $a$1;
    $n_sroa_1_4_extract_trunc = $n_sroa_1_4_extract_shift$0;
    $d_sroa_0_0_extract_trunc = $b$0;
    $d_sroa_1_4_extract_shift$0 = $b$1;
    $d_sroa_1_4_extract_trunc = $d_sroa_1_4_extract_shift$0;
    if (($n_sroa_1_4_extract_trunc | 0) == 0) {
      $4 = ($rem | 0) != 0;
      if (($d_sroa_1_4_extract_trunc | 0) == 0) {
        if ($4) {
          HEAP32[$rem >> 2] = ($n_sroa_0_0_extract_trunc >>> 0) % ($d_sroa_0_0_extract_trunc >>> 0);
          HEAP32[$rem + 4 >> 2] = 0;
        }
        $_0$1 = 0;
        $_0$0 = ($n_sroa_0_0_extract_trunc >>> 0) / ($d_sroa_0_0_extract_trunc >>> 0) >>> 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      } else {
        if (!$4) {
          $_0$1 = 0;
          $_0$0 = 0;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
        HEAP32[$rem >> 2] = $a$0 & -1;
        HEAP32[$rem + 4 >> 2] = $a$1 & 0;
        $_0$1 = 0;
        $_0$0 = 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      }
    }
    $17 = ($d_sroa_1_4_extract_trunc | 0) == 0;
    do {
      if (($d_sroa_0_0_extract_trunc | 0) == 0) {
        if ($17) {
          if (($rem | 0) != 0) {
            HEAP32[$rem >> 2] = ($n_sroa_1_4_extract_trunc >>> 0) % ($d_sroa_0_0_extract_trunc >>> 0);
            HEAP32[$rem + 4 >> 2] = 0;
          }
          $_0$1 = 0;
          $_0$0 = ($n_sroa_1_4_extract_trunc >>> 0) / ($d_sroa_0_0_extract_trunc >>> 0) >>> 0;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
        if (($n_sroa_0_0_extract_trunc | 0) == 0) {
          if (($rem | 0) != 0) {
            HEAP32[$rem >> 2] = 0;
            HEAP32[$rem + 4 >> 2] = ($n_sroa_1_4_extract_trunc >>> 0) % ($d_sroa_1_4_extract_trunc >>> 0);
          }
          $_0$1 = 0;
          $_0$0 = ($n_sroa_1_4_extract_trunc >>> 0) / ($d_sroa_1_4_extract_trunc >>> 0) >>> 0;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
        $37 = $d_sroa_1_4_extract_trunc - 1 | 0;
        if (($37 & $d_sroa_1_4_extract_trunc | 0) == 0) {
          if (($rem | 0) != 0) {
            HEAP32[$rem >> 2] = 0 | $a$0 & -1;
            HEAP32[$rem + 4 >> 2] = $37 & $n_sroa_1_4_extract_trunc | $a$1 & 0;
          }
          $_0$1 = 0;
          $_0$0 = $n_sroa_1_4_extract_trunc >>> ((_llvm_cttz_i32($d_sroa_1_4_extract_trunc | 0) | 0) >>> 0);
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
        $49 = Math_clz32($d_sroa_1_4_extract_trunc | 0) | 0;
        $51 = $49 - (Math_clz32($n_sroa_1_4_extract_trunc | 0) | 0) | 0;
        if ($51 >>> 0 <= 30) {
          $57 = $51 + 1 | 0;
          $58 = 31 - $51 | 0;
          $sr_1_ph = $57;
          $r_sroa_0_1_ph = $n_sroa_1_4_extract_trunc << $58 | $n_sroa_0_0_extract_trunc >>> ($57 >>> 0);
          $r_sroa_1_1_ph = $n_sroa_1_4_extract_trunc >>> ($57 >>> 0);
          $q_sroa_0_1_ph = 0;
          $q_sroa_1_1_ph = $n_sroa_0_0_extract_trunc << $58;
          break;
        }
        if (($rem | 0) == 0) {
          $_0$1 = 0;
          $_0$0 = 0;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
        HEAP32[$rem >> 2] = 0 | $a$0 & -1;
        HEAP32[$rem + 4 >> 2] = $n_sroa_1_4_extract_shift$0 | $a$1 & 0;
        $_0$1 = 0;
        $_0$0 = 0;
        return (tempRet0 = $_0$1, $_0$0) | 0;
      } else {
        if (!$17) {
          $117 = Math_clz32($d_sroa_1_4_extract_trunc | 0) | 0;
          $119 = $117 - (Math_clz32($n_sroa_1_4_extract_trunc | 0) | 0) | 0;
          if ($119 >>> 0 <= 31) {
            $125 = $119 + 1 | 0;
            $126 = 31 - $119 | 0;
            $130 = $119 - 31 >> 31;
            $sr_1_ph = $125;
            $r_sroa_0_1_ph = $n_sroa_0_0_extract_trunc >>> ($125 >>> 0) & $130 | $n_sroa_1_4_extract_trunc << $126;
            $r_sroa_1_1_ph = $n_sroa_1_4_extract_trunc >>> ($125 >>> 0) & $130;
            $q_sroa_0_1_ph = 0;
            $q_sroa_1_1_ph = $n_sroa_0_0_extract_trunc << $126;
            break;
          }
          if (($rem | 0) == 0) {
            $_0$1 = 0;
            $_0$0 = 0;
            return (tempRet0 = $_0$1, $_0$0) | 0;
          }
          HEAP32[$rem >> 2] = 0 | $a$0 & -1;
          HEAP32[$rem + 4 >> 2] = $n_sroa_1_4_extract_shift$0 | $a$1 & 0;
          $_0$1 = 0;
          $_0$0 = 0;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
        $66 = $d_sroa_0_0_extract_trunc - 1 | 0;
        if (($66 & $d_sroa_0_0_extract_trunc | 0) != 0) {
          $86 = (Math_clz32($d_sroa_0_0_extract_trunc | 0) | 0) + 33 | 0;
          $88 = $86 - (Math_clz32($n_sroa_1_4_extract_trunc | 0) | 0) | 0;
          $89 = 64 - $88 | 0;
          $91 = 32 - $88 | 0;
          $92 = $91 >> 31;
          $95 = $88 - 32 | 0;
          $105 = $95 >> 31;
          $sr_1_ph = $88;
          $r_sroa_0_1_ph = $91 - 1 >> 31 & $n_sroa_1_4_extract_trunc >>> ($95 >>> 0) | ($n_sroa_1_4_extract_trunc << $91 | $n_sroa_0_0_extract_trunc >>> ($88 >>> 0)) & $105;
          $r_sroa_1_1_ph = $105 & $n_sroa_1_4_extract_trunc >>> ($88 >>> 0);
          $q_sroa_0_1_ph = $n_sroa_0_0_extract_trunc << $89 & $92;
          $q_sroa_1_1_ph = ($n_sroa_1_4_extract_trunc << $89 | $n_sroa_0_0_extract_trunc >>> ($95 >>> 0)) & $92 | $n_sroa_0_0_extract_trunc << $91 & $88 - 33 >> 31;
          break;
        }
        if (($rem | 0) != 0) {
          HEAP32[$rem >> 2] = $66 & $n_sroa_0_0_extract_trunc;
          HEAP32[$rem + 4 >> 2] = 0;
        }
        if (($d_sroa_0_0_extract_trunc | 0) == 1) {
          $_0$1 = $n_sroa_1_4_extract_shift$0 | $a$1 & 0;
          $_0$0 = 0 | $a$0 & -1;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        } else {
          $78 = _llvm_cttz_i32($d_sroa_0_0_extract_trunc | 0) | 0;
          $_0$1 = 0 | $n_sroa_1_4_extract_trunc >>> ($78 >>> 0);
          $_0$0 = $n_sroa_1_4_extract_trunc << 32 - $78 | $n_sroa_0_0_extract_trunc >>> ($78 >>> 0) | 0;
          return (tempRet0 = $_0$1, $_0$0) | 0;
        }
      }
    } while (0);
    if (($sr_1_ph | 0) == 0) {
      $q_sroa_1_1_lcssa = $q_sroa_1_1_ph;
      $q_sroa_0_1_lcssa = $q_sroa_0_1_ph;
      $r_sroa_1_1_lcssa = $r_sroa_1_1_ph;
      $r_sroa_0_1_lcssa = $r_sroa_0_1_ph;
      $carry_0_lcssa$1 = 0;
      $carry_0_lcssa$0 = 0;
    } else {
      $d_sroa_0_0_insert_insert99$0 = 0 | $b$0 & -1;
      $d_sroa_0_0_insert_insert99$1 = $d_sroa_1_4_extract_shift$0 | $b$1 & 0;
      $137$0 = _i64Add($d_sroa_0_0_insert_insert99$0 | 0, $d_sroa_0_0_insert_insert99$1 | 0, -1, -1) | 0;
      $137$1 = tempRet0;
      $q_sroa_1_1198 = $q_sroa_1_1_ph;
      $q_sroa_0_1199 = $q_sroa_0_1_ph;
      $r_sroa_1_1200 = $r_sroa_1_1_ph;
      $r_sroa_0_1201 = $r_sroa_0_1_ph;
      $sr_1202 = $sr_1_ph;
      $carry_0203 = 0;
      while (1) {
        $147 = $q_sroa_0_1199 >>> 31 | $q_sroa_1_1198 << 1;
        $149 = $carry_0203 | $q_sroa_0_1199 << 1;
        $r_sroa_0_0_insert_insert42$0 = 0 | ($r_sroa_0_1201 << 1 | $q_sroa_1_1198 >>> 31);
        $r_sroa_0_0_insert_insert42$1 = $r_sroa_0_1201 >>> 31 | $r_sroa_1_1200 << 1 | 0;
        _i64Subtract($137$0 | 0, $137$1 | 0, $r_sroa_0_0_insert_insert42$0 | 0, $r_sroa_0_0_insert_insert42$1 | 0) | 0;
        $150$1 = tempRet0;
        $151$0 = $150$1 >> 31 | (($150$1 | 0) < 0 ? -1 : 0) << 1;
        $152 = $151$0 & 1;
        $154$0 = _i64Subtract($r_sroa_0_0_insert_insert42$0 | 0, $r_sroa_0_0_insert_insert42$1 | 0, $151$0 & $d_sroa_0_0_insert_insert99$0 | 0, ((($150$1 | 0) < 0 ? -1 : 0) >> 31 | (($150$1 | 0) < 0 ? -1 : 0) << 1) & $d_sroa_0_0_insert_insert99$1 | 0) | 0;
        $r_sroa_0_0_extract_trunc = $154$0;
        $r_sroa_1_4_extract_trunc = tempRet0;
        $155 = $sr_1202 - 1 | 0;
        if (($155 | 0) == 0) {
          break;
        } else {
          $q_sroa_1_1198 = $147;
          $q_sroa_0_1199 = $149;
          $r_sroa_1_1200 = $r_sroa_1_4_extract_trunc;
          $r_sroa_0_1201 = $r_sroa_0_0_extract_trunc;
          $sr_1202 = $155;
          $carry_0203 = $152;
        }
      }
      $q_sroa_1_1_lcssa = $147;
      $q_sroa_0_1_lcssa = $149;
      $r_sroa_1_1_lcssa = $r_sroa_1_4_extract_trunc;
      $r_sroa_0_1_lcssa = $r_sroa_0_0_extract_trunc;
      $carry_0_lcssa$1 = 0;
      $carry_0_lcssa$0 = $152;
    }
    $q_sroa_0_0_insert_ext75$0 = $q_sroa_0_1_lcssa;
    $q_sroa_0_0_insert_ext75$1 = 0;
    $q_sroa_0_0_insert_insert77$1 = $q_sroa_1_1_lcssa | $q_sroa_0_0_insert_ext75$1;
    if (($rem | 0) != 0) {
      HEAP32[$rem >> 2] = 0 | $r_sroa_0_1_lcssa;
      HEAP32[$rem + 4 >> 2] = $r_sroa_1_1_lcssa | 0;
    }
    $_0$1 = (0 | $q_sroa_0_0_insert_ext75$0) >>> 31 | $q_sroa_0_0_insert_insert77$1 << 1 | ($q_sroa_0_0_insert_ext75$1 << 1 | $q_sroa_0_0_insert_ext75$0 >>> 31) & 0 | $carry_0_lcssa$1;
    $_0$0 = ($q_sroa_0_0_insert_ext75$0 << 1 | 0 >>> 31) & -2 | $carry_0_lcssa$0;
    return (tempRet0 = $_0$1, $_0$0) | 0;
}
function ___udivdi3($a$0, $a$1, $b$0, $b$1) {
    $a$0 = $a$0 | 0;
    $a$1 = $a$1 | 0;
    $b$0 = $b$0 | 0;
    $b$1 = $b$1 | 0;
    var $1$0 = 0;
    $1$0 = ___udivmoddi4($a$0, $a$1, $b$0, $b$1, 0) | 0;
    return $1$0 | 0;
}
function _bitshift64Shl(low, high, bits) {
    low = low|0; high = high|0; bits = bits|0;
    var ander = 0;
    if ((bits|0) < 32) {
      ander = ((1 << bits) - 1)|0;
      tempRet0 = (high << bits) | ((low&(ander << (32 - bits))) >>> (32 - bits));
      return low << bits;
    }
    tempRet0 = low << (bits - 32);
    return 0;
}
function ___uremdi3($a$0, $a$1, $b$0, $b$1) {
    $a$0 = $a$0 | 0;
    $a$1 = $a$1 | 0;
    $b$0 = $b$0 | 0;
    $b$1 = $b$1 | 0;
    var $rem = 0, __stackBase__ = 0;
    __stackBase__ = STACKTOP;
    STACKTOP = STACKTOP + 16 | 0;
    $rem = __stackBase__ | 0;
    ___udivmoddi4($a$0, $a$1, $b$0, $b$1, $rem) | 0;
    STACKTOP = __stackBase__;
    return (tempRet0 = HEAP32[$rem + 4 >> 2] | 0, HEAP32[$rem >> 2] | 0) | 0;
}

  
function dynCall_ii(index,a1) {
  index = index|0;
  a1=a1|0;
  return FUNCTION_TABLE_ii[index&7](a1|0)|0;
}


function dynCall_iiii(index,a1,a2,a3) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=a3|0;
  return FUNCTION_TABLE_iiii[index&7](a1|0,a2|0,a3|0)|0;
}


function dynCall_vi(index,a1) {
  index = index|0;
  a1=a1|0;
  FUNCTION_TABLE_vi[index&7](a1|0);
}

function b0(p0) {
 p0 = p0|0; nullFunc_ii(0);return 0;
}
function b1(p0,p1,p2) {
 p0 = p0|0;p1 = p1|0;p2 = p2|0; nullFunc_iiii(1);return 0;
}
function b2(p0) {
 p0 = p0|0; nullFunc_vi(2);
}

// EMSCRIPTEN_END_FUNCS
var FUNCTION_TABLE_ii = [b0,___stdio_close,b0,b0,b0,__Z10ThreadMainPv,b0,b0];
var FUNCTION_TABLE_iiii = [b1,b1,___stdout_write,___stdio_seek,_sn_write,b1,b1,___stdio_write];
var FUNCTION_TABLE_vi = [b2,b2,b2,b2,b2,b2,_cleanup_387,b2];

  return { _emscripten_sync_run_in_main_thread_3: _emscripten_sync_run_in_main_thread_3, _bitshift64Shl: _bitshift64Shl, _emscripten_atomic_load_f32: _emscripten_atomic_load_f32, _emscripten_atomic_xor_u64: _emscripten_atomic_xor_u64, _llvm_cttz_i32: _llvm_cttz_i32, _bitshift64Lshr: _bitshift64Lshr, _emscripten_atomic_and_u64: _emscripten_atomic_and_u64, _emscripten_sync_run_in_main_thread: _emscripten_sync_run_in_main_thread, _emscripten_sync_run_in_main_thread_4: _emscripten_sync_run_in_main_thread_4, _emscripten_sync_run_in_main_thread_5: _emscripten_sync_run_in_main_thread_5, _emscripten_sync_run_in_main_thread_6: _emscripten_sync_run_in_main_thread_6, _emscripten_sync_run_in_main_thread_7: _emscripten_sync_run_in_main_thread_7, _emscripten_sync_run_in_main_thread_0: _emscripten_sync_run_in_main_thread_0, _emscripten_sync_run_in_main_thread_1: _emscripten_sync_run_in_main_thread_1, _emscripten_sync_run_in_main_thread_2: _emscripten_sync_run_in_main_thread_2, __emscripten_atomic_fetch_and_sub_u64: __emscripten_atomic_fetch_and_sub_u64, _emscripten_atomic_exchange_u32: _emscripten_atomic_exchange_u32, _fflush: _fflush, _emscripten_set_current_thread_status: _emscripten_set_current_thread_status, _emscripten_atomic_cas_u64: _emscripten_atomic_cas_u64, _memset: _memset, _emscripten_atomic_sub_u64: _emscripten_atomic_sub_u64, _emscripten_sync_run_in_main_thread_xprintf_varargs: _emscripten_sync_run_in_main_thread_xprintf_varargs, _i64Subtract: _i64Subtract, __emscripten_atomic_fetch_and_and_u64: __emscripten_atomic_fetch_and_and_u64, _emscripten_atomic_load_u64: _emscripten_atomic_load_u64, _emscripten_atomic_store_f64: _emscripten_atomic_store_f64, __emscripten_atomic_fetch_and_xor_u64: __emscripten_atomic_fetch_and_xor_u64, ___udivmoddi4: ___udivmoddi4, _i64Add: _i64Add, _emscripten_atomic_store_u64: _emscripten_atomic_store_u64, _emscripten_atomic_load_f64: _emscripten_atomic_load_f64, __emscripten_atomic_fetch_and_add_u64: __emscripten_atomic_fetch_and_add_u64, __emscripten_atomic_fetch_and_or_u64: __emscripten_atomic_fetch_and_or_u64, ___udivdi3: ___udivdi3, ___errno_location: ___errno_location, _main: _main, _emscripten_main_thread_process_queued_calls: _emscripten_main_thread_process_queued_calls, _emscripten_atomic_add_u64: _emscripten_atomic_add_u64, _free: _free, _emscripten_atomic_store_f32: _emscripten_atomic_store_f32, _emscripten_atomic_exchange_u64: _emscripten_atomic_exchange_u64, ___uremdi3: ___uremdi3, ___pthread_tsd_run_dtors: ___pthread_tsd_run_dtors, _malloc: _malloc, _memcpy: _memcpy, _emscripten_conditional_set_current_thread_status: _emscripten_conditional_set_current_thread_status, _emscripten_atomic_or_u64: _emscripten_atomic_or_u64, runPostSets: runPostSets, stackAlloc: stackAlloc, stackSave: stackSave, stackRestore: stackRestore, establishStackSpace: establishStackSpace, setThrew: setThrew, setTempRet0: setTempRet0, getTempRet0: getTempRet0, dynCall_ii: dynCall_ii, dynCall_iiii: dynCall_iiii, dynCall_vi: dynCall_vi };
})
;